// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/COR_net/src/CORNET_dns_impl.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// Implementation of A0::Client over CORBA
// $Id: CORNET_dns_impl.h,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// ==========================================================================
#ifndef __CORNET_DNS_IMPL_H_
#define __CORNET_DNS_IMPL_H_

#include <CORNET_network.h>
#include <CORNET_servers.h>
#include <vector>

namespace CORNET {

class DNS_impl : virtual public POA_INUKCORBA::DNS,
                    virtual public PortableServer::RefCountServantBase
{
  DNS_impl(const DNS_impl&);
  void operator=(const DNS_impl&);

  friend class Network;
  PortableServer::POA_var _poa;
  CORBA::ORB_var          _orb;
  
public:

  // initialize a server with a rank 'self' on count server
  DNS_impl( PortableServer::POA_ptr, CORBA::ORB_ptr );
  ~DNS_impl();

  virtual PortableServer::POA_ptr _default_POA();

  CORBA::ORB_ptr _the_ORB();

  //
  // IDL:Corba/Server/get_server:1.0
  //
  INUKCORBA::ListServers* get_servers()
      throw(CORBA::SystemException);

  //
  // IDL:Corba/Server/get_server:1.0
  //
  INUKCORBA::Server_ptr get_server(CORBA::Long rank)
      throw(CORBA::SystemException);

  //
  // IDL:Corba/Server/add_server:1.0
  //
  CORBA::Long add_server( INUKCORBA::Server_ptr s )
      throw(CORBA::SystemException);

protected:
  PTH::Mutex                          _access;       // - to lock the server 
  std::vector<bool>                  _is_defined;
  std::vector<INUKCORBA::Server_var> _all_servers;
};


} // End of namespace InukCorba

#endif
