// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/COR_net/src/CORNET_servers_impl.cpp,v $
// Copyright(c)'2001 by Apache Team
// acom_corba.idl : 
// Author: Thierry Gautier
// $Id: CORNET_servers_impl.cpp,v 1.4 2003/07/28 20:21:19 thierry Exp $
// ==========================================================================

#include <CORBA.h>
#include <CORNET_servers_impl.h>
#include <string>
#include <fstream>


//#define CORNET_TRACE_CALL

namespace CORNET {

// --------------------------------------------------------------------------
// Constructor
//
Server_impl::Server_impl(
  CORNET_net* net, 
  PortableServer::POA_ptr poa, CORBA::ORB_ptr orb
)
  : _poa (PortableServer::POA::_duplicate(poa) ),
    _orb (CORBA::ORB::_duplicate(orb) ),
    _net(net)
{
}

Server_impl::~Server_impl()
{
}

PortableServer::POA_ptr Server_impl::_default_POA()
{
  return PortableServer::POA::_duplicate(_poa);
}

CORBA::ORB_ptr Server_impl::_the_ORB()
{
  return CORBA::ORB::_duplicate(_orb);
}


// --------------------------------------------------------------------------
//
// IDL:InukCorba/Server/new_server:1.0
//
void Server_impl::signal_server( CORBA::Long rank, INUKCORBA::Server_ptr s)
      throw(CORBA::SystemException)
{
#ifdef CORNET_TRACE_CALL
  std::cout << "In : " << __PRETTY_FUNCTION__ << std::endl;
#endif
  _net->join_group( rank, s );
#ifdef CORNET_TRACE_CALL
  std::cout << "Out : " << __PRETTY_FUNCTION__ << std::endl;
#endif
}


// --------------------------------------------------------------------------
//
// IDL:InukCorba/Server/cget_dns:1.0
//
INUKCORBA::DNS_ptr Server_impl::get_dns( )
      throw(CORBA::SystemException)
{
#ifdef CORNET_TRACE_CALL
  std::cout << "In/Out : " << __PRETTY_FUNCTION__ << std::endl;
  std::cout << "Return DNS object, IOR=  " << _orb->object_to_string( _net->_dns_servant ) << std::endl;
#endif
  return INUKCORBA::DNS::_duplicate(_net->_dns_servant);
}


// --------------------------------------------------------------------------
//
// IDL:Corba/Server/deactivate:1.0
// 
void Server_impl::deactivate() throw(CORBA::SystemException)
{
	_orb->shutdown(false);
}


} // -namespace

