// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/COR_net/src/CORNET_servers_impl.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// Implementation of A0::Client over CORBA
// $Id: CORNET_servers_impl.h,v 1.2 2003/07/15 17:51:58 thierry Exp $
//
// ==========================================================================
#ifndef __CORNET_IMPL_H_
#define __CORNET_IMPL_H_

#include <CORNET_network.h>
#include <CORNET_servers.h>
#if defined(CORBA_USE_OBE) || defined(CORBA_USE_OB)
#include <CORNET_servers_skel.h>
#endif
#if defined(CORBA_USE_OMNIORB) 
#include <CORNET_servers.h>
#endif
#include <vector>

namespace CORNET {

class Server_impl : virtual public POA_INUKCORBA::Server,
                    virtual public PortableServer::RefCountServantBase
{
  Server_impl(const Server_impl&);
  void operator=(const Server_impl&);

  friend class CORNET_net;
  PortableServer::POA_var _poa;
  CORBA::ORB_var          _orb;
  
public:

  // initialize a server with a racomk 'self' on count server
  Server_impl( CORNET_net* net, PortableServer::POA_ptr, CORBA::ORB_ptr );
  ~Server_impl();

  virtual PortableServer::POA_ptr _default_POA();

  CORBA::ORB_ptr _the_ORB();

  //
  // IDL:Corba/Server/doIt:1.0
  //
  void doIt( const INUKCORBA::CIOVector& iiov, const INUKCORBA::CIOVector& diov )
      throw(CORBA::SystemException);

  //
  // IDL:Corba/Server/init_broadcast_all_servers:1.0
  //
  void signal_server(CORBA::Long racomk, INUKCORBA::Server_ptr a)
      throw(CORBA::SystemException);

  //
  // IDL:Corba/Server/get_dns:1.0
  // 
  INUKCORBA::DNS_ptr get_dns()
      throw(CORBA::SystemException);

  //
  // IDL:Corba/Server/deactivate:1.0
  // 
  void deactivate()
      throw(CORBA::SystemException);

protected:
  CORNET_net*  _net;          // - the network
};


} // End of namespace InukCorba

#endif
