// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_ack.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// Implementation of ack service
// $Id: ics_ack.h,v 1.5 2003/07/07 17:44:26 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_ACK_H_
#define _INUK_ACK_H_
#include <acom>
#include <ics_conf.h>
#include <ics_lighthashmap.h>
#include <ext/hash_map>


namespace ICS {

/* 
 * Bcast service for inuktitut
 */
class AckService: public ACOM::ServiceAM {

public:
  /** */
  AckService()
  { }

  /** */
  ~AckService();

  /** */
  void initialize( ACOM::Network* net );

  /** */
  void wait( long key, long count );

  /** */
  void signal( int tonode, long key );

protected:

  /** Context for one communication
   */
  struct ack_com_context {
    ack_com_context( )
     : is_wait(false), recv(0), count(0) {}
    bool   is_wait; 
    long   recv; 
    long   count; 
  };


  /** header of the message */
  struct Header {
    int key;
  };

  /* appele apres que le message soit arrive 
   */
  void call (
       ACOM::ComFailure::Code e,      // if any 
       ACOM::Network::Receipt* r, 
       ACOM::Network::Header* h,
       ACOM::IOVectEntry* iov,
       ACOM::IOVectSize   iov_sz,
       void* cc
  ) throw (ACOM::ComFailure);


  /** The network on which communications occur
   */
  ACOM::Network* _net;

  /** Mutex  to lock access to internal data structure
   */
  PTH::Mutex     _access;
  PTH::Condition _cond;


  /** map[key] -> context de communication
   */
  typedef LHashMap<long,ack_com_context*> Trigger_set;
  //typedef __gnu_cxx::hash_map<long,ack_com_context*> Trigger_set;
  Trigger_set _postrecv; /* list of all posted or received request for ack */
};


}

#endif
