// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_barrier.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// Implementation of barrier as a service
// $Id: ics_barrier.cpp,v 1.3 2003/07/07 08:58:45 thierry Exp $
//
// ==========================================================================
#include <ics_barrier.h>
#include <iostream>

namespace ICS {

// -----------------------------------------------------------------------------
  /** */
BarrierService::BarrierService()
{
}



// -----------------------------------------------------------------------------
  /** */
BarrierService::~BarrierService()
{
}



// -----------------------------------------------------------------------------
/* */
void BarrierService::initialize( ACOM::Network* net )
{ 
  _net = net;
  _access.init(); _cond.init(); 
}



// -----------------------------------------------------------------------------
/* Called when message arrived 
 */
void BarrierService::call ( 
     ACOM::ComFailure::Code e,      // if any 
     ACOM::Network::Receipt* r,
     ACOM::Network::Header* header,
     ACOM::IOVectEntry* iov,
     ACOM::IOVectSize   iov_sz,
     void* cc
) throw (ACOM::ComFailure)
{
#if 0
  std::cout << "In call" << std::endl;
#endif
  if (e != ACOM::ComFailure::OK) {
    std::cerr << "Error in msg='" //<< e.what(); // ACOM::ComFailure::what(e) 
              << "', #iov" << iov_sz  << ", len[0]" << (iov_sz > 0 ? iov[0].len : 0)
              << std::endl;
    ACOM::throwit( ACOM::ComFailure(e) );
  }

  int key;
  r->unpack(&key, sizeof(int));

  /* find tag in _postrecv */
  PTH::CriticalGuard cg(_access); // - begin critical section
  bar_com_context* ctxt =0;
  Trigger_set::iterator curr = _postrecv.find(key);

  if (curr == 0)
  {
    ctxt  = new bar_com_context;
    curr = _postrecv.insert( key, ctxt );
  } else {
    ctxt = curr->second;
  }
  if (++ctxt->recv == ctxt->count) 
  {
    if (ctxt->is_wait) 
      _cond.broadcast();
  }
}

}


