// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_barrier.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// Implementation of barrier as a service
// $Id: ics_barrier.h,v 1.3 2003/07/07 08:58:45 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_BARRIER_H_
#define _INUK_BARRIER_H_
#include <acom>
#include <ics_conf.h>
#include <ics_lighthashmap.h>

namespace ICS {

/* 
 * Bcast service for inuktitut
 */
class BarrierService: public ACOM::ServiceAM {

public:
  /** */
  BarrierService();

  /** */
  virtual ~BarrierService();

  /** */
  void initialize( ACOM::Network* net );

  /** */
  virtual void barrier( int key ) =0;

protected:

  /** Context for one communication
   */
  struct bar_com_context {
    bar_com_context( )
     : is_wait(false), recv(0), count(0) {}
    bool   is_wait; 
    long   recv;   /* number of messages received */
    long   count;  /* number of messages to be received */
  };


  /* appele apres que le message soit arrive 
   */
  void call (
       ACOM::ComFailure::Code e,      // if any 
       ACOM::Network::Receipt* r, 
       ACOM::Network::Header* h,
       ACOM::IOVectEntry* iov,
       ACOM::IOVectSize   iov_sz,
       void* cc
  ) throw (ACOM::ComFailure);


  /** The network on which communications occur
   */
  ACOM::Network* _net;

  /** Mutex  to lock access to internal data structure
   */
  PTH::Mutex     _access;
  PTH::Condition _cond;

  /** map[key] -> context de communication
   */
  typedef LHashMap<long, bar_com_context*> Trigger_set;
  Trigger_set _postrecv; /* list of all posted or received request for barrier */
};


}

#endif
