// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_bcast_alphatree.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of bcast using binomial algorithm
// $Id: ics_bcast_alphatree.h,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// ==========================================================================
#ifndef _INUK_BCAST_ALPHATREE_H_
#define _INUK_BCAST_ALPHATREE_H_
#include <ics_bcast.h>
#include <ics_bcast_one_2_all.h>

namespace ICS {
 
/* 
 * Bcast service for inuktitut using alpha tree.
 */
class BcastAlphaTree : public BcastService {
public:
  /** */
  BcastAlphaTree( double alpha =0.5 );

  void set_alpha( double a )
  { _alpha = a; }

  double get_alpha( ) const
  { return _alpha; }

  /** */
  handler post_bcast(
    void*&                     buffer, 
    size_t&                    count,
    const ACOM::Format*        fmt,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_src, 
    int                        tag
  );

  /** */
  void wait_bcast(
    handler wc
  );

  /** */
  void async_bcast(
    void*&                     buffer, 
    size_t&                    count,
    const ACOM::Format*        fmt,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_src, 
    int                        tag,
    void                       (*cb_func)(void*, void*),
    void*                      cb_arg1,
    void*                      cb_arg2
  );

protected:
  double _alpha;
  
  /** For async bcast
  */
  static void continuation( void* a1, void* a2 );
};

}

#endif
