// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_bcast_chain.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of flat bcast
// $Id: ics_bcast_chain.h,v 1.1 2003/05/27 20:43:27 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_BCAST_CHAIN_H_
#define _INUK_BCAST_CHAIN_H_
#include <ics_bcast.h>

namespace ICS {

/* 
 * Bcast service for inuktitut
 */
class BcastChain : public BcastService {
public:
  /** */
  BcastChain();

  /** */
  handler post_bcast(
    void*&                     buffer, 
    size_t&                    count,
    const ACOM::Format*        fmt,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_src, 
    int                        tag
  );

  /** */
  void wait_bcast(
    handler wc
  );

  /** */
  void async_bcast(
    void*&                     buffer, 
    size_t&                    count,
    const ACOM::Format*        fmt,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_src, 
    int                        tag,
    void                       (*cb_func)(void*, void*),
    void*                      cb_arg1,
    void*                      cb_arg2
  );

protected:
  static void continuation( void* a1, void* a2 );
};

}

#endif
