// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_bcast_compose.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of flat bcast
// $Id: ics_bcast_compose.h,v 1.1 2003/05/27 21:33:54 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_BCAST_COMPOSE_H_
#define _INUK_BCAST_COMPOSE_H_
#include <ics_bcast.h>

namespace ICS {

/* 
 * Bcast service for inuktitut
 */
class BcastCompose : public BcastService {
public:

  /** */
  BcastCompose();

  void attach_services( BcastService* s1, BcastService* s2 )
  { _s1 = s1; _s2 = s2; }

  void attach_service1( BcastService* s1 )
  { _s1 = s1; }

  void attach_service2( BcastService* s2 )
  { _s2 = s2; }

  void set_groupsize( int a )
  { _length = a; }

  int get_groupsize( ) const
  { return _length; }

  /** */
  handler post_bcast(
    void*&                     buffer, 
    size_t&                    count,
    const ACOM::Format*        fmt,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_src, 
    int                        tag
  );

  /** */
  void wait_bcast(
    handler wc
  );

  /** */
  void async_bcast(
    void*&                     buffer, 
    size_t&                    count,
    const ACOM::Format*        fmt,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_src, 
    int                        tag,
    void                       (*cb_func)(void*, void*),
    void*                      cb_arg1,
    void*                      cb_arg2
  );

protected:
  BcastService* _s1;   
  BcastService* _s2;   
  int           _length;

  static void continuation( void* a1, void* a2 );
};

} // namespace

#endif
