// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_bcast_pipeline1.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of bcast using pipeline algorithm
// $Id: ics_bcast_pipeline1.h,v 1.2 2003/07/15 17:22:44 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_BCAST_PIPELINE1_H_
#define _INUK_BCAST_PIPELINE1_H_
#include <ics_bcast.h>

namespace ICS {

/* 
 * Bcast service for inuktitut
 */
class BcastPipeline1 : public BcastService {
public:
  /** */
  BcastPipeline1( size_t sz_bloc = 16384 )
   : _szbloc(sz_bloc)
  { }

  /** */
  void initialize( ACOM::Network* net );

  /** Set bloc size for packet */
  void set_blocsize( size_t sb )
  { _szbloc = sb; }

  /** */
  handler post_bcast(
    void*&                     buffer, 
    size_t&                    count,
    const ACOM::Format*        fmt,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_src, 
    int                        tag
  );

  /** */
  void wait_bcast(
    handler wc
  );

  /** */
  void async_bcast(
    void*&                     buffer, 
    size_t&                    count,
    const ACOM::Format*        fmt,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_src, 
    int                        tag,
    void                       (*cb_func)(void*, void*),
    void*                      cb_arg1,
    void*                      cb_arg2
  );

protected:
  /** */
  void send_iov ( ACOM::Network::OutChannel* ch, int& serial, int tag, 
                  ACOM::IOVectEntry* iov, size_t iovsz );
  
  /** */
  void postrecv_iov ( int& serial, int tag, 
                      ACOM::IOVectEntry* iov, size_t iovsz );
  
  /** */
  com_context* wait_iov ( int serial, int tag );

  /* decodage de l'address pour stocker le message
   */
  void* get_iovect(
    ACOM::Network::Receipt* r,
    ACOM::Network::Header* header, 
    ACOM::IOVectEntry* vector, 
    ACOM::IOVectSize count
  );
protected:
  /** thread that manage communication (resend)
  */
  PTH::Thread _thread;
  
  /** bytes size of a packet
   */
  size_t _szbloc;

  /** iovect entries in a cell
   */
  static const int _nb_entries= 64;

  /** size of cached free blocks
   */
  static const int _iovect_threshold=16;

  /** iovec allocator
   */
  ACOM::IOVectCellAllocator _iovA;
};

}

#endif
