// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_bcastnet_alpha.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of virtual base class for all bcast algorithms
// Please read node in .cpp file.
// $Id: ics_bcastnet_alpha.h,v 1.7 2003/07/28 08:05:41 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_BCASTALPHA_NETWORK_H_
#define _INUK_BCASTALPHA_NETWORK_H_
#include <acom>
#include <ics_bcast_network.h>


namespace ICS {

// -----------------------------------------------------------------------------
/** BcastAlphaNetwork implement a flat tree algorithm for broadcast
 */
class BcastAlphaNetwork: public BcastNetwork {
public:
  // --------------------------------------------------------------------------
  /** Constructor
  */
  BcastAlphaNetwork();

  /** Destructor
  */
  ~BcastAlphaNetwork();

  /** Set name to the network as : balpha_<network name>
  */
  int initialize( int* argc, char** argv[], ACOM::Network* netInit ) 
    throw (ACOM::NetworkError);

  // ---------------------------------------------------------------------------
  /** extended classes for broadcast purpose using alpha tree
  */
  class OutChannel: public BcastNetwork::OutChannel {
  public:
    OutChannel();

    void set_alpha( double a )
    { _alpha = a; }
  
    double get_alpha( ) const
    { return _alpha; }

  protected:
    double _alpha;    /* alpha value */
    friend class BcastAlphaNetwork;
  };

  // ---------------------------------------------------------------------------
	BcastNetwork::OutChannel* open_channel
    ( int tag, int count_peer, LocalNodeNo* peers, int index_self )
       throw(ACOM::ComFailure);

  /** called to post or to process incomming message 
  */
  void process( ACOM::Network::OutChannel* ch, ACOM::Network::CallContext* call_cc, ACOM::Network::Request* r)
    throw (ACOM::ComFailure);

private:
  friend class OutChannel;
};
 


/*
 * inline definitions
 */
 
}

#endif
