// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_bcastnet_flat.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of virtual base class for all bcast algorithms
// Please read node in .cpp file.
// $Id: ics_bcastnet_flat.cpp,v 1.7 2003/07/30 12:56:46 thierry Exp $
//
// ==========================================================================
#include <ics_bcastnet_flat.h>

namespace ICS {

// --------------------------------------------------------------------------
/** Constructor
*/
BcastFlatNetwork::BcastFlatNetwork()
  : BcastNetwork()
{
  /* Change properties */
  set_property("primary",  "false");
  set_property("secondary","true");
  set_name("");
}

// --------------------------------------------------------------------------
/** Destructor
*/
BcastFlatNetwork::~BcastFlatNetwork()
{
}



// ---------------------------------------------------------------------------
int BcastFlatNetwork::initialize( int* argc, char** argv[], ACOM::Network* netInit ) 
  throw (ACOM::NetworkError)
{
  set_name("bflat_" + netInit->get_name() );
  return Network::initialize( argc, argv, netInit );
}  



// ---------------------------------------------------------------------------
BcastNetwork::OutChannel* BcastFlatNetwork::open_channel
  ( int tag, int count_peer, LocalNodeNo* peers, int index_self )
      throw(ACOM::ComFailure)
{
  BcastFlatNetwork::OutChannel* ch = new BcastFlatNetwork::OutChannel;
  ch->init( this, tag, count_peer, peers, index_self );
  return ch;
}      


// ---------------------------------------------------------------------------
void BcastFlatNetwork::process( ACOM::Network::OutChannel* c, ACOM::Network::CallContext* call_cc, ACOM::Network::Request* req )
  throw (ACOM::ComFailure)
{
  ACOM_ASSERT_DEBUG( call_cc ==0, "bad assertion");
  ACOM_ASSERT_DEBUG( c->get_net() ==this, "bad assertion");

  BcastFlatNetwork::OutChannel* ch = (BcastFlatNetwork::OutChannel*)c;
  
  /* Add _count_peers-2 use of the request : 1 is already counted by the user, and send it N-1 times */
  req->_used_ct += ch->_count_peers - 2;
#if 0
  std::cout << "@req=" << (long)req 
            << ", ch#peers= " << ch->_count_peers
            << ", used_ct= " << req->_used_ct << std::endl;
#endif
  
  for (int i=0; i< ch->_count_peers; ++i) 
  {
    if (i != ch->_index_self) {
#if 1
      std::cout << "[ICS]: Send mesg to " << ch->_peers[i] << std::endl;
#endif
      ACOM::Network::OutChannel* channel = get_subnet()->get_default_route(ch->_peers[i]);
      channel->post( req );
    }
  }
#if 1
  std::cout << "[ICS]: End Send mesg " << std::endl;
#endif
}

 
}

