// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_bcastnet_flat.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of virtual base class for all bcast algorithms
// Please read node in .cpp file.
// $Id: ics_bcastnet_flat.h,v 1.2 2003/07/28 08:05:40 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_BCASTFLAT_NETWORK_H_
#define _INUK_BCASTFLAT_NETWORK_H_
#include <acom>
#include <ics_bcast_network.h>

namespace ICS {

// -----------------------------------------------------------------------------
/** BcastFlatNetwork implement a flat tree algorithm for broadcast
 */
class BcastFlatNetwork: public BcastNetwork {
public:
  // --------------------------------------------------------------------------
  /** Constructor
  */
  BcastFlatNetwork();

  /** Destructor
  */
  ~BcastFlatNetwork();

  /** Set name to the network as : bflat_<network name>
  */
  int initialize( int* argc, char** argv[], ACOM::Network* netInit ) 
    throw (ACOM::NetworkError);

  // ---------------------------------------------------------------------------
  /** extended classes for broadcast purpose.
  */
  typedef BcastNetwork::OutChannel OutChannel;


  // ---------------------------------------------------------------------------
	BcastNetwork::OutChannel* open_channel
    ( int tag, int count_peer, LocalNodeNo* peers, int index_self )
       throw(ACOM::ComFailure);

  /** called to process incomming message 
  */
  void process( ACOM::Network::OutChannel* ch, ACOM::Network::CallContext* call_cc, ACOM::Network::Request* r)
    throw (ACOM::ComFailure);

private:
  friend class OutChannel;
};
 


/*
 * inline definitions
 */
 
}

#endif
