// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_redops.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Definition of reduction operation
// $Id: ics_redops.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// ==========================================================================
#include <ics_redops.h>


namespace ICS {

// -------------------------------------------------------------------------
const CumulOperatorFormat& CumulOperatorFormat::Null = (CumulOperatorFormat&)ACOM::FormatDef::Null;



// -------------------------------------------------------------------------
void CumulOperatorFormat::default_fnc1
  ( void* dest, const ACOM::Format* fmt, const void* val ) const
{ (this->*_cumulfncN)( dest, fmt, val, 1); }
  


// -------------------------------------------------------------------------
void CumulOperatorFormat::default_fncN
  ( void* dest, const ACOM::Format* fmt, const void* val, size_t count ) const
{ 
  char* beg_dest = (char*)dest;
  char* beg_val  = (char*)val;
  for (size_t i=0; i<count; ++i) {
    (this->*_cumulfnc1)( beg_dest, fmt, beg_val); 
    beg_dest += fmt->get_size();
    beg_val += fmt->get_size();
  }
}


// -------------------------------------------------------------------------
CumulOperatorFormat::CumulOperatorFormat( )
 : ACOM::Format( 0,
           0, // write 
           0, // read 
           0, // alloc 
           0, // dealloc 
           0, // cstor 
           0, // dstor 
           0, // create 
           0, // destroy 
           0  // copy 
   ),
   _cumulfnc1(&CumulOperatorFormat::default_fnc1), _cumulfncN(&CumulOperatorFormat::default_fncN)
{
}



// -------------------------------------------------------------------------
CumulOperatorFormat::CumulOperatorFormat( CumulOperator1 fnc1 )
 : ACOM::Format( 0,
           0, // write 
           0, // read 
           0, // alloc 
           0, // dealloc 
           0, // cstor 
           0, // dstor 
           0, // create 
           0, // destroy 
           0  // copy 
   ),
   _cumulfnc1(fnc1), _cumulfncN(&CumulOperatorFormat::default_fncN)
{
}



// -------------------------------------------------------------------------
CumulOperatorFormat::CumulOperatorFormat( CumulOperatorN fncN )
 : ACOM::Format( 0,
           0, // write 
           0, // read 
           0, // alloc 
           0, // dealloc 
           0, // cstor 
           0, // dstor 
           0, // create 
           0, // destroy 
           0  // copy 
   ),
   _cumulfnc1(&CumulOperatorFormat::default_fnc1), _cumulfncN(fncN)
{
}


// -------------------------------------------------------------------------
CumulOperatorFormat::CumulOperatorFormat( CumulOperator1 fnc1, CumulOperatorN fncN )
 : ACOM::Format( 0,
           0, // write 
           0, // read 
           0, // alloc 
           0, // dealloc 
           0, // cstor 
           0, // dstor 
           0, // create 
           0, // destroy 
           0  // copy 
   ),
   _cumulfnc1(fnc1), _cumulfncN(fncN)
{
}

}

