// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_reduce_alphatree.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of flat reduce
// $Id: ics_reduce_alphatree.h,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// ==========================================================================
#ifndef _INUK_RED_ALPHATREE_H_
#define _INUK_RED_ALPHATREE_H_
#include <ics_reduce.h>

namespace ICS {

/* 
 * Reduce service for inuktitut
 */
class ReduceAlphaTree : public ReduceService {
public:
  /** */
  ReduceAlphaTree()
  {
  }

  void set_alpha( double a )
  { _alpha = a; }

  double get_alpha( ) const
  { return _alpha; }

  /** */
  handler post_reduce(
    void*&                     recv_data, 
    void*                      send_data, 
    size_t                     count,
    const ACOM::Format*        fmt,
    const CumulOperatorFormat* op,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_dest, 
    int                        tag
  );

  /** */
  void wait_reduce(
    handler wc
  );

  /** */
  void async_reduce(
    void*&                     recv_data, 
    void*                      send_data, 
    size_t                     count,
    const ACOM::Format*        fmt,
    const CumulOperatorFormat* op,
    int                        sz_ranks, 
    int*                       ranks, 
    int                        index_self, 
    int                        index_dest, 
    int                        tag,
    void                       (*cb_func)(void*, void*),
    void*                      cb_arg1,
    void*                      cb_arg2
  );

protected:
  double _alpha;

  /** For async bcast
  */
  static void continuation( void* a1, void* a2 );
};

}

#endif
