// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_reducenet_alpha.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of virtual base class for all reduce algorithms
// Please read node in .cpp file.
// $Id: ics_reducenet_alpha.h,v 1.1 2003/07/28 07:45:49 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_REDUCEALPHA_NETWORK_H_
#define _INUK_REDUCEALPHA_NETWORK_H_
#include <acom>
#include <ics_reduce_network.h>


namespace ICS {

// -----------------------------------------------------------------------------
/** ReduceAlphaNetwork implement a alpha tree algorithm for reduction
 */
class ReduceAlphaNetwork: public ReduceNetwork {
public:
  // --------------------------------------------------------------------------
  /** Constructor
  */
  ReduceAlphaNetwork();

  /** Destructor
  */
  ~ReduceAlphaNetwork();


  // ---------------------------------------------------------------------------
  /** extended classes for reduce purpose.
  */
  class OutChannel: public ReduceNetwork::OutChannel {
  public:
    OutChannel();

    void post( ACOM::Network::Request* r ) throw (ACOM::ComFailure);

    /* forward to next node */
    void process( ACOM::Network::CallContext* call_cc );

    void set_alpha( double a )
    { _alpha = a; }
  
    double get_alpha( ) const
    { return _alpha; }

  protected:
    double _alpha;    /* alpha value */
  };


  // ---------------------------------------------------------------------------
	ReduceNetwork::OutChannel* open_channel
    ( int tag, OpReduceService* op, 
      int count_peer, LocalNodeNo* peers, int index_self, int index_dest 
    )
       throw(ACOM::ComFailure);

private:
  friend class OutChannel;
};
 


/*
 * inline definitions
 */
 
}

#endif
