// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_reducenet_flat.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of virtual base class for all reduce algorithms
// Please read node in .cpp file.
// $Id: ics_reducenet_flat.h,v 1.4 2003/07/28 08:05:41 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_REDUCEFLAT_NETWORK_H_
#define _INUK_REDUCEFLAT_NETWORK_H_
#include <acom>
#include <ics_reduce_network.h>


namespace ICS {

// -----------------------------------------------------------------------------
/** ReduceFlatNetwork implement a flat tree algorithm for reduction
 */
class ReduceFlatNetwork: public ReduceNetwork {
public:
  // --------------------------------------------------------------------------
  /** Constructor
  */
  ReduceFlatNetwork();

  /** Destructor
  */
  ~ReduceFlatNetwork();


  // ---------------------------------------------------------------------------
  /** extended classes for reduce purpose.
  */
  class OutChannel: public ReduceNetwork::OutChannel {
  public:
    void post( ACOM::Network::Request* r ) throw (ACOM::ComFailure);

    /* forward to next node */
    void process( ACOM::Network::CallContext* call_cc, ACOM::Network::Request* r );
  protected:
  };


  // ---------------------------------------------------------------------------
	ReduceNetwork::OutChannel* open_channel
    ( int tag, OpReduceService* op, 
      int count_peer, LocalNodeNo* peers, int index_self, int index_dest 
    )
       throw(ACOM::ComFailure);

private:
  friend class OutChannel;
};
 


/*
 * inline definitions
 */
 
}

#endif
