// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_system.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Authors: T. Gautier 
// $Id: ics_system.cpp,v 1.2 2003/07/28 08:05:40 thierry Exp $
// ==========================================================================
// the namespace identifier

#include <ics_system.h>
#include <ics_network.h>

/* WARN A CHANGER ICI :
*/
int nb_queues  = 1;
int nb_threads = 1;
  

namespace ICS {

static int count_initialize =0;


// -----------------------------------------------------------------------------
void Ics::initialize(int* ac, char*** av ) throw (PTH::PosixError)
{ 
  ++count_initialize;
  static bool once=true; if (once) once=false; else return;
  PTH::Pth::initialize( ac, av );
  
  ThreadRedirec::allthreads.clear();
  ThreadRedirec::queue = new QueueWork();
  
  ACOM_ASSERT( nb_threads >= nb_queues, "bad assertion" );
    
  /* create queues */
  for (int i=0; i < nb_queues; ++i)
    ThreadRedirec::queue->add_queue( new BasicQueueWork );
    
  /* create threads and stop them */
  for (int i=0; i < nb_threads; ++i)
  {
    ThreadRedirec* tr = new ThreadRedirec( i % nb_queues );
    ThreadRedirec::allthreads.push_back( tr );
    tr->start();
//    tr->stop();
  }
}



// -----------------------------------------------------------------------------
void Ics::commit() throw (PTH::PosixError)
{
  static bool once=true;
  if (once) once=false; else return;

#if 0
  PTH::Pth::commit();
  for (int i=0; i < nb_threads; ++i)
  {
    ThreadRedirec::allthreads[i]->restart();
  }
#endif
}
 


// -----------------------------------------------------------------------------
void Ics::terminate() throw (PTH::PosixError)
{
  if (--count_initialize > 0) return;
  static bool once=true;
  if (once) once=false; else return;
  for (int i=0; i < nb_threads; ++i)
  {
    ThreadRedirec::allthreads[i]->kill();
  }
  for (int i=0; i < nb_threads; ++i)
  {
    delete ThreadRedirec::allthreads[i];
  }
  PTH::Pth::terminate();
}



// -----------------------------------------------------------------------------
const char* Ics::info()
{
  return "no info available";
}



// -----------------------------------------------------------------------------
const char* Ics::version()
{
  return "$Id: ics_system.cpp,v 1.2 2003/07/28 08:05:40 thierry Exp $";
}


} // -namespace
