// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_system.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: L. Pigeon & T. Gautier
// $Id: ics_system.h,v 1.2 2003/07/28 08:05:41 thierry Exp $
//
// ==========================================================================

#ifndef _ICS_SYSTEM_H_ 
#define _ICS_SYSTEM_H_

/*!
\file  
\brief ICS module initialisation  of InuktitutINRIA.
\author  L. Pigeon T. Gautier 

This file is dedicated to initialization , commit and finalization of of
of the ICS (Inuktitut Collective Services) module of Inuktitut0INRIA.
 
 This part is environnement dependant and must be adapted as needed.

\sa ICS::Ics::initialize() ICS::Ics::commit() ICS::Ics::terminate()

\date 2001
*/
#include <pth>
#include <ics_conf.h>


namespace ICS {

// -------------------------------------------------------------------------
// ICS package : static values
// -------------------------------------------------------------------------
/** 
\brief This part initializes all static values for ICS, and other modules
Fwd declaration of this class is defined and used in acom_system.cpp.
Any modification of this interface must be report on Acom.
*/
class Ics {
public :
  /// Initialize static value etc...   
  static void initialize(int* ac=0, char***av=0) throw (PTH::PosixError);
  /// ICS for Inuktitut0++ INRIA is up 
  static void commit() throw (PTH::PosixError);
  /// ICS for Inuktitut0++ INRIA is down 
  static void terminate() throw (PTH::PosixError);
  /// Copyright info about ICS for Inuktitut0++ INRIA  
  static const char* info();
  /// Version for ICS thread for Inuktitut0++ INRIA
  static const char* version();
};

} // -namespace

#endif // _ICS_SYSTEM_H_
