//
// $Id: testnetbcast.cpp,v 1.3 2003/07/07 15:32:24 thierry Exp $
//
// Bcast algorithm
//
#include <pth>
#include <acom>
#include <ics>
#include <unistd.h>
#include <stdlib.h>
#include <sys/time.h>
#include <iostream>
#include <iomanip>

static ACOM::Network* net = 0;
static ICS::BcastNetwork* bcastnet = 0;
static ICS::BcastNetwork::OutChannel* bcastchannel =0;

class EchoService: public ACOM::ServiceAM {
public:
  void call ( 
	     AC::ComFailure::Code e,      // if any 
	     acom::Network::Receipt* receipt,
	     AC::Network::Header* h,
	     AC::IOVectEntry* iov,
	     AC::IOVectSize   iov_sz,
	     void* ctx
	     ) throw (AC::ComFailure)
  {
    if (e == AC::ComFailure::OK) 
    {
      std::cout << net->rank() << ":: Echo: No Error iov0 = "<< (char*)iov[0].data << std::endl;
      char toto[8];
      receipt->unpack(toto,8);
      std::cout << net->rank() << ":: Echo: Im data = "<< toto << std::endl;
    }
    else 
      std::cout <<  net->rank() << ":: Error" << std::endl;
  }
};

static EchoService echo_service;

/* 
 *
 */
int doit (size_t len, int iter)
{
  net->barrier();
}



int main (int argc, char* argv[])
{
  char* toto="coucou\n";
  try {
    AC::Acom::initialize( &argc, &argv );

    ACOM::Service::Manager.bind (1, &echo_service );

    AC::Acom::commit( );

    /* Get the network:
    */
    try {
      net = ACOM::Acom::resolv_network( "CORNET" );
      std::cout << "Use network = " << net->get_name() << std::endl;
    } catch ( const ACOM::InvalidArgument& e ) {
      std::cout << "Error, bad network name !" << std::endl;
      throw e;
    }

    /* build Bcast network */
    //bcastnet = new ICS::BcastFlatNetwork;
    //bcastnet = new ICS::BcastChainNetwork;
    bcastnet = new ICS::BcastAlphaNetwork;
    bcastnet->initialize( &argc, &argv, net );
    net->barrier();

    /* open one BcastChannel */
    int rank = net->rank();
    int nodecount = net->node_count();
    ICS::uint16_t* ranks = new ICS::uint16_t[nodecount];
    for (int i=0; i<nodecount; ++i)
      ranks[i] = i;
    bcastchannel = bcastnet->open_channel(8, nodecount, ranks, rank );

    net->barrier();
    sleep(3);
    
    if (rank ==0) {
      /* send message: */
      AC::ActiveMessage<EchoService> am (bcastchannel, &echo_service, 0);
      am->put(toto,8);
      am->pack(toto,8);
      am.post(bcastchannel);
    }
    sleep(7);
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
    return -1;
  }
}
