// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/NetworkCore/src/acom_comerror.h,v $
// Copyright(c)'2001 by Apache Team
// acom_comerror.h : Error handling functions
// Author: Jacques Briat
// $Id: acom_comerror.h,v 1.4 2003/07/15 17:25:26 thierry Exp $
// ==========================================================================
/* Eliminates multiple includes of this file */
#ifndef _ACOM_COMM_ERROR_H
#define _ACOM_COMM_ERROR_H

#include <acom_netconfig.h>
#include <acom_error.h>

//@Include: acom_netconfig.h acom_error.h

// A0 namespace
namespace ACOM_NET_NAMESPACE {

// ---------------------------------------------------------------------------
// System errors: definition exceptions throwed by this package.
// ---------------------------------------------------------------------------
/**@name Exception types for the package Network 
*/

class NetworkError : public RuntimeError{
public :
  NetworkError(const char * msg , int code=0)
   : RuntimeError(msg,code)
  {}
  NetworkError ( int code=0)
   : RuntimeError("NetworkError ",code)
  {}
};


class ComFailure: public NetworkError {
  /// Return a string about the exception code
virtual   const char * _whatmsg() const throw ();
public:
  /// Error Code
  enum  Code {
    /// No error return value
    OK  = 0,
    ///
    FAIL,
    ///
    TRUNCATED,
    ///
    NOT_FILLED,
    ///
    FATAL,
    ///
    NOROUTE,
    ///
    NULL_SERVICE,
    ///
    PANIC,
    ///
    BAD_REQUEST,
    ///
    NOT_IMPLEMENTED,
    ///
    BAD_ADDRESS,
    ///
    NO_CONNECTION,
    ///
    BAD_PROTOCOL
  };
public:
  /// Cstor:
  ComFailure( Code e ): NetworkError("ComFailure ::", e){};
  ComFailure(const char* msg , Code e=OK) throw(): NetworkError(msg,e){};
  
};

} //  - namespace
#endif  /* */
