//
// $Id: SeqTest.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test pingpong
//
#include "acom"
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <sys/time.h>


#define SIZE_MAX  16


namespace AC = acom;
using namespace AC;



//***********************************************************************
//              IOVectSeq TEST
//************************************************************************
#define AllocThreshold 5
//#define AllocThreshold 0
void testIOVSeq(int  NBcell_entry, int NBentry){int i,j; size_t sz;
// NBcell_entry cell iovector size
// NB entries to be putted in Seq
// 

IOVectCellAllocator iovA;
{
IOVectSeq iovS;
iovA.init( sizeof(IOVectCell)+(NBcell_entry*sizeof(IOVectEntry)) , AllocThreshold);
iovS.init( NBcell_entry , &iovA   );
// TEST PUT
std::cout << "Test IOVectSeq :: DESTROY Void seq   ---------- ::  "<< std::endl;
iovS.putEos();
IOVectSeq::IteratorEntry ient; ient= iovS.beginEntry();
if(ient.eos()){
	 std::cout << " ::: EOS detected---------- ::  "<<  std::endl;
	}
IOVectEntry iove;
if(ient.get(&iove)){
	std::cout << "........... TRUE GET (" << iove.data << ","<<iove.len    <<")"<< std::endl;
}else{
	std::cout << "........... FALSE GET (" << iove.data << ","<<iove.len<<")"<< std::endl;
}
iovS.destroy();
std::cout << "Test IOVectSeq :: DESTROY PASSED ::  "<< std::endl;

}



{
IOVectSeq iovS;
IOVectCellAllocator iovA;
iovA.init( sizeof(IOVectCell)+(NBcell_entry*sizeof(IOVectEntry)) , AllocThreshold);
iovS.init( NBcell_entry , &iovA   );
// TEST PUT
std::cout << "Test IOVectSeq :: PUT "<< NBentry<< " ---------- ::  "<< std::endl;
for( i=0;i<NBentry; i++){
//std::cout << "PUT---------- ::  "<< i<< std::endl;
iovS.put((void*)i,i*2);
}
iovS.putEos();
std::cout << "Test IOVectSeq :: PUT PASSED ::  "<< std::endl;
std::cout << "Test IOVectSeq :: IteratorEntry :: GET ---------- ::  "<< std::endl;
//TEST GET
{IOVectSeq::IteratorEntry ient; ient= iovS.beginEntry();
for( i=0;; i++){
	if(ient.eos()){
	// std::cout << "End of Seq---------- ::  "<< i<< std::endl;
 		break;
	}
ient.get((void**)&j,&sz);
//std::cout << "GET---------- ::  "<< j<<" "<<sz<< std::endl;
if(i!=j)std::cout << "GET FAILED ON ADR"<< i <<" != " <<j << std::endl;
if(sz!=(2*i))std::cout << "GET FAILED ON SZ  "<< sz <<" != " <<sizeof(int) << std::endl;
}
if(i!=NBentry) { 
	std::cout << "GET FAIL on total ---------- ::  "<<  j << " != "<< NBentry <<std::endl;
}
}
std::cout << "Test IOVectSeq :: GET PASSED ::  "<< std::endl;

std::cout << "Test IOVectSeq :: IteratorEntry  operator -> ---------- ::  "<< std::endl;
///
{IOVectSeq::IteratorEntry ie; 
//std::cout << "IterEntry begin()---------- ::  "<< std::endl;
int j=0;
for(ie= iovS.beginEntry(); ie!=iovS.endEntry();j++, ++ie){
		if((j!=((int) ie->data)) || 2*((int) ie->data)!=(ie->len)){
			std::cout << " FAIL on  IterEntry ---------- ::  "<<
			((int) ie->data) << " " << ie->len<< std::endl; break ;
		 }
}
if(j!=NBentry) { 
	std::cout << "IterEntry FAIL on total ---------- ::  "<<  j << " != "<< NBentry <<std::endl;
}
}
std::cout << "Test IOVectSeq :: IteratorEntry PASSED !!!!:::  "<< std::endl;
std::cout << "Test IOVectSeq :: IteratorCell  operator -> ---------- ::  "<< std::endl;
{IOVectSeq::IteratorCell ic; 
//std::cout << "IterEntry begin()---------- ::  "<< std::endl;
int j=0;
for(ic= iovS.beginCell(); ic!=iovS.endCell(); ++ic,j++){
	for(int k=0; k<ic->_filled ; k++){
		int x= (int)( ic->_iov[k].data);
		if( 2*x!=(ic->_iov[k].len)){
			std::cout << " FAIL on  Iter entry on Cell ---------- ::  "<<
			((int)( ic->_iov[k].data)) << " " << (ic->_iov[k].len)<< std::endl; break ;
		 }}
}
int c= NBentry/NBcell_entry;
if(c* NBcell_entry!=NBentry)c++;
if(j!=c) { 
	std::cout << "IterCell FAIL on total ---------- ::  "<<  j << " != "<<NBentry/NBcell_entry <<std::endl;
}
}
std::cout << "Test IOVectSeq :: IteratorCell PASSED !!! ::  "<< std::endl;
std::cout << "Test IOVectSeq :: DESTROY ---------- ::  "<< std::endl;
iovS.destroy();
std::cout << "Test IOVectSeq :: PASSED !!!!::  "<< std::endl;
}
}
//.**************************************************************************
//               ByteSeq TEST
//***************************************************************************
void testByteSeq(int NBcell_entry, int NBpack, int SZ){

 // NBcell_entry cell iovector size
// NBpack total number of pack to do
// SZ buffer size 
int i,j;

ByteCellAllocator bA;
IOVectCellAllocator iovA;

iovA.init( sizeof(IOVectCell)+(NBcell_entry*sizeof(IOVectEntry))  ,AllocThreshold );

bA.init( SZ ,AllocThreshold );
std::cout << "Test ByteSeq :: VOID DESTROY ---------- ::"<< std::endl;
{ByteSeq bS;bS.packEos();
bS.destroy();}
std::cout << "Test ByteSeq :: VOID DESTROY  ---------- :: PASSED "<< std::endl;

ByteSeq bS;
bS.init( SZ, &bA ,  NBcell_entry , &iovA );
std::cout << "Test ByteSeq :: Pack ---------- ::"<<NBpack<< std::endl;
for( i=0;i<NBpack; i++){
//std::cout << "PACK ---------- ::  "<< i<< std::endl;
bS.pack((void*)&i,sizeof(int));
}
bS.packEos();
std::cout << "Test ByteSeq :: PACK PASSED ::  "<< std::endl;

std::cout << "Test ByteSeq :: UNPACK ---------- ::"<<NBpack<< std::endl;  
{ ByteSeqReader bR;
  bool err= bR.init(&bS);
for( i=0;; i++){
	if(bR.eos()){
	//	std::cout << "----------------UnPACK EOS "<< i<<" =?= "<< NBpack<<std::endl;
		 break ;
	}
	bool x=bR.unpack((void*)&j,sizeof(int));
 // std::cout << "-- UnPACK " << x <<" RANK "<<i<<" READ VALUE"<< j << std::endl;
	if(i!=j){std::cout << "UnPACK FAIL on read ::  "<<i<<" != "<< j<< std::endl; break;} 
}

if( i!= NBpack)
	std::cout << "UNPACK FAIL on total ---------- ::  "<< i<<" != "<<NBpack << std::endl;
std::cout << "Test ByteSeq :: UNPACK PASSED ::  "<< std::endl;
std::cout << "Test ByteSeq :: REWIND---------- :: "<<NBpack<< std::endl;
err= bR.init(&bS);
for( i=0;; i++){
	if(bR.eos()){
	//	std::cout << "----------------UnPACK EOS "<< i<<" =?= "<< NBpack<<std::endl;
		 break ;
	}
	bool x=bR.unpack((void*)&j,sizeof(int));
 // std::cout << "-- UnPACK " << x <<" RANK "<<i<<" READ VALUE"<< j << std::endl;
	if(i!=j){std::cout << "REWIND FAIL on read ::  "<<i<<" != "<< j<< std::endl; break;} 
}

if( i!= NBpack)
	std::cout << "REWIND FAIL on total ---------- ::  "<< i<<" != "<<NBpack << std::endl;
std::cout << "Test ByteSeq :: REWIND PASSED ::  "<< std::endl;

}
std::cout << "Test ByteSeq :: COPY as an IOVectSeq ---------- :: "<<NBpack<< std::endl;
{IOVectSeq iovS; ByteSeqReader bR; bool err;
iovS.init( NBcell_entry , &iovA   );
IOVectSeq::IteratorEntry ie; 
//std::cout << "IterEntry begin()---------- ::  "<< std::endl;
for(ie= bS.beginEntry(); ie!=bS.endEntry(); ++ie){
		 // alloc copy & put 
		void* x= (void*) std::malloc(ie->len);
		memcpy( x, ie->data, ie->len);
		iovS.put(x,ie->len);	
		 }
iovS.putEos();
err= bR.init(&iovS);
for( i=0;; i++){
	if(bR.eos()){
	//	std::cout << "----------------UnPACK EOS "<< i<<" =?= "<< NBpack<<std::endl;
		 break ;
	}
	bool x=bR.unpack((void*)&j,sizeof(int));
 // std::cout << "-- UnPACK " << x <<" RANK "<<i<<" READ VALUE"<< j << std::endl;
	if(i!=j){std::cout << "UnPACK FAIL on read ::  "<<i<<" != "<< j<< std::endl; break;} 
}
for(ie= iovS.beginEntry(); ie!=iovS.endEntry(); ++ie){
		 // free block
		 std::free(ie->data);			
		 }
iovS.destroy();
std::cout << "Test ByteSeq :: COPY as an IOVectSeq PASSED ::  "<< std::endl;
}
std::cout << "Test ByteSeq :: PASSED !!!!::  "<< std::endl;
bS.destroy();
}

int doit (int argc, char* argv[]){
std::cout << "======================================================="<<std::endl;
	testIOVSeq(13, 1  );
std::cout << "======================================================="<<std::endl;
	testIOVSeq(13, 4957  );
std::cout << "======================================================="<<std::endl;
 testByteSeq(13, 1 , 11   ); 
std::cout << "======================================================="<<std::endl;
 testByteSeq(13, 25 , 11   ); 
std::cout << "======================================================="<<std::endl;
  testIOVSeq( 37, 11111  );
std::cout << "======================================================="<<std::endl;
  testByteSeq(37 ,211, 753    ); 
std::cout << "======================================================="<<std::endl;
 }
int main (int argc, char* argv[])
{ 
  try {
   doit(argc,argv);
 
  } catch (std::exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }

}
