//
// $Id: loopam0.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <acom>
#include <string>
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <iostream>
#include <stdlib.h>
#include <list>

namespace AC = acom;
using namespace AC;
static int rank = -1;
static volatile int isterm = 0;
static char * msg= " MESSAGE NUMERO ";
class AckService: public AC::Service {
public:
  void call ( 
       AC::ComFailure::Code e,      // if any  
			 AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  { int n; int* x; int v;
    std::cout << " ACK: ";
    if (e == AC::ComFailure::OK){ 
    
     std::cout << " No Error" << std::endl;
       if(h->size_h==0) {
			 std::cout << " receive nothing immediat"  << std::endl; return;
			}
			receipt->unpack(&n, sizeof(int));
			std::cout << " receive int "<< n << std::endl;
			std::cout << " receive " << iov_sz <<" blocks " << std::endl;
			if(n!=  iov_sz){
				 std::cout << " receive number " << iov_sz <<" of blocks but wait for "<< n << std::endl;
				//return;
			}
			for(int i=0;i<n;i++){
			  std::cout <<"ADR BLOCK  <<< "<< iov[i].data << " TAILLE << "<< iov[i].len << ">>>"<< std::endl;
				if( iov[i].len !=(i+1)*sizeof(int)){
					std::cout << " receive block rank "<< i << " of size  " << iov[i].len <<"  but wait "<< (i+1)*sizeof(int) << std::endl;
					//return;
				}
			  x= ((int*)(iov[i].data)); 
				if( x[0] != i){
					std::cout << " receive block rank "<< i << " of value   " << x[0] <<"  but wait "<< i << std::endl;
				//	return;
				}
			}
    }else std::cout << "Error" << std::endl;
		std::cout << "END ACK: " << std::endl;
    isterm ++;
  }
};

static AckService ack_service;

static  int * buildArray(int sz, int val){
	int * x=new int[sz];
	for(int i=0;i<sz;i++) x[i]=val;
	return x;
}

class MyCallback : public AC::Callback {
public: 	
	std::list<int*> lst;
	bool finish;
	MyCallback():AC::Callback(),lst(),finish(false){};
	
  void done( AC::Network::Request* req )
  {
    while(!lst.empty()){ int * x =lst.back();
	 std::cout << "...........................FREE " << (void*)x <<std::endl;
						delete[] x; 
						lst.pop_back();
		}
		finish=true;
  }
	void wait(){
		//:std::cout << "..............................................WAIT " <<std::endl;
	 while(!finish);finish=false; 
	}
};
#define NBMSG 100

int doit (int argc, char* argv[])
{ int rank; 
  AC::LoopBack net; 
	net.initialize( &argc, &argv );
  //std::cout << "[MAIN] after initialize" << std::endl;
  AC::Service::Manager.bind (2, &ack_service);
  net.commit( );
  //std::cout << "[MAIN] after commit" << std::endl;
	rank=net.rank();
  AC::Network::OutChannel* channel = net.open_channel(rank);
 for (int n=1; n < NBMSG ; ++n){
			int sz;
      /* Get a request
      */
		//	MyCallback cbk;
			std::cout << "[VOID EMISSION No--------> "<< n << " ] " << std::endl;
      AC::ActiveMessage<AckService> am (&net, &ack_service, 0);
			std::cout << "[BEFORE VOID EMISSION No--------> "<< n << " ] " << std::endl;
      am(channel);
			std::cout << "[AFTER VOID EMISSION No--------> "<< n << " ] " << std::endl;
		//	cbk.wait();


  }


  for (int n=1; n < NBMSG ; ++n)
    { int sz;
      /* Get a request
      */
			MyCallback cbk;
			std::cout << "[EMISSION No--------> "<< n << " ] " << std::endl;
      AC::ActiveMessage<AckService> am (&net, &ack_service, &cbk);
			std::cout <<"[pack  "<< n << "] "<<std::endl;
			am->pack(&n, sizeof(int));
			for(int i=0;i<n;i++){
				  int * x=buildArray(i+1, i);
				  cbk.lst.push_back(x);
				  std::cout <<"[PUT "<< i << "TIMES ARRAY  "<< (void*)x << "] "<<std::endl;
			    am->put( (void*)x, (i+1)*sizeof(int));	 
				}	
			std::cout << "[BEFORE EMISSION No--------> "<< n << " ] " << std::endl;
      am(channel);
			std::cout << "[AFTER EMISSION No--------> "<< n << " ] " << std::endl;
			cbk.wait();
   	 }
  std::cout << "Ready to Terminate" << std::endl;
  net.terminate( );
}

int main (int argc, char* argv[])
{ 
  std::cout << "[MAIN] after initialize" << std::endl;
  try {
    return doit(argc, argv);
  } catch (RuntimeError& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
