//
// $Id: testam.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <pth>

namespace AC = acom;

static int rank = -1;
static PTH::CountDown isterm;

class AckService: public AC::ServiceAM {
public:
  void call ( 
	     AC::ComFailure::Code e,      // if any 
	     acom::Network::Receipt* receipt,
	     AC::Network::Header* h,
	     AC::IOVectEntry* iov,
	     AC::IOVectSize   iov_sz,
	     void* ctx
	     ) throw (AC::ComFailure)
  {
    std::cout << ":: ACK: ";
    if (e == AC::ComFailure::OK) 
      {
	std::cout << " No Error iov0 = "<<(char*)iov[0].data << std::endl;
	char toto[8];
	receipt->unpack(toto,8);
	std::cout << "Im data = "<<toto << std::endl;
	
      }
    else 
      std::cout << "Error" << std::endl;
    --isterm;
  }
};

static AckService ack_service;

int doit (int argc, char* argv[])
{
  PTH::Pth::initialize();
  PTH::Pth::commit();
  char* toto="coucou\n";
  
  AC::Acom::initialize( &argc, &argv );
  //AC::Service::Manager.bind (2, &ack_service);
  AC::Service::Manager.bind (10, 2, &ack_service);
  //AC::System::attach_debugger( );
  AC::Acom::commit( );
  std::cout << "[MAIN] after commit" << std::endl;

	/* Get the network:
  */
  AC::Acom::const_iterator icurr = AC::Acom::begin_network();
  AC::Acom::const_iterator iend  = AC::Acom::end_network();
  if (icurr == iend) 
    {
      std::cout << "No network attached to the process, exit" << std::endl;
      //return 0;
      exit (0);
    }
  else
    {
      std::cout << "Using network: " << (*icurr)->get_name() << std::endl;
    }
  AC::Network* net = *icurr;
  
  //  net->initialize(&argc,&argv);

  //  Taktuk::Network* net = new Taktuk::Network();
  //  net->initialize(&argc,&argv);
  //  net->commit();

  isterm.init(net->node_count()-1);
  net->barrier();
  std::cout<<"MAIN BEGIN"<<std::endl; 
  
  rank = net->rank();
  
  std::cout<<"send a msg to all other node WE ARE "<<net->node_count()<<std::endl;
	
  std::cout << "Service as number=" << ack_service.get_id() << std::endl;
  for (int n=0; n < net->node_count(); ++n)
    {
      /* Get a channel:
       */
      if(n!=rank) // not send it to me
	{
	  std::cout << "Got a channel to "<<n<<": rank is=" << rank << std::endl;
	  AC::Network::OutChannel* channel = net->get_default_route(n);
	  AC::ActiveMessage<AckService> am (net, &ack_service, 0);
	  am->put(toto,8);
	  am->pack(toto,8);
	  am(channel);
	}
    }
  isterm.wait();
  // - wait calling of PING
  std::cout << "Ready to Terminate" << std::endl;
  //net->terminate( );
  AC::Acom::terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (...){
    std::cerr << "Unknown exception" << std::endl;
  }
}
