//
// $Id: testam0.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>

namespace AC = acom;

static int rank = -1;
static volatile bool isterm = false;

class AckService: public AC::Service {
public:
  void call ( 
       AC::ComFailure::Code e,      // if any  
			 Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    std::cout << ":: ACK: ";
    if (e == AC::ComFailure::OK) 
       std::cout << " No Error" << std::endl;
    else 
       std::cout << "Error" << std::endl;
    isterm = true;
  }
};

static AckService ack_service;

int doit (int argc, char* argv[])
{
  AC::System::initialize( &argc, &argv );
  std::cout << "[MAIN] after initialize" << std::endl;
  AC::Service::Manager.bind (2, &ack_service);
  //AC::System::attach_debugger( );
  AC::System::initcommit( );
  std::cout << "[MAIN] after initcommit" << std::endl;

  /* Get the network:
  */
  AC::System::const_iterator icurr = AC::System::begin_network();
  AC::System::const_iterator iend  = AC::System::end_network();
  if (icurr == iend) {
     std::cout << "No network attached to the process, exit" << std::endl;
     return 0;
  }
  else
    std::cout << "Using network: " << (*icurr)->get_name() << std::endl;
  AC::Network* net = *icurr;
  rank = net->rank();

  if (rank ==0) 
  {
    for (int n=1; n < net->node_count(); ++n)
    {
      /* Get a channel:
      */
      std::cout << "Got a channel to 1: rank is=" << rank << std::endl;
      AC::OutChannel* channel = net->get_local_route(n);

      AC::ActiveMessage<AckService> am (channel, &ack_service, 0, 0);
      am->post();
    }
  }
  else {
    while (!isterm) {
      usleep( 1000 );
    }
    // - wait calling of PING
  }
  std::cout << "Ready to Terminate" << std::endl;
  AC::System::terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (AC::Exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
