//
// $Id: testam4.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test write and signal : a call to one service from rank 0, with 
// a service header
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>

namespace AC = acom;

static char* MSG = "C'est un ping" ;
static int rank = -1;
static volatile bool isterm = false;

class PingService: public AC::Service {
public:
  struct Header {
		double  data1;
    int     data2;
  };
  PingService()
  { }

  ~PingService()
  { }

  void call ( 
       AC::ComFailure::Code e,      // if any 
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    Header* h_serv = (Header*)h->get_service_header();
    std::cout << ":: PING: id=" << h_serv->data1 << ", " << h_serv->data2
              << ", ";
    if (e == AC::ComFailure::OK) 
       std::cout << "msg='" << (char*)iov[0].data << "'" << std::endl; 
    else 
       std::cout << "Error" << std::endl;
    isterm = true;
  }
};

static PingService ping;

int doit (int argc, char* argv[])
{
  AC::System::initialize( &argc, &argv );
  AC::Service::Manager.bind (2, &ping);
  AC::System::initcommit( );

  /* Get the network:
  */
  AC::System::const_iterator icurr = AC::System::begin_network();
  AC::System::const_iterator iend  = AC::System::end_network();
  if (icurr == iend) {
     std::cout << "No network attached to the process, exit" << std::endl;
     return 0;
  }
  else
    std::cout << "Using network: " << (*icurr)->get_name() << std::endl;
  AC::Network* net = *icurr;
  rank = net->rank();

  std::cout << "Got a channel to 1: rank is=" << rank << std::endl;
  if (rank ==0) 
  {
    for (int n=1; n < net->node_count(); ++n)
    {
      /* Get a channel:
      */
      AC::OutChannel* channel = net->get_local_route(n);

      std::cout << "Make ping channel " << std::endl;

      AC::ActiveMessage<PingService> am (channel, &ping, 0, 1);
      am->h_serv->data1 = 0.123456789;
      am->h_serv->data2 = 123456789;
      am->io_v[0] = AC::IOVectEntry(MSG, strlen(MSG)+1);
      am->post();
    }
  }
  else {
    while (!isterm) {
      usleep( 1000 );
    }
    // - wait calling of PING
  }
  std::cout << "Ready to Terminate" << std::endl;
  AC::System::terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (AC::Exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
