//
// $Id: testcorba1.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>

namespace AC = acom;

static volatile bool isterm = false;
static volatile int counter =0;
static AC::Network* corba_net;

class PingService: public AC::Service
{
public:
  void call ( 
       AC::ComFailure::Code e,      // if any 
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    std::cout << corba_net->rank() << ":: PING: ";
    if (e == AC::ComFailure::OK) 
       std::cout << "msg='" << (char*)iov[0].data << "'<fin>\n" << std::endl; 
    else 
       std::cout << "Error" << std::endl;
    isterm = true;
    ++counter;
  }
};

static PingService ping;

int doit (int argc, char* argv[])
{
  AC::System::initialize( &argc, &argv );
  AC::Service::Manager.bind (2, &ping);
  //AC::System::attach_debugger( );
  AC::System::initcommit( );

  /* Get the CORBA network:
  */
  corba_net = AC::System::resolv_network("CORBA");

  /* Barrier : all corba_net have been set
  */
  corba_net->barrier();

  int my_netrank = corba_net->rank();

  std::cout << "Got a channel to 1: my_rank is=" << my_netrank << std::endl;
  std::cout << "Count node is=" << corba_net->node_count() << std::endl;
  if (my_netrank ==0) 
  {
    for (int n=1; n < corba_net->node_count(); ++n)
    {
      /* Get a channel:
      */
      AC::OutChannel* channel = corba_net->get_local_route(n);

      std::cout << my_netrank << "::Make ping channel " << std::endl;
      char* MSG = "C'est un ping" ;
      AC::ActiveMessage<PingService> am (channel, &ping, 0, 1);
      am->io_v[0] = AC::IOVectEntry(MSG, strlen(MSG)+1);
      am->post();
    }
  }
  else {
    while (!isterm) {
      usleep( 1000 );
    }
    // - wait calling of PING
  }
  corba_net->barrier();
  std::cout << my_netrank << "::Ready to Terminate" << std::endl;
  AC::System::terminate( );
  std::cout << my_netrank << "::Terminate: #call service=" << counter << std::endl;
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (AC::Exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
