//
// $Id: testcorba2.cpp,v 1.2 2003/07/15 17:32:38 thierry Exp $
//
// test write and signal
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>

namespace AC = acom;

static volatile bool isterm = false;

class PingService: public AC::Service
{
public:
  PingService()
   : _myiovect(_mydata, 256)
  { } 
  void call ( 
       AC::ComFailure::Code e,      // if any 
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    std::cout << ":: PING:";
    if (e == AC::ComFailure::OK)
       std::cout << "msg='" << _mydata << "'" << std::endl;
    else
       std::cout << "Error" << std::endl;
    isterm = true;
  }

  void get_iovect(
    AC::Network::Header* header, AC::IOVectEntry* vector, AC::IOVectSize count
  )
  {
    count =1;
    vector = &_myiovect;
  }
  AC::IOVectEntry _myiovect;
  char _mydata[256]; 
};

static PingService ping;

int doit (int argc, char* argv[])
{
  AC::System::initialize( &argc, &argv );
  AC::Service::Manager.bind (2, &ping);
  AC::System::initcommit( );

  /* Get the CORBA network:
  */
  AC::Network* corba_net = AC::System::resolv_network("CORBA");
  int my_netrank = corba_net->rank();

  if (my_netrank ==0) 
  {
    for (int n=1; n < corba_net->node_count(); ++n)
    {
      /* Get a channel:
      */
      AC::OutChannel* channel = corba_net->get_local_route(n);
      std::cout << "Got a channel to 1: my_rank is=" << my_netrank << std::endl;

      std::cout << "Make ping channel " << std::endl;
      char* MSG = "C'est un ping" ;
      AC::WriteAndSignal<PingService> ws (channel, &ping, 0, 1);
      ws->io_v[0] = AC::IOVectEntry(MSG, strlen(MSG)+1);
      ws->post();
    }
  }
  else {
    while (!isterm) {
      usleep( 1000 );
    }
    // - wait calling of PING
  }
  std::cout << "Ready to Terminate" << std::endl;
  AC::System::terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (AC::Exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
