#include <acom>



int get_networks(AC::Network* &p_net, 
		  char * pnet_name,
		  AC::Network* &s_net,
		  char * snet_name) {
  AC::Acom::const_iterator iend  = AC::Acom::end_network();
  AC::Acom::const_iterator icurr = AC::Acom::begin_network();
  if (pnet_name == NULL) {
    // find a primary network
    while (icurr != iend) {
      if  ((*icurr)->get_property("primary") == "true")
	break;
      ++icurr;
    }
    
    if (icurr == iend) {
      std::cerr << "Cannot find a primary network" << std::endl;
      exit(-1);
    }
    p_net = *icurr;
  } else {
	try {
	  p_net = AC::Acom::resolv_network(pnet_name);
	} catch (AC::InvalidArgument &e) {
	  std::cerr << "Cannot find primary network " << pnet_name << std::endl;
	  p_net = NULL;
	  return 1;
	}

  }

  if (snet_name == NULL) {
    // find a primary network
    icurr = AC::Acom::begin_network();
    while (icurr != iend) {
      if  ((*icurr)->get_property("secondary") == "true")
	break;
      ++icurr;
    }
    
    if (icurr == iend) {
      std::cerr << "Cannot find a secondary network" << std::endl;
      exit(-1);
    }
    s_net = *icurr;
  } else {
	try {
	  s_net = AC::Acom::resolv_network(snet_name);
	} catch (AC::InvalidArgument &e) {
	  std::cerr << "Cannot find secondary network " << snet_name << std::endl;
	  s_net = NULL;
	  return 1;
	}
  }
  return 0;

}

