//
// $Id: testlistnet.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test list networks on which the process is connected to
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>
using  namespace std;
namespace AC = acom;

int doit (int argc, char* argv[])
{

  AC::Acom::initialize( &argc, &argv );
  AC::Acom::commit();

  // Print the number of registered networks
  std::cout << "Number of registered networks: " << AC::Acom::all_networks.size() << endl;

  /* Print the list of networks:
  */
  AC::Acom::const_iterator icurr = AC::Acom::begin_network();
  AC::Acom::const_iterator iend  = AC::Acom::end_network();
  AC::Properties net_prop;
  AC::Properties::constIterator ipcurr, ipend;

  std::cout << "Here is the list for host " 
            << AC::Acom::get_canonical_name() 
            << ", pid " << AC::Acom::get_pid() << ":\n";
  while (icurr != iend) {
    std::cout << (*icurr)->get_name()  << std::endl
              << "   Number of nodes: "  << (*icurr)->node_count() << std::endl
              << "   Rank of this machine: "<< (*icurr)->rank() << std::endl;

    // Print properties
    std::cout << "   Properties:" <<  std::endl;
    net_prop =  (*icurr)->get_properties();
    ipend = net_prop.end();
    ipcurr = net_prop.begin();
    while (ipcurr != ipend) {
      std::cout << "   - " << ipcurr->first << ": " << ipcurr->second << std::endl;
      ++ipcurr;
    }
    ++icurr;
  }
  std::cout << std::endl;

  // terminate the networks
  AC::Acom::terminate();
  return 0;
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
    //  } catch (AC::Exception& ex) {
    //    std::cerr << "Catch exception: " << ex.what() << std::endl;
  } catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
