//
// $Id: testmpi1.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>

namespace AC = acom;

extern "C" {
extern void MPI_factory_initialize();
}


static int rank = 0;
static volatile int isterm = 0;

class PingService: public AC::Service
{
public:
  void call ( 
       AC::ComFailure::Code e,      // if any 
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    std::cout << rank << " :: PING: ";
    if (e == AC::ComFailure::OK) 
       std::cout << "msg='" << (char*)iov[0].data << "'" << std::endl; 
    else 
       std::cout << "Error" << std::endl;
    isterm++;
  }
};

static PingService ping;

int doit (int argc, char* argv[])
{
  AC::System::initialize( &argc, &argv );
  MPI_factory_initialize();
  AC::Service::Manager.bind (2, &ping);
  AC::System::initcommit( );

  /* Get the MPI network:
  */
  AC::Network* net = AC::System::resolv_network("MPI");
  int my_netrank = rank = net->rank();

  std::cout << "Got a channel to 1: my_rank is=" << my_netrank << std::endl;
  if (my_netrank ==0) 
  {
    for (int n=1; n < net->node_count(); ++n)
    {
      /* Get a channel:
      */
      AC::OutChannel* channel = net->get_local_route(1-rank);

      std::cout << "Make ping channel " << std::endl;
      char* MSG = "C'est un ping" ;
      for (int k=0; k < 100; ++k) {
        AC::ActiveMessage<PingService> am (channel, &ping, 0, 1);
        am->io_v[0] = AC::IOVectEntry(MSG, strlen(MSG)+1);
        am->post();
      }
    }
  }
  else {
    while (isterm <100) {
      usleep( 1000 );
    }
    // - wait calling of PING
  }
  std::cout << my_netrank << " :: Ready to Terminate" << std::endl;
  AC::System::terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (AC::Exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
    AC::System::terminate( );
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
    AC::System::terminate( );
  }
}
