

/* functions not define on IRIX in /usr/include/sys/time.h */
#ifdef PTH_USE_PTHREAD_IRIX
# define timersub(a, b, result)                                               \
  do {                                                                        \
    (result)->tv_sec = (a)->tv_sec - (b)->tv_sec;                             \
    (result)->tv_usec = (a)->tv_usec - (b)->tv_usec;                          \
    if ((result)->tv_usec < 0) {                                              \
      --(result)->tv_sec;                                                     \
      (result)->tv_usec += 1000000;                                           \
    }                                                                         \
  } while (0)

# define timeradd(a, b, result)                                               \
  do {                                                                        \
    (result)->tv_sec = (a)->tv_sec + (b)->tv_sec;                             \
    (result)->tv_usec = (a)->tv_usec + (b)->tv_usec;                          \
    if ((result)->tv_usec >= 1000000)                                         \
      {                                                                       \
        ++(result)->tv_sec;                                                   \
        (result)->tv_usec -= 1000000;                                         \
      }                                                                       \
  } while (0)

#endif

#define timerdiv(t, div_val, res)                             \
do {                                                          \
  long tmp;                                                   \
  tmp = (((t)->tv_sec % (int) (div_val)) * 1000000);          \
  tmp += (t)->tv_usec;                                        \
  (res)->tv_usec = tmp / (int) (div_val);                     \
  (res)->tv_sec /= (div_val);                                 \
} while (0)
  
#define timermul(t, mul_val, res)                             \
do {                                                          \
  (res)->tv_sec = (t)->tv_sec * (mul_val);                    \
  (res)->tv_sec += ((t)->tv_usec * (mul_val)) / 1000000;      \
  (res)->tv_usec = ((t)->tv_usec * (mul_val)) % 1000000;      \
} while (0)


#define milliseconds(t)                                 \
   ((float) (t)->tv_usec / 1000 + (t)->tv_sec * 1000)

