//
// $Id: testws0.cpp,v 1.2 2003/07/15 17:33:09 thierry Exp $
//
// test write and signal
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>

namespace AC = acom;

static volatile bool isterm = false;
static int rank =-1;

class PingService: public AC::Service
{
public:
  PingService()
   : _myiovect(_mydata, 256)
  { } 
  void call ( 
       AC::ComFailure::Code e,      // if any 
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    std::cout << rank << " :: PING:";
    if (e == AC::ComFailure::OK)
       std::cout << "msg='" << _mydata << "'" << std::endl;
    else
       std::cout << "Error" << std::endl;
    isterm = true;
  }

  void get_iovect(
    AC::Network::Header* header, AC::IOVectEntry* vector, AC::IOVectSize& count
  )
  {
    count =1;
    vector = &_myiovect;
  }

protected:
  AC::IOVectEntry _myiovect;
  char _mydata[256]; 
};

static PingService ping;

int doit (int argc, char* argv[])
{
  AC::System::initialize( &argc, &argv );
  AC::Service::Manager.bind (2, &ping);
  AC::System::initcommit( );

  /* Get the network:
  */
  AC::System::const_iterator icurr = AC::System::begin_network();
  AC::System::const_iterator iend  = AC::System::end_network();
  if (icurr == iend) {
     std::cout << "No network attached to the process, exit" << std::endl;
     return 0;
  }
  else
    std::cout << "Using network: " << (*icurr)->get_name() << std::endl;
  AC::Network* net = *icurr;
  rank = net->rank();
  

  if (rank ==0) 
  {
    for (int n=1; n < net->node_count(); ++n)
    {
      /* Get a channel:
      */
      AC::OutChannel* channel = net->get_local_route(n);
      std::cout << "Got a channel to 1: rank is=" << rank << std::endl;

      std::cout << "Make WS ping on channel " << std::endl;
      char* MSG = "C'est un ping" ;
      AC::WriteAndSignal<PingService> ws (channel, &ping, 0, 1);
      ws->io_v[0] = AC::IOVectEntry(MSG, strlen(MSG)+1);
      ws->post();
    }
  }
  else {
    while (!isterm) {
      usleep( 1000 );
    }
    // - wait calling of PING
  }
  std::cout << "Ready to Terminate" << std::endl;
  AC::System::terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (AC::Exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
