//
// $Id: testws4.cpp,v 1.2 2003/07/15 17:33:09 thierry Exp $
//
// test write and signal : a call to one service from rank 0, with 
// a service header
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>

namespace AC = acom;

static char* MSG = "C'est un ping" ;
static int rank = -1;
static volatile bool isterm = false;

class PingService: public AC::Service {
public:
  struct Header {
    int  data;
  };
  PingService()
  {
  }
  ~PingService()
  { 
  }
  void call ( 
       AC::ComFailure::Code e,      // if any 
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    Header* h_serv = (Header*)h->get_service_header();
std::cout << "In ping:" << std::endl;
std::cout << "size_h=" << h->size_h << std::endl;
std::cout << "size_d=" << h->size_d << std::endl;
std::cout << "node  =" << h->node << std::endl;
std::cout << "id    =" << h->id << std::endl;
std::cout << "data  =" << h_serv->data << std::endl;
    std::cout << ":: PING: id=" << h_serv->data << ", ";
    char* data2 = ((char*)&h_serv->data) + sizeof(int);
    if (e == AC::ComFailure::OK) {
       std::cout << "msg1='" << (char*)iov[0].data << "'" << std::endl; 
       std::cout << "msg1bis='" << (char*)iov[1].data << "'" << std::endl; 
       std::cout << "msg2='" << data2 << "'" << std::endl; 
    }
    else 
       std::cout << "Error" << std::endl;
    isterm = true;
  }
  void get_iovect(
    AC::Network::Header* header, AC::IOVectEntry* vector, AC::IOVectSize count  )
  {
    int sz = strlen(MSG);
    count  =2;
    vector = new AC::IOVectEntry[2];
    vector[0] = AC::IOVectEntry( new char[sz+1], sz+1);
    vector[1] = AC::IOVectEntry( new char[sz+1], sz+1);
  }

};

static PingService ping;

int doit (int argc, char* argv[])
{
  /* Get the network:
  */
  AC::System::const_iterator icurr = AC::System::begin_network();
  AC::System::const_iterator iend  = AC::System::end_network();
  if (icurr == iend) {
     std::cout << "No network attached to the process, exit" << std::endl;
     return 0;
  }
  else
    std::cout << "Using network: " << (*icurr)->get_name() << std::endl;
  AC::Network* net = *icurr;
  rank = net->rank();

  std::cout << "Got a channel to 1: rank is=" << rank << std::endl;
  if (rank ==0) 
  {
    for (int n=1; n < net->node_count(); ++n)
    {
      /* Get a channel:
      */
      AC::OutChannel* channel = net->get_local_route(n);

      std::cout << "Make ping channel " << std::endl;

      // variable size header of size 52 bytes, 2 io vector
      AC::WriteAndSignal<PingService> am (channel, &ping, 0, 2, 52);
      am->h_serv->data = 123456789;
      char* data2 = ((char*)&(am->h_serv->data)) + sizeof(int);
      memcpy(data2,"Cette chaine a exactement 52 caracteres (avec le 0)",52);
      am->io_v[0] = AC::IOVectEntry(MSG, strlen(MSG)+1);
      am->io_v[1] = AC::IOVectEntry(MSG, strlen(MSG)+1);
      
      am->post();
    }
  }
  else {
    while (!isterm) {
      usleep( 1000 );
    }
    // - wait calling of PING
  }
  std::cout << "Ready to Terminate" << std::endl;
}

int main (int argc, char* argv[])
{
  try {
    AC::System::initialize( &argc, &argv );
    AC::Service::Manager.bind (2, &ping);
    AC::System::initcommit( );
    //AC::System::attach_debugger( );
    doit(argc, argv);
    AC::System::terminate( );
  } catch (AC::Exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
