 // ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/Psocket/src/sock_server.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file for more information
// Author: J Briat T.Gautier
//
//
//
// ==========================================================================
#include <errno.h>
#include <string>
#include <stdio.h>
#include <iostream>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <pth>

#include "sock_server.h"

namespace SOCK{

// ==========================================================================
/*! bind socket to Localaddr.
 *  \return  zero if bind was successfull, else -1
 */
int SocketServer::bind(const Address& localaddr)
{
  setAddress( localaddr );
  int bind_result = bind();
  return bind_result;
}

// ==========================================================================
/*! bind socket to _addr.
 *  \return  zero if bind was successfull, else -1
 */
int SocketServer::bind()
{
  if (_fd == -1)
  {
    _fd = ::socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );
    if (_fd == -1)
      printf("SOCKET: fd  = %d\n",_fd);
    else
      _valid = true;
  }

 
 // if(ntohs(_addr._sockaddr.sin_port)!=0)
 //   localaddr.sin_port = _addr._sockaddr.sin_port;
  int bind_result = -1;
  /*if ( localaddr.sin_port == 0)
  {
    localaddr.sin_port = IPPORT_RESERVED ;
    while (bind_result < 0 && ntohs(localaddr.sin_port) <  IPPORT_USERRESERVED -1)
    {
      localaddr.sin_port++;
      bind_result =  ::bind(_fd,(sockaddr *)&localaddr, sizeof(localaddr));
    }
  }
  else {
    bind_result = ::bind(_fd, (sockaddr*)&localaddr, sizeof(localaddr));
  }*/
  bind_result = ::bind(_fd, (sockaddr*)&_addr._sockaddr, sizeof(_addr._sockaddr));
  if(bind_result<0)
  {
    PTH::throwit( PTH::RuntimeError( strerror(errno), errno ));
  }
  sockaddr_in sock;
#if defined(SOCK_USE_LINUX) || defined(SOCK_USE_SUNOS)
  socklen_t sizesock=sizeof(sock);
#elif defined(SOCK_USE_DARWIN) || defined(SOCK_USE_IRIX)
  int sizesock=sizeof(sock);
#endif
  getsockname(_fd,(sockaddr*)&sock,&sizesock);
  
  //std::cout << "sock _port= "<<ntohs(sock.sin_port)<<endl;
  //std::cout << "sock sockaddr.sinport= "<<sock.sin_port<<endl;

 
  _addr._port = ntohs(sock.sin_port);
//  _addr._sockaddr.sin_port = localaddr.sin_port;
  //std::cout << "Port for the address= " << _addr << std::endl;
  if (bind_result == -1)
  {
    _addr._lastError=errno;
    PTH::throwit( PTH::RuntimeError( strerror(errno), errno ));
    //perror("bind");
  }
  return bind_result;
}



// ==========================================================================
/*! listen for connections on socket
 * \return zero on success, else -1
 */
int SocketServer::listen(int backlog)
{
  int listen_result = ::listen(_fd,backlog);
  if (listen_result == -1) _addr._lastError=errno;
  return listen_result;
}//maybe in the accept????

// ==========================================================================
/*! wait for incoming connection, return Socket object for client.
 *  Blocks until a client has connected
 *  \return socket object, connected to the computer that requested a
 *          connection
 */
SocketClient& SocketServer::accept(const Address& localaddr, SocketClient& sc)
{
  setAddress( localaddr );
  return accept(sc);
}

// ==========================================================================
/*! wait for incoming connection, return Socket object for client.
 *  Blocks until a client has connected
 *  \return socket object, connected to the computer that requested a
 *          connection
 */
SocketClient& SocketServer::accept(SocketClient &sc )
{
  Address addr;
#if defined(SOCK_USE_LINUX) || defined(SOCK_USE_SUNOS)
  socklen_t size = sizeof(sockaddr_in);
#elif defined(SOCK_USE_DARWIN)  || defined(SOCK_USE_IRIX)
  int size = sizeof(sockaddr_in);
#endif
  int fd;
  if ((fd = ::accept(_fd, addr.getSockAddr(), &size)) <0)
  {
    _addr._lastError=errno;
    PTH::throwit( PTH::RuntimeError( strerror(errno), errno ));
//    perror("accept ::");
  }
  addr._valid = true;
  addr._port = htons (addr.getSockAddr_in()->sin_port);
  sc.set_fd(fd);
  sc.setAddress(addr);
  return sc;
}


} // namespace
