// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/Pthread/src/tr_buffer.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: J. Briat & T. Gautier

//
// ==========================================================================
#ifndef _TR_BUFFER_H_
#define _TR_BUFFER_H_
/*!
\file
\brief Base types for Inuktitut INRIA Tracing facility;
\author  J. Briat  

This file is dedicated to the base  type for coding event. It is used for recording or reading an event record to/from  a trace 

 This part is environnement dependant and must be adapted as needed.

\date 2002
*/

#include <pth_ns.h>
#include <pth_dep.h>
#include <pth_time.h>
#include <pth_pthreadsync.h>

#include <string>
#include <stdlib.h>

namespace PTH {
/** What is recorded  for an event in a file:
      -  level & event code
      -  traced node
      - traced thread
      - date
  */
//@{
  /// types for numbering levels 
  typedef unsigned short tr_level_no;
	/// types for numbering  events
  typedef unsigned short tr_event_no;  
 /// Size of the event size
  typedef unsigned short EventSize;
  /// Size of a node rank 
  typedef unsigned short NodeNo;
  /// Size of the static part of an event
  const short event_static_size= sizeof(tr_level_no)
    + sizeof(tr_event_no)
    + sizeof(NodeNo) // node no
    + sizeof(PTH::ThreadId) // traced thread
    + sizeof(  PhysicalClock::Date) ; 
  /**  size of string size 
       
  A string is recorded as its size followed by its bytes 
  
  */
    
  typedef unsigned short StringSize;
//@} 

  /** 
      \brief  FlushBuffer event
      
      events used to trace the behavior of the buffer allocation strategy.
  */
 //@{
/// level reserved for tracer
  const tr_level_no  tracer_level_no=0; // reserved for tracer
/// flush buffer event
  const tr_event_no  flushBuffer_no=0;  // flush buffer event
/// static size for flush buffer event   
  const  short flush_event_size = event_static_size + sizeof( PhysicalClock::Date);
//@} 
  
}
#endif
