#ifndef _TR_RECORDER_INL_
#define _TR_RECORDER_INL_
namespace PTH 
{
inline void Binder::initBinder(void (*destruct)(SimpleBuffer*))throw(PosixError){
     int err;
     err=_tracekey.createnothrow(destruct);
     //  ASSERT(!err,
//           PosixError("[Binder::Init]: cannot create POSIX key for self reference", err));
};


// ////////////////////////////////////////////////////////////////////////////




inline SimpleBuffer * SimpleBufferManager::allocBuffer( ){ 
  SimpleBuffer * buf;
  buf= new SimpleBuffer();
  buf->open();
  //---------------------list_buffer---------------------------
  {
    CRITICAL_NOTRACE (mutex_list_buffer);
    list_buffer.push_back(buf);
  }
  //---------------------------------------------------------
  return buf;
}


inline void SimpleBufferManager::freeBuffer(SimpleBuffer * buf ){ 
  //----------------------list_buffer---------------------------
	{
     CRITICAL_NOTRACE (mutex_list_buffer);
    list_buffer.erase(buf); 
  }
  //---------------------------------------------------------------
  delete buf;
}



inline void SimpleBufferManager::saveBuffer( SimpleBuffer* buf){
  int sz= buf->close();
  if(sz && _fd!=-1){ CRITICAL_NOTRACE (mutex_fd); 
    /* int szz= */::write(_fd,&(buf->_data[0]), sz);
  }
  buf->refresh();
}



inline SimpleBuffer * SimpleBufferManager::flushBuffer(SimpleBuffer* buf){ 
  int sz= buf->close();
   //   std::cout<<"flushBuffer\n";
 if(sz&& _fd!=-1){ CRITICAL_NOTRACE (mutex_fd);
     /* int szz= */::write(_fd,&(buf->_data[0]),sz);
  }
   buf->refresh();
  return buf;
 }


inline  void  SimpleBufferManager::openTraceFile(char * fn) throw(PosixError){
  if(!fn)return ;
#ifdef PTH_USE_PTHREAD_DARWIN
  _fd=::open(fn,O_CREAT |O_WRONLY |  O_TRUNC, S_IRWXU  );
#else
  _fd=::open(fn,O_CREAT |O_WRONLY |  O_TRUNC|   O_SYNC, S_IRWXU  );
#endif
   // ASSERT((_fd>=0),
//   PosixError("[SimpleGenericManager::Init]: cannot open trace file", errno));
   ::lseek(_fd, 0, SEEK_SET);  
}




inline  void  SimpleBufferManager::closeTraceFile( )throw(PosixError){
 static bool once=true;if(once)once=false;else return;
if(_fd!=-1){::close(_fd);_fd=-1;}
}
}
#endif
