// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/SOCK_net/src/SOCKNET_service.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// $Id: SOCKNET_service.cpp,v 1.3 2003/07/28 15:46:39 thierry Exp $
//
// ==========================================================================
#include <SOCKNET_service.h>
#include <SOCKNET_network.h>


namespace SOCKNET {


// -----------------------------------------------------------------------------
void ServiceGetUrl::get_urlpeer( std::string& s, const int peer )
{
//  std::cout << "In : " << __PRETTY_FUNCTION__ << std::endl;
  bool recv = false;
  ACOM::Network::OutChannel* ch = 
      _net->_subnet->get_default_route( peer );
  ACOM::AWSMessage msg(_net->_subnet, _net->_service_geturl, 0 );
  size_t opaque[3];
  opaque[0] = (size_t)&_net->_cond;
  opaque[1] = (size_t)&s;
  opaque[2] = (size_t)&recv;
  msg->pack( opaque, 3*sizeof(size_t) );
  msg.post( ch );

  /* wait reply */
  PTH::CriticalGuard critical( &_net->_access );
  while (!recv)
  {
    _net->_cond.wait( _net->_access );
  }
//  std::cout << "Out : " << __PRETTY_FUNCTION__ << std::endl;
}
  

// -----------------------------------------------------------------------------
void ServiceGetUrl::call ( 
      ACOM::ComFailure::Code e,      // if any 
      ACOM::Network::Receipt* r,      
      ACOM::Network::Header* h,
      ACOM::IOVectEntry* iov,
      ACOM::IOVectSize   iov_sz,
      void* cc
) throw (ACOM::ComFailure)
{
//  std::cout << "In : " << __PRETTY_FUNCTION__ << std::endl;
  size_t opaque[3];
  r->unpack( opaque, 3*sizeof(size_t) );
  _net->_service_reply->reply( h->src, opaque, _net->_url );
//  std::cout << "Out : " << __PRETTY_FUNCTION__ << std::endl;
}



// -----------------------------------------------------------------------------
void ServiceReply::reply( int node, size_t opaque[3], const std::string& url )
{
//  std::cout << "In : " << __PRETTY_FUNCTION__ << std::endl;
  ACOM::Network::OutChannel* ch = 
      _net->_subnet->get_default_route( node );
  ACOM::AWSMessage msg(_net->_subnet, _net->_service_reply, 0 );
  size_t sz = url.size();
  msg->pack( opaque, 3*sizeof(size_t) );
  msg->pack( &sz, sizeof(size_t) );
  const char* c = url.c_str();
  msg->pack( c, sizeof(char)*sz );
  msg.post( ch );
//  std::cout << "Out : " << __PRETTY_FUNCTION__ << std::endl;
}
  

// -----------------------------------------------------------------------------
void ServiceReply::call ( 
      ACOM::ComFailure::Code e,      // if any 
      ACOM::Network::Receipt* r,      
      ACOM::Network::Header* h,
      ACOM::IOVectEntry* iov,
      ACOM::IOVectSize   iov_sz,
      void* cc
) throw (ACOM::ComFailure)
{
//  std::cout << "In : " << __PRETTY_FUNCTION__ << std::endl;
  size_t opaque[3];
  size_t sz =0;
  r->unpack( opaque, 3*sizeof(size_t) );
  r->unpack( &sz, sizeof(size_t) );
  char* c = (char*)::alloca(sz+1);
  r->unpack(c, sizeof(char)*sz);
  PTH::Condition* cond = (PTH::Condition*)opaque[0];
  std::string* s       = (std::string*)opaque[1];
  bool* f              = (bool*)opaque[2];
  *s = c;
  PTH::CriticalGuard critical( &_net->_access );
  *f = true;
  cond->broadcast();
//  std::cout << "Out : " << __PRETTY_FUNCTION__ << std::endl;
}




}
