// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/SOCK_net/src/SOCKNET_service.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// $Id: SOCKNET_service.h,v 1.2 2003/07/15 18:26:56 thierry Exp $
//
// ==========================================================================
#ifndef __SOCKNET_SERVICE_H_
#define __SOCKNET_SERVICE_H_
#include <acom>


namespace SOCKNET {

/* fwd delcaration */
class SOCKNET_net;

// -----------------------------------------------------------------------------
/** 
 */
class ServiceReply : public ACOM::ServiceAM {
public:
  void initialize( SOCKNET_net* net )
  { _net = net; }
  
  void reply( int node, size_t opaque[3], const std::string& url );
  
protected:
  /* appele apres que le message soit arrive 
   */
  void call ( 
       ACOM::ComFailure::Code e,      // if any 
       ACOM::Network::Receipt* r,      
       ACOM::Network::Header* h,
       ACOM::IOVectEntry* iov,
       ACOM::IOVectSize   iov_sz,
       void* cc
  ) throw (ACOM::ComFailure);
  SOCKNET_net* _net;
};

// -----------------------------------------------------------------------------
/** 
 */
class ServiceGetUrl : public ACOM::ServiceAM {
public:

  void initialize( SOCKNET_net* net )
  { _net = net; }

  /* make a call */
  void get_urlpeer( std::string& s, const int peer );
  
protected:
  /* appele apres que le message soit arrive 
   */
  void call ( 
       ACOM::ComFailure::Code e,      // if any 
       ACOM::Network::Receipt* r,      
       ACOM::Network::Header* h,
       ACOM::IOVectEntry* iov,
       ACOM::IOVectSize   iov_sz,
       void* cc
  ) throw (ACOM::ComFailure);
  SOCKNET_net* _net;
};



/*
 * inline definitions
 */
 
}
#endif // __SOCKNET_SERVICE_H_

