//
// $Id: hello.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// Bcast algorithm
//
#include <pth>
#include <acom>
#include <ics>
#include <unistd.h>
#include <sys/time.h>
#include <iomanip>
#include <CORNET_network.h>
#include <SOCKNET_network.h>


namespace AC = acom;

AC::Network* net = 0;
AC::Network* primary_net = 0;
ICS::BcastOne2All*   bcastone2all_service =0;
ICS::BcastPipeline1* bcastpipeline1_service =0;
ICS::BcastAlphaTree* bcastalpha_service =0;
ICS::AckService*     ack_service =0;
ICS::BarrierService* barrier_service =0;

/* pointer to the concret service for bcast */
ICS::BcastService*   thebcast =0;

/* 
*
*/
int doit ()
{
  int myrank    =  net->rank();
  int nodecount =  net->node_count();

  int* ranks = new int[ nodecount ];
  for (int i=0; i<nodecount; ++i)
    ranks[i] =i;
  
  void* data = 0;
  size_t len =0;
  if (myrank ==0) {
    data = (void*)"Ca sent bon ici le bcast";
    len = strlen((char*)data)+1;
  }
  else {
    data = malloc(256);
  }

  /* call bcast */
  size_t sz = 1;
  void* llen = (void*)&len;
  thebcast->bcast(
    llen,
    sz,
    &ACOM::FormatDef::Int,
    nodecount,
    ranks,
    myrank,  /* self index in ranks */
    0,       /* src indexs in ranks */
    1        /* tag */
  );
  std::cout << net->rank() << ":: string len=" << len << std::endl;
  thebcast->bcast(
    data,
    len, 
    &ACOM::FormatDef::Byte,
    nodecount,
    ranks,
    myrank,  /* self index in ranks */
    0,       /* src indexs in ranks */
    2       /* tag */
  );

  std::cout << net->rank() << ":: msg=" << (char*)data << std::endl;
  delete ranks;
}





int main (int argc, char* argv[])
{
  try {
    PTH::Pth::initialize();
    PTH::Pth::commit();

    bcastone2all_service  = new ICS::BcastOne2All; 
    bcastpipeline1_service= new ICS::BcastPipeline1; 
    bcastalpha_service    = new ICS::BcastAlphaTree; 
    ack_service           = new ICS::AckService; 
    barrier_service       = new ICS::BarrierService; 
    AC::Service::Manager.bind (2, ack_service );
    AC::Service::Manager.bind (3, barrier_service );
    AC::Service::Manager.bind (4, bcastone2all_service );
    AC::Service::Manager.bind (5, bcastpipeline1_service );
    AC::Service::Manager.bind (6, bcastalpha_service );
    primary_net = new CORNET::CORNET_net();
    net = new SOCKNET::SOCKNET_net();

    /* Initialize the service objects */
    ack_service->initialize( net );
    barrier_service->initialize( net );
    bcastone2all_service->initialize( net );
    bcastpipeline1_service->initialize( net );
    bcastalpha_service->initialize( net );

    bcastpipeline1_service->set_blocsize( 1024 );
    bcastalpha_service->set_alpha( 0.5 );

    primary_net->initialize(&argc,&argv);
    net->initialize(&argc,&argv, primary_net);

    primary_net->commit();
    net->commit();

    if ( std::string(argv[1]) == "one2all" ) {
      thebcast = bcastone2all_service;
      std::cout << "using one2all algorithm" << std::endl;
    } else if ( std::string(argv[1]) == "pipeline1" ) {
      thebcast = bcastpipeline1_service;
      std::cout << "using pipeline1 algorithm" << std::endl;
    } else if ( std::string(argv[1]) == "alpha" ) {
      thebcast = bcastalpha_service;
      std::cout << "using alpha algorithm" << std::endl;
    } else {
      thebcast = bcastone2all_service;
      std::cout << "using one2all algorithm" << std::endl;
    }

    //barrier_service->barrier( 0 );
    primary_net->barrier();

    int rank = net->rank();
    int nodecount = net->node_count();
std::cout << "rank=" << rank << std::endl;
std::cout << "nodecount=" << nodecount << std::endl;

    /* Call one experiment : */
    doit();

    //barrier_service->barrier( 1 );
    primary_net->barrier();

    net->terminate();
    primary_net->terminate();
    delete bcastone2all_service;
    delete bcastpipeline1_service;
    delete bcastalpha_service;
    delete ack_service;
    delete barrier_service;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
    //AC::System::terminate( );
    net->terminate();
    primary_net->terminate();
  }
}
