#ifndef __TCP_MANAGER_H
#define __TCP_MANAGER_H

#include<pth>
#include<acom>
#include<sock>
#include<TCP_network.h>
#include<TCP_dns.h>
#include<CoreTCP.h>

//class TCPmanager: private PTH::ThreadModel<TCPmanager>
class TCPmanager
{
	public:
		TCPmanager()
		{
			PTH::Pth::initialize();
			PTH::Pth::commit();
//			_state.reserve(32);
		}
		~TCPmanager()
		{
			;
		}
		void initialize(acom::Network* netbase, TCP_NET::tcp_net* net);

		void terminate();

		TCP_NET::tcp_net::TCP_Channel* connectto(const TCP_NET::tcp_net::LocalNodeNo& node);

		int close(const TCP_NET::tcp_net::LocalNodeNo& node);

		typedef unsigned short uint16;

		enum state {doing,connected,closed,unreach };
	private:
		class QueueState
		{
			public:
				QueueState()
				{
					PTH::Pth::initialize();
					PTH::Pth::commit();
					mut = new PTH::Mutex();
					mut->init();
					queue = new PTH::Condition();
					queue->init();
					_value=closed;
					_ch=NULL;
				}

				QueueState(const QueueState& qs)
				{
					mut = new PTH::Mutex();
					mut->init();
					queue = new PTH::Condition();
					queue->init();
					_value=qs._value;
					_ch=qs._ch;
				}

                                // when copying objects, do not copy mutex
                                // or conds
                                QueueState & operator=(const QueueState& qs)
                                {
				state _value = qs._value;
                                _ch = qs._ch;
                                return *this;
                                }

				~QueueState()
				{
					mut->destroy();
					queue->destroy();
					delete mut;
					delete queue;
				}
				void DoOrWait()
				{
					mut->lock();
					if(_value!=closed)
					{
						while (_value == doing)
						{
							//std::cout<<"DoorWait -> waiting"<<std::endl;
							queue->wait(*mut);
						}
					}
					else
					{
						if(_value==closed)
							_value=doing;
						//std::cout<<"DoorWait -> doing"<<std::endl;
					}
					//std::cout<<"DoorWait -> OK"<<std::endl;
					mut->unlock();
				}
				state get_value()
				{
					state res;
					mut->lock();
					res=_value;
					mut->unlock();
					return res;
				}
				state getset_value(state s)
				{
					state res;
					mut->lock();
					res=_value;
					if(_value!=connected)
						_value=s;
					mut->unlock();
					return res;
				}
				TCP_NET::tcp_net::TCP_Channel* getchannel()
				{
					TCP_NET::tcp_net::TCP_Channel* ch;
					mut->lock();
					ch=_ch;
					mut->unlock();
					return ch;
				}
				void SetLink(TCP_NET::tcp_net::TCP_Channel* ch)
				{
					mut->lock();
					if(ch!=NULL)
					{
						_value=connected;
						_ch=ch;
					}
					else
						_value=unreach;
					queue->broadcast();
					mut->unlock();
				}
			private:
				PTH::Mutex * mut;
				PTH::Condition * queue;
				state _value;
				//InfoTCPnet::link* _link;
				TCP_NET::tcp_net::TCP_Channel* _ch;
				
		};
	private:
		PTH::Thread _TCP_mgr_thread;
		PTH::ThreadId _TCP_mgr_threadId;
		std::vector<QueueState> _state;
		/*int testandset(const tcp_net::LocalNodeNo& Id);
		void unset(const tcp_net::LocalNodeNo& Id);
		void test(const tcp_net::LocalNodeNo& Id);
*/
		acom::Network* _net;
		TCP_NET::tcp_net* _mynet;
		SOCK::SocketServer _sockserv;
		SOCK::Address hostAddr;
		std::string hostIP;
		uint16 hostPort;
		TCP_dns _dns;
		friend class QueueState;
		void process(SOCK::SocketClient* s);
				
	public:
		void run();
};
#endif
