#include <TCP_router.h>
#include <TCP_network.h>
#include <CoreTCP.h>
#include <acom>

void TCP_router::bcast(InfoTCPnet::link* link,
        acom::Network::Receipt* receipt,
        acom::IOVectEntry* iov,
        size_t* iov_dsz,
        void* im_data)
{
//	dbg.log("process","incoming  message is for me and for all other redirect it before call the service\n");
	//send the message to on all link less one
	for(int i=0;i<info.all_links.size();i++)
	{
		if(info.all_links[i]._peer!=link->_peer && info.all_links[i].open())
		{
			dbg.log("process","redirect message to %d\n",info.all_links[i]._peer);
			info.all_links[i].lock();
			//send the header
			info.all_links[i]._sock->writen(&receipt->_header,
								sizeof(acom::Network::Header));
			dbg.log("process","redirect message HEADER OK\n");
			//send the description tab
			info.all_links[i]._sock->writen(iov_dsz,
								sizeof(size_t)*receipt->_header.iovsz_d);
			//send immediate data
			info.all_links[i]._sock->writen(im_data,
								sizeof(char)*receipt->_header.size_h);
			//send defered data
			for(int ii=0;ii<receipt->_header.iovsz_d;ii++)
			{
				info.all_links[i]._sock->writen(iov[ii].data,iov[ii].len);
			}
			info.all_links[i].unlock();
			dbg.log("process","redirect message to %d terminated\n",info.all_links[i]._peer);

		}
	}
}


int TCP_router::process(InfoTCPnet::link* link,int linkID)
{
	
	//dbg.log("process","process BEGIN\n");
	//std::cout<<"ROUTEUR recoi un nouveau message"<<std::endl;
	acom::Service* s=NULL;
	size_t* iov_dsz; 
	acom::IOVectEntry* iov;
	TCP_NET::tcp_net::TCP_Receipt rcpt;
	void* im_data;
	acom::IOVectSeq im_data_seq;
	im_data_seq.init(_nb_entries,&_iovA);
	int data_to_read=0;
 
	if(link==NULL ||  link->_sock == NULL || !link->_sock->valid())
		return -1;
	//first read the header
	//link->lock(); 
	// Unlock when we finish to read all the AM or WS or AWS
	
	//first read the header
	if(link->_sock->readn((void*)&rcpt._header,sizeof(acom::Network::Header))<=0)
	{
		//link->unlock();
		return -1;
	}
	//IT'S FOR ME?????
	//std::cout<<"ROUTEUR JE SUIS LE NOEUD "<<info.rank<<" le message est pour le noeuds "<<rcpt._header.dst<<std::endl;
	if(rcpt._header.dst==InfoTCPnet::ALL || rcpt._header.dst == info.rank)
	{	// YES IT'S FOR ME :-)
  
		//std::cout<<"ROUTEUR recoi un nouveau message C' EST POUR MOI YOUPI"<<std::endl;
		//dbg.log("process","incoming message is for me process it\n"); 

		/*build the iovector of deferred data on the stack 
		*/
		if(rcpt._header.iovsz_d>0)
		{
			iov=(acom::IOVectEntry*) malloc(sizeof(acom::IOVectEntry)*(rcpt._header.iovsz_d));
    	if(iov==NULL)
				return -1;
				//dbg.log("ERROR","process CAN'T ALLOCATE DATA FOR IOV DESC\n");

			iov_dsz=(size_t*)malloc(sizeof(size_t)*rcpt._header.iovsz_d);
	   	if(iov_dsz==NULL)
				return -1;
				//dbg.log("ERROR","process CAN'T ALLOCATE DATA FOR IOV DESC\n");

			if(link->_sock->readn((void*)iov_dsz,sizeof(size_t)*rcpt._header.iovsz_d)<0)
			{
				//link->unlock();
				return -1;
			}

			for(int i=0;i<rcpt._header.iovsz_d;i++)
			{
				dbg.log("process","descrition def data len no %d = %d\n",i,iov_dsz[i]);
				iov[i].len=iov_dsz[i];
				iov[i].data=0;
			}
		}
		else
		{
			iov=NULL;
			iov_dsz=NULL;
		}
		//alloc & read imediate data
		if(rcpt._header.size_h>0)
		{
			im_data=malloc(sizeof(char)*rcpt._header.size_h);
			if(im_data==NULL)
				return -1;
				//dbg.log("ERROR","process CAN'T ALLOCATE DATA FOR IOV DESC\n");
			if(link->_sock->readn((void*)im_data,sizeof(char)*rcpt._header.size_h)<0)
			{
				//link->unlock();
				return -1;
			}
		}
		else
			im_data=NULL;
		//initialize the receipt request
		if(rcpt._header.size_h>0)
			im_data_seq.put(im_data,rcpt._header.size_h);

		rcpt.init((acom::IOVectSeq*)&im_data_seq,iov,rcpt._header.iovsz_d,_net);
		dbg.log("process","receipt initilized works on defered data\n"); 
    void* ctxt =0;
		switch(rcpt._header.protocol)
		{
			case acom::Network::P_AM :// AM  Allocate + copy defered data  + call + free 
				//  intialize  the iovector ( block & size)
				dbg.log("process","AM message process allocate & read the iov of defered data\n");
				data_to_read=rcpt._header.size_d;
				for(int i=0; i<rcpt._header.iovsz_d; i++)
				{
					iov[i].data=_net->allocate_data(iov[i].len);
					// block recv 
					if(link->_sock->readn( iov[i].data,iov[i].len)<0)
					{
						//link->unlock();
						return -1;
					}
					data_to_read-=iov[i].len;
					dbg.log("process","read %d data of iov len %d\n",i,iov[i].len);
					//dbg.Xmem(iov[i].data,iov[i].len);
					dbg.log("process","defered data allocation & read completed\n");    
				}
				if(data_to_read>0)
				{
					dbg.log("process","BAD SIZE MESSAGE DETECTED ....... clean\
										the network\n");
					if(clean_link(link,data_to_read)<0)
					{
						//link->unlock();
						return -1;
					}
				}
				//read completed unlock sock mutex
				//link->unlock();
				// call service
				//if for all redirect before!!
				if(rcpt._header.dst==InfoTCPnet::ALL)
				{	// YES IT'S FOR ALL
					bcast(link,&rcpt,iov,iov_dsz,im_data);
				}
				dbg.log("process","try to call the service\n");
				try
				{
					s=acom::Service::Manager.resolv(rcpt._header.id);
					s->call(acom::ComFailure::OK, &rcpt,&rcpt._header,iov,rcpt._header.iovsz_d,ctxt);
				}
				catch(const PTH::RuntimeError &e)
				{
					dbg.log("WARNING","service number %d unkown by Service Manager\n[%s]\n",rcpt._header.id,e.what());
					return -1;
				}
				dbg.log("process","AM service called completed\n");
				/// free blocks
				for(int i=0; i<rcpt._header.iovsz_d; i++){
					_net->deallocate_data( iov[i].data);
				}
				break;
			case acom::Network::P_AWS://AWS  Allocate + copy defered data  + call ( not free)
				//  intialize  the iovector ( block & size)
				//dbg.log("process","AWS message process allocate & read the iov of defered data\n");
				data_to_read=rcpt._header.size_d;
				for(int i=0; i<rcpt._header.iovsz_d; i++)
				{
					iov[i].data=_net->allocate_data(iov[i].len);
					// block recv 
					if(link->_sock->readn( iov[i].data,iov[i].len)<0)
					{
						//link->unlock();
						return -1;
					}
					data_to_read-=iov[i].len;
					//dbg.log("process","read %d data of iov len %d\n",i,iov[i].len);
					//dbg.Xmem(iov[i].data,iov[i].len);
					//dbg.log("process","defered data allocation & read completed\n");    
				}
				if(data_to_read>0)
				{
					//dbg.log("process","BAD SIZE MESSAGE DETECTED ....... clean\
										the network\n");
					if(clean_link(link,data_to_read)<0)
					{
						//link->unlock();
						return -1;
					}
				}
				//read completed unlock sock mutex
				//link->unlock();
				// call service
				//if for all redirect before!!
				if(rcpt._header.dst==InfoTCPnet::ALL)
				{	// YES IT'S FOR ALL
					bcast(link,&rcpt,iov,iov_dsz,im_data);
				}
				//dbg.log("process","try to call the service\n");
				try
				{
					s=acom::Service::Manager.resolv(rcpt._header.id);
					s->call(acom::ComFailure::OK, &rcpt,&rcpt._header,iov,rcpt._header.iovsz_d,ctxt);
				}
				catch(const PTH::RuntimeError &e)
				{
					//dbg.log("WARNING","service number %d unkown by Service Manager\n[%s]\n",rcpt._header.id,e.what());
					return -1;
				}
				//dbg.log("process","AWS service called completed\n");
				// blocks must be freed later by applicationthrough deallocate_data
				break;
			case  acom::Network::P_WS :
				//dbg.log("process","WS message process call get_iovector & read the iov of defered data\n");
				// call get iovect . Service MUST complete the IOvector
				
				try
				{
					s= acom::Service::Manager.resolv(rcpt._header.id);
					ctxt = s->get_iovect(&rcpt,&rcpt._header,iov,rcpt._header.iovsz_d);
				}
				catch(...)
				{
					//dbg.log("WARNING","service number %d CAN'T CALL GETIOVECT\n",rcpt._header.id);
					return -1;
				}
				data_to_read=rcpt._header.size_d;
				for(int i=0; i<rcpt._header.iovsz_d; i++)
				{
					// block recv 
					if(link->_sock->readn( iov[i].data,iov[i].len)<0)
					{
						//link->unlock();
						return -1;
					}
					data_to_read-=iov[i].len;
					//dbg.log("process","read %d data of iov len %d\n",i,iov[i].len);
					//dbg.Xmem(iov[i].data,iov[i].len);
					//dbg.log("process","defered data allocation & read completed\n");    
				}
				if(data_to_read>0)
				{
					//dbg.log("process","BAD SIZE MESSAGE DETECTED ....... clean\
										the network\n");
					if(clean_link(link,data_to_read)<0)
					{
						//link->unlock();
						return -1;
					}
				}
				//read completed unlock sock mutex
				//link->unlock();
				// call service
				//if for all redirect before!!
				if(rcpt._header.dst==InfoTCPnet::ALL)
				{	// YES IT'S FOR ALL
					bcast(link,&rcpt,iov,iov_dsz,im_data);
				}
				//dbg.log("process","try to call the service\n");
				try
				{
					s->call(acom::ComFailure::OK, &rcpt,&rcpt._header,iov,rcpt._header.iovsz_d,ctxt);
				}
				catch(const PTH::RuntimeError &e)
				{
					//dbg.log("WARNING","service number %d unkown by Service Manager\n[%s]\n",rcpt._header.id,e.what());
					return -1;
				}
				dbg.log("process","WS service called completed\n");
				break;
			default : break;
		}
		im_data_seq.destroy();
		rcpt.finish();
		free(im_data);
		free(iov);
		free(iov_dsz);

	}
	else
  {	// IT'S NOT FOR ME :-(
		//redirect the message 
		//std::cout<<"ROUTEUR recoi un nouveau message C' EST PAS POUR MOI SNIF"<<std::endl;
		//dbg.log("process","incoming message is not for me redirect it\n"); 
		int dest;
		if(rcpt._header.dst < info.route_table.size())
		{
			dest = info.route_table[rcpt._header.dst];
		}else
			dest =-1;
		//dbg.log("process","redirect message to %d\n",info.all_links[dest]._peer); 
		if(dest!=-1 && info.all_links[dest]._peer!=link->_peer && info.all_links[dest]._sock!=NULL && info.all_links[dest]._sock->valid())
		{
			int sizetodo=rcpt._header.size_h + rcpt._header.size_d + 
							(sizeof(size_t)*rcpt._header.iovsz_d);
			//dbg.log("process","redirect message begin size of msg %d\n",sizetodo); 
			int nbread=0;   
			info.all_links[dest].lock();
			info.all_links[dest]._sock->writen(&rcpt._header,sizeof(acom::Network::Header));
			//dbg.log("process","redirect message  header sent \n"); 
			//dbg.log("process","REDIRECTED HEADER:\nim data sz: %d\ndef data sz: \
						%d\ndest : %d\nproto : %d\nservice id : %d\niovd sz : %d\nemet : %d\nno :%d\
						\n",rcpt._header.size_h,rcpt._header.size_d,rcpt._header.dst,rcpt._header.protocol,rcpt._header.id,rcpt._header.iovsz_d,rcpt._header.src,rcpt._header.no);

			for(;sizetodo>0;)
			{
				nbread=link->_sock->readn(receive_buffer,sizetodo>MAXBUF ? MAXBUF : sizetodo);
				if(nbread<0)
				{
					info.all_links[dest].unlock();
					return -1;
				}
				info.all_links[dest]._sock->writen(receive_buffer,nbread);
					//dbg.log("process","WARNING in redirection msg write problem\n");;
				sizetodo-=nbread;
			}
			info.all_links[dest].unlock();
			//dbg.log("process","redirect message completed\n"); 

		}
		
		else // free the net
		{
			int sizetodo=rcpt._header.size_h + rcpt._header.size_d + 
							(sizeof(size_t)*rcpt._header.iovsz_d);
			int nbread=0;
			for(;sizetodo>0;)
			{
				nbread=link->_sock->readn(receive_buffer,sizetodo>MAXBUF ? MAXBUF : sizetodo);
				if(nbread<=0)
				{
					//link->unlock();
					return -1;
				}
				sizetodo-=nbread;
			}
		}
		//link->unlock();
		rcpt.finish();
	}
	// end of reception
	//dbg.log("process","COMPLETED CORRECTLY\n");
	return 1;
}
