// Authors: Mareschal arnaud, Menetrieux Marie-Laure
/*
 * The contents of this file are subject to the Dyade Public License,
 * as defined by the file DYADE_PUBLIC_LICENSE.TXT
 *
 * You may not use this file except in compliance with the License. You may
 * obtain a copy of the License on the Dyade web site (www.dyade.fr).
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 *
 *
 *
 * The Initial Developer of the Original Code is Dyade. The Original Code and
 * portions created by Dyade are Copyright Bull and Copyright INRIA.
 * All Rights Reserved.
 */
/* Copyright (c) 1997 by Groupe Bull. Read the COPYRIGHT file. */
/* $Id: */
/* Author: Cyrille.Martin@imag.fr */

/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __TCPBARRIER_H
#define __TCPBARRIER_H

#include <acom>
#include <pth>
#include <time.h>
#define TIME_OUT 10

namespace BARRIER_NAMESPACE {

struct ack_info {
    int rank;
    int size;
};

class Barrier
{
 public:
  Barrier(acom::Network* net_);
  int initialize() throw (acom::NetworkError);
  int commit()throw (acom::NetworkError);
  int terminate()throw (acom::NetworkError);
  ~Barrier();
  int sync();
  void receipt_ack();
  void waitall();

 private:
 void sendack();
class ServAckBarrier:public acom::ServiceAM {
public:

 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Class AckBarrier

/** Constructor
  */
  ServAckBarrier::ServAckBarrier(Barrier * bar){
  _barrier = bar;
   }
  void ServAckBarrier::call (
	     acom::ComFailure::Code e,
	     AC::Network::Receipt* receipt,
      	     acom::Network::Header* h,
	     acom::IOVectEntry* iov,
	     acom::IOVectSize   iov_sz, void* ctxt
	     ) throw (acom::ComFailure)
  {

                     _barrier->receipt_ack();

  }
  protected :
        Barrier * _barrier;

};//end class AckBarrier
class ServBarrier:public acom::ServiceAM {
public:

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Class Barrier

/** Constructor
  */
  ServBarrier::ServBarrier(Barrier * bar){
  _barrier = bar ;
   }
  void ServBarrier::call (
	     acom::ComFailure::Code e,
	     AC::Network::Receipt* receipt,
      	     acom::Network::Header* h,
	     acom::IOVectEntry* iov,
	     acom::IOVectSize   iov_sz, void* ctxt
	     ) throw (acom::ComFailure)
  {

        _barrier->waitall();

  }

protected :
        Barrier * _barrier;

  //end class Servbarrier
} ;

public :
  ServBarrier * ServiceBarrier;
  ServAckBarrier * ServiceAckBarrier;


  int _count_barrier;
  int _barrier_state;
  acom::Network * net;
  PTH::Mutex mutex;
  PTH::Condition cond;
  timespec time_out;

};
}; /*end namespace BARRIER_NAMESPACE */
#endif /* __TCPBARRIER_H */
