//
// $Id: testAllToAllDyn.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// ralise un All to all sur un rseau TCP_net secondaire statique
//
// 
#include <cstring>
#include <cstdio>
#include <acom>
#include <acom_tcp_net.h>
#include <spread_net.h>
#include <sock>
#include <pth>
#include <debuglog.h>

namespace AC = acom;
static volatile bool term = false;
static AC::Network* net=0;
static int nbMsgRecu = 0;
int nbNodes = -1;

timeval time_init;
timeval time_term;


class Msg: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,    
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
        nbMsgRecu++;
	if ( nbMsgRecu == net->node_count()-1 ){
		term = true;
	}
  }
};

static Msg message;


int doit (int argc, char* argv[])
{
  // INITIALISATION avec secondaire
  Spread::Network Primaire;
  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Primaire.initialize( &argc,&argv );
  if (Secondaire.initializeDynamic( 0,&argv,&Primaire )<0){
  	Primaire.commit();
 	std::cout<<"node "<<net->rank()<<"erreur lors de l'init "<<std::endl;
  }
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 5, &message);
  net = &Secondaire;
  if(Primaire.commit()<0)
  {
      std::cerr<<"rshp can't connect several host :"<<std::endl;
      Primaire.print_rejected();
  }
  nbNodes = Primaire.node_count();
  /*******/ if (net->rank() == 0){gettimeofday(&time_init,0);} /******/

  Secondaire.commit();


  AC::Network::OutChannel* channel;
  int recepteur = 0;

	for (int remote = 0; remote <net->node_count() ;remote++){
		if (net->rank() != remote)
		{
	 		// Get a channel:
			AC::ActiveMessage<Msg> am (net, &message, 0);
			try{
				channel = net->get_default_route(remote);
		   		am(channel);
    			}catch(...){
 		    		std::cout<<"node "<<net->rank()<<"TEST : exception "<<std::endl;
			}
   		}
 	}


  while (!term)
  {
	usleep( 1000 );
  }


  Primaire.barrier();
  /*******/if (net->rank() == 0){gettimeofday(&time_term,0);} /******/

  if (net->rank()==0)
  {
	  std::cout<<"AllToAllDyn "<<nbNodes<<" "<<(double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec)<<std::endl;
  }

  Secondaire.terminate();
  dbg.log("TCP_net","apres terminate secondaire\n");
  Primaire.terminate();
}

int main (int argc, char* argv[])
{
 return	doit(argc, argv);
}
