//
// $Id: testInitDyn.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <cstring>
#include <cstdio>
#include <acom>
#include <acom_tcp_net.h>
#include <spread_net.h>
#include <sock>
#include <pth>


 namespace AC = acom;
static int rank = -1;
static volatile bool isterm = false;
  AC::Network* net = 0;

class AckService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
        std::cout << "!!! TEST : node : "<<h->dst <<"  :: ACK: reception d'un AM "<<std::endl;

   if (e != AC::ComFailure::OK)
       std::cout << "TEST : Error" << std::endl;

    isterm = true;

  }
};

static AckService ack_service;

int doit (int argc, char* argv[])
{

  // TCP_NET_NAMESPACE::tcp_net Primaire;
  Spread::Network Primaire;
  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Primaire.initialize( &argc,&argv );
  Secondaire.initializeDynamic( 0,&argv,&Primaire );
 //  Secondaire.initialize( 0,&argv,&Primaire );
 AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 4, &ack_service);
  Primaire.commit();
  Secondaire.commit();


  AC::Network* netPrim = &Primaire;

  rank = netPrim->rank();
  int node_count = netPrim->node_count();



  std::cout<<"node "<<rank<<" : "<<"TEST : Initialisation et commit -> Ok"<<std::endl;

  net = &Secondaire;
  AC::Network::OutChannel* channel;
  if (rank ==0)
  {
     // Get a channel:

   AC::ActiveMessage<AckService> am (net, &ack_service, 0);

   try{

	int n = 1;
	net->open_channel(n);
	channel = net->get_default_route(n);
        am(channel);

     }catch(...){
      std::cout<<"node "<<rank<<" : "<<"TEST : exception souleve!!!!!!!!!!!!!!!"<<std::endl;
   }
  }
/*sleep(5);*/

  if (rank ==1)
  {
     // Get a channel:

   AC::ActiveMessage<AckService> am (net, &ack_service, 0);

   try{

	int n = 0;
	//si les AM se croisent deux lisaisons seront ouvertes
	//le noeuds ecouteront les deux liaisons
	//mais chaque noeud ecrira toujours sur la meme
	net->open_channel(n);
	channel = net->get_default_route(n);
        am(channel);

     }catch(...){
      std::cout<<"node "<<rank<<" : "<<"TEST : exception souleve!!!!!!!!!!!!!!!"<<std::endl;
   }
  }
  
  if (rank == 0||rank == 1)
   {
   	std::cout<<"node "<<rank<<" : "<<"TEST : en attente de recpetion de l'am"<<std::endl;
   	while (!isterm)
     	{
		usleep( 1000 );
   	}
   }


   Secondaire.terminate();
   std::cout << "node "<<rank<<" : "<<"*****    TEST : Ready to Terminate   *****" << std::endl;
   Primaire.terminate();
}

int main (int argc, char* argv[])
{
    return doit(argc, argv);
}
