//
// $Id: testInitSec.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <cstring>
#include <cstdio>
#include <acom>
#include <acom_tcp_net.h>
#include <spread_net.h>
#include <sock>
#include <pth>

 namespace AC = acom;
static int rank = -1;
static volatile bool isterm = false;

class AckService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
        std::cout << "!!! TEST : node : "<<h->dst <<"  :: ACK: reception d'un AM "<<std::endl;
  	char* buf = (char*)malloc(7);//"p non recu";
    	receipt->unpack(buf,7);
	std::cout<<"TEST : message recu pack: "<<buf<<std::endl;
	std::cout<<"TEST : taille iov : "<<iov_sz<<std::endl;
	std::cout<<"TEST : message recu put: "<<(char*) iov[0].data<<std::endl;
	std::cout<<"TEST : taille message recu put: "<<iov[0].len<<std::endl;

   if (e == AC::ComFailure::OK)
       std::cout << " TEST : No Error" << std::endl;
    else
       std::cout << "TEST : Error" << std::endl;
    std::cout << "!!! TEST : node : "<<h->dst <<"fin reception"<<std::endl;
    isterm = true;

  }
};

static AckService ack_service;

int doit (int argc, char* argv[])
{

  // TCP_NET_NAMESPACE::tcp_net Primaire;
  Spread::Network Primaire;
  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Primaire.initialize( &argc,&argv );
  Secondaire.initialize( 0,&argv,&Primaire );
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 4, &ack_service);
  Primaire.commit();
  Secondaire.commit();


  AC::Network* netPrim = &Primaire;

  rank = netPrim->rank();
  std::cout<<"TEST : My rank = "<<rank<<std::endl;
  int node_count = netPrim->node_count();
  std::cout<<"node "<<rank<<" : "<<"TEST : Initialisation et commit du primaire -> Ok"<<std::endl;
  //sleep(2);//a remplacer par une barriere



  std::cout<<"node "<<rank<<" : "<<"TEST : Initialisation et commit du secondaire -> Ok"<<std::endl;

  AC::Network* netSec = &Secondaire;
  AC::Network::OutChannel* channel;
  if (rank ==1)
  {
     // Get a channel:

   AC::ActiveMessage<AckService> am (netSec, &ack_service, 0);

   try{

       	char* buf = "put marche !!!";
	am->put(buf, 14*sizeof(char));
	char* bufpack = "pack ok";
	am ->pack(bufpack,7);
	int n = 0;
	channel = netSec->get_default_route(n);
        am(channel);

     }catch(...){
      std::cout<<"node "<<rank<<" : "<<"TEST : exception souleve!!!!!!!!!!!!!!!"<<std::endl;
   }
  }

  if (rank == 0)
   {
   	std::cout<<"node "<<rank<<" : "<<"TEST : en attente de recpetion de l'am"<<std::endl;
   	while (!isterm)
     	{
		usleep( 1000 );
   	}
   }


	//sleep(10);
   Secondaire.terminate();
   std::cout << "node "<<rank<<" : "<<"*****    TEST : Ready to Terminate   *****" << std::endl;
   Primaire.terminate();
}

int main (int argc, char* argv[])
{
    return doit(argc, argv);
}
