//
// $Id: testPingPong.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <cstring>
#include <cstdio>
#include <acom>
#include <acom_tcp_net.h>
#include <spread_net.h>
#include <sock>
#include <pth>

namespace AC = acom;
static volatile bool pingRecu = false;
static volatile bool pongRecu = false;
static AC::Network* net=0;
static int nbPing=500;


class PongService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
        std::cout << "Node "<<h->dst <<" : Reception pong n"<<*(int*) iov[0].data<<std::endl;
	if (e != AC::ComFailure::OK)
		std::cout << "TEST : Error" << std::endl;
	pongRecu = true;
  }
};

static PongService pong;

class PingService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
        std::cout << "Node "<<h->dst <<" : Reception ping n"<<*(int*) iov[0].data<<std::endl;
	AC::Network::OutChannel* channel;
	AC::ActiveMessage<PongService> am (net, &pong, 0);
	try{
		channel = net->get_default_route(h->src);
     		am->put(iov[0].data,sizeof(int));
		am(channel);
	}catch(...){
	     std::cout<<"node "<<net->rank()<<" : "<<"TEST : exception souleve lors de l'envoi du pong"<<std::endl;
	}

	if (e != AC::ComFailure::OK)
		std::cout << "TEST : Error" << std::endl;
	//if (*(int*) iov[0].data == nbPing) {pingRecu = true;}
	pingRecu = true;
  }
};

static PingService ping;

int doit (int argc, char* argv[])
{

  /*// INITIALISATION avec primaire*/
  TCP_NET_NAMESPACE::tcp_net Primaire;
  Primaire.initialize( &argc,&argv );
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 4, &ping);
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 5, &pong);
  net = &Primaire;
  Primaire.commit();/**/


/*// INITIALISATION avec secondaire
  Spread::Network Primaire;
  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Primaire.initialize( &argc,&argv );
  Secondaire.initialize( 0,&argv,&Primaire );
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 4, &ping);
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 5, &pong);
  net = &Secondaire;
  Primaire.commit();
  Secondaire.commit();/**/

  std::cout<<"node "<<net->rank()<<" : "<<"Initialisation et commit -> Ok\n\n\n"<<std::endl;

  AC::Network::OutChannel* channel;

for (int i = 0;i<nbPing;i++){

	pingRecu = false;
	pongRecu = false;
	if (net->rank() == 0)
  	{
		// Get a channel:
		AC::ActiveMessage<PingService> am (net, &ping, 0);
		try{
			channel = net->get_default_route(1);
		   	am->put(&i,sizeof(int));
			am(channel);
	    }catch(...){
	 	     std::cout<<"node "<<net->rank()<<" : "<<"TEST : exception souleve!!!!!!!!!!!!!!!"<<std::endl;
	   }
  	}

  	if (net->rank() == 1 && !pingRecu)
 	 {
  	 	std::cout<<"node "<<net->rank()<<" : "<<"TEST : en attente de recpetion du ping"<<std::endl;
  	 	while (!pingRecu)
    	 	{
			usleep( 1000 );
	   	}
  	}

  	if (net->rank() == 0 && !pongRecu)
  	{
  	 	std::cout<<"node "<<net->rank()<<" : "<<"TEST : en attente de recpetion du pong"<<std::endl;
  	 	while (!pongRecu)
  	   	{
			usleep( 1000 );
	   	}
	  }
}

  //Secondaire.terminate();
  std::cout << "\n\n\nnode "<<net->rank()<<" : "<<"*****    TEST : Ready to Terminate   *****" << std::endl;
  Primaire.terminate();
}

int main (int argc, char* argv[])
{
   return doit(argc, argv);
}
