//
// $Id: testam.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <taktuknetwork.h>
#include <TCP_network.h>
#include <pth>

namespace AC = acom;

static int rank = -1;
static PTH::CountDown isterm;

class AckService: public AC::ServiceAM {
public:
  void call ( 
	     AC::ComFailure::Code e,      // if any 
	     acom::Network::Receipt* receipt,
	     AC::Network::Header* h,
	     AC::IOVectEntry* iov,
	     AC::IOVectSize   iov_sz,
	     void * ctx
	     ) throw (AC::ComFailure)
  {
    std::cout << ":: ACK: ";
    if (e == AC::ComFailure::OK) 
      {
	std::cout << " No Error iov0 = "<<(char*)iov[0].data << std::endl;
	char toto[8];
	receipt->unpack(toto,8);
	std::cout << "Im data = "<<toto << std::endl;
	
      }
    else 
      std::cout << "Error" << std::endl;
    --isterm;
  }
};

static AckService ack_service;

int doit (int argc, char* argv[])
{
  PTH::Pth::initialize();
  PTH::Pth::commit();
  AC::Service::Manager.bind (10, 2, &ack_service);
  char* toto="coucou\n";

  Taktuk::Network* primary_net = new Taktuk::Network();
  TCP_NET::tcp_net* secondary_net = new TCP_NET::tcp_net();
  
  primary_net->initialize(&argc,&argv);
  secondary_net->initialize(&argc,&argv,primary_net);
  primary_net->commit();
  secondary_net->commit();
  
  isterm.init(secondary_net->node_count()-1);
  primary_net->barrier();
  std::cout<<"MAIN BEGIN node count = "<<secondary_net->node_count()<<std::endl; 
  
  rank = secondary_net->rank();
  
  std::cout<<"send a msg to all other node"<<std::endl;
  
  //std::cout << "Service as number=" << ack_service.get_id() << std::endl;
  for (int n=0; n < secondary_net->node_count(); ++n)
    {
      /* Get a channel:
       */
      if(n!=rank) // not send it to me
	{
	  std::cout << "Request for a channel to "<<n<<": rank is=" << rank << std::endl;
	  AC::Network::OutChannel* channel = secondary_net->get_default_route(n);
	  std::cout << "Got a channel to "<<n<<": rank is=" << rank <<" OK :-)"<< std::endl;
	  AC::ActiveMessage<AckService> am (secondary_net, &ack_service, 0);
	  am->put(toto,8);
	  am->pack(toto,8);
	  am(channel);
	  //			std::cout << "SEND MESSAGE to "<<n<<": rank is=" << rank <<" OK :-)"<< std::endl;
	}
    }
  std::cout << "Waiting for messages" << std::endl;
  isterm.wait();
  // - wait calling of PING
  std::cout << "Ready to Terminate" << std::endl;
  
  secondary_net->terminate( );
  primary_net->terminate();
  delete secondary_net;
  delete primary_net;
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (...){
    std::cerr << "Unknown exception" << std::endl;
  }
}
