//
// $Id: testam0.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <cstring>
#include <cstdio>
#include <acom>
#include <acom_tcp_net.h>
#include <sock>
#include <pth>

 namespace AC = acom;
static int rank = -1;
static volatile bool isterm = false;

class AckService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    std::cout << "node : "<<rank <<"  :: ACK: reception d'un AM ";
    if (e == AC::ComFailure::OK)
       std::cout << " No Error" << std::endl;
    else
       std::cout << "Error" << std::endl;
    isterm = true;
  }
};

static AckService ack_service;

int doit (int argc, char* argv[])
{
   TCP_NET_NAMESPACE::tcp_net toto;

   rank = atoi( argv[1]);
   std::cout<<"My rank = "<<rank<<std::endl;

  toto.initialize( &argc,&argv );
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 4, &ack_service);
  toto.commit();
  AC::Network* net = &toto;

    //attente que la connexion soit realise
   if (rank ==0)
  {
     // Get a channel:

      int n = 1;
      AC::Network::OutChannel* channel = net->get_default_route(n);
      AC::ActiveMessage<AckService> am (&toto, &ack_service, 0);

   try{

       am(channel);

     }catch(...){
      std::cout<<"exception souleve!"<<std::endl;
   }
  }

  if (rank ==1)
   {
   	std::cout<<"en attente de recpetion de l'am"<<std::endl;
   	while (!isterm)
     	{
		usleep( 1000 );
   	}
   }

   toto.terminate();
   std::cout << "Ready to Terminate" << std::endl;

}

int main (int argc, char* argv[])
{

    return doit(argc, argv);


}
