                                                                                                                                                                         //
// $Id: testam1_n_tcp_net.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a ping pong from node 0 with all the other nodes
//
// arguments : longueur du message en Ko, taille max en Ko, taille de l'augmentation a chaque passage en Ko,nombre d'itrations
#include "acom"
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <spread_net.h>
#include <iostream>
#include <iomanip>
#include <fstream.h>
#include <acom_tcp_net.h>
#include <sys/time.h>

namespace AC = acom;
 #define SECPERUSEC 1000000

static int rank = -1;
static volatile bool isterm = false;
static volatile int count_ping = 0;
static volatile int count_pong = 0;
Spread::Network *Primaire;
TCP_NET_NAMESPACE::tcp_net *net;

static int SIZE_MAX = 0; // - in bytes
static int ITER_PING;
void * msg;


std::ofstream fileStream;
pthread_mutex_t mutex;
pthread_cond_t cond;

double tim;
struct timeval time1,time2;
double t1,t2;

class PongService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {


    pthread_mutex_lock(&mutex);
    isterm = true;
    pthread_cond_signal(&cond);
    pthread_mutex_unlock(&mutex);
  }
};

static PongService pong;

class PingService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {

     if (e == AC::ComFailure::OK){
          char * toto ="cou ping";
           try{

                ++count_ping;

                if (count_ping == ITER_PING) {
                        AC::Network::OutChannel* channel = net->get_default_route(h->src);
                        AC::ActiveMessage<PongService> am (net, &pong, 0);
                        am->put(toto,8);
                        am(channel);
                        count_ping =0;
                        pthread_mutex_lock(&mutex);
                        isterm = true;
                        pthread_cond_signal(&cond);
	          pthread_mutex_unlock(&mutex);
                }
           }catch(...){
	     std::cout<<"node "<<net->rank()<<" : "<<"TEST : exception souleve lors de l'envoi du pong"<<std::endl;
          }
    }

  }
};

static PingService ping;

 int initFile (int i)
{


                char  arg[3];
                sprintf(arg,"%i",i);
                char file_name[50];
                char * var ;
                var ="RESULT_TEST";
                char *  path = getenv(var);
                if (path != NULL)
                        strcpy(file_name,  path);
                strcat(file_name,"/node1_n");
                strcat(file_name,  arg);
                fileStream.open(file_name,ofstream::app) ;
                if (fileStream.is_open()){
                            return 0;
	        }
	  return -1;
}

 void waitack()
{
	pthread_mutex_lock(&mutex);

	while(!isterm)
		pthread_cond_wait(&cond,&mutex);

	isterm=false;
	pthread_mutex_unlock(&mutex);
}

int doit (int len)
{
        char* toto="coucou\n";
        size_t size;
        size = len;
        msg = malloc(size);
        std::cout << "Got a channel to 1: rank is=" << rank << std::endl;
        if (rank== 0)
        {

                                        /* Get a channel:                                                         */
               gettimeofday(&time1,NULL);
                t1= ((double)time1.tv_sec)*((double)SECPERUSEC) + (double)time1.tv_usec;
                for (int n=1; n < net->node_count(); ++n)
              {
                      for (int k=0; k < ITER_PING; ++k)
                      {
                                  AC::Network::OutChannel* channel = net->get_default_route(n);
                                AC::ActiveMessage<PingService> am (net, &ping, 0);
                                am->put(msg,size);
                                am(channel);
                      }
                }
        }
        waitack();
        if (rank == 0)
        {
               gettimeofday(&time2,NULL);
                t2= ((double)time2.tv_sec)*((double)SECPERUSEC)+ (double)time2.tv_usec;
                tim = (t2-t1);

        }
// - wait calling of PING
        free(msg);
}

int main (int argc, char* argv[])
{
        Primaire = new Spread::Network();
        net = new TCP_NET_NAMESPACE::tcp_net();
        Primaire->initialize( &argc,&argv );
        net->initialize(0,&argv,Primaire);
        AC::Service::Manager.bind (15,15, &ping);
        AC::Service::Manager.bind (15,16, &pong);

        rank = net->rank();
        int len = 0;
        double deb;
        len = atoi(argv[1]);
        SIZE_MAX  = atoi(argv[2]);//16384;
        int stride =  atoi(argv[3]);//1024;
        ITER_PING = atoi(argv[4]);// 100;
        Primaire->commit();
        net->commit();
        try {


                if (rank ==0)
                {
                         int crea = initFile(rank);
                }

                while (len<=SIZE_MAX)
                {
                        std::cout<<"passage dans le while len ="<<len<<std::endl;
                        doit(len*1024);
                        isterm=false;
                        tim =((double)time2.tv_sec)*((double)SECPERUSEC)+(double)time2.tv_usec
                                        - ((double)time1.tv_sec)*((double)SECPERUSEC)-(double)time1.tv_usec;
                        tim =(tim / ((double)SECPERUSEC))/ITER_PING;
                        if (rank ==0)
                         {
                                fileStream
                                        << std::setw(15) << std::setfill(' ') << (double)len
                                        <<std::setw(20) << std::setfill(' ')<<tim<<"\n";

                        }
                        len+=stride;

                }
                if (rank==0)
                {

                        fileStream.close();

                }
                std::cout << "Ready to Terminate" << std::endl;
                net->terminate( );
                Primaire->terminate();
        }
        catch (...) {
        std::cerr << "Unknown exception" << std::endl;
        }
        pthread_cond_destroy(&cond);
        pthread_mutex_destroy(&mutex);
}
