                                                                                                                                     //
// $Id: testamn_1_tcp_net.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//

// arguments : longueur du message en Ko, nombre d'itrations
// test active message: a ping pong from all nodes to node 0
// tous les noeuds de 1  n mesure le temps mis par le ping pong
// ils stocke ce temps dans un tableau et le renvoi au noeud 1
//Le noeud 1 ecrira toutes ces mesures dans un fichier.
//
#include "acom"
#include <stdlib.h>
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <spread_net.h>
#include <iostream>
#include <iomanip>
#include <fstream.h>
#include <sys/time.h>
#include <acom_tcp_net.h>
#include <vector>

namespace AC = acom;
 #define SECPERUSEC 1000000

static int rank = -1;
static volatile bool isterm = false;
static volatile int count_pong = 0;
static volatile int count = 0;
static volatile int count_time = 0;
Spread::Network *Primaire;
TCP_NET_NAMESPACE::tcp_net *net;
std::vector<int> count_ping;

pthread_mutex_t mutex;
pthread_cond_t cond;


static int ITER_PING;
void * msg;


std::ofstream fileStream;
double tim;
struct timeval time1,time2;
double t1,t2;


class MesureService: public AC::Service{
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
   //recoit un tableau d'un noeud et crit ce tableau dans un fichier
        count_time++;
        //on rcupre les donnes
        double toto (*(double*) iov->data);
        fileStream
                                        << std::setw(15) << std::setfill(' ') << ((int)h->src)
                                        <<std::setw(20) << std::setfill(' ')<< toto << "\n";

        if (count_time == net->node_count() -1 )
        {
                isterm = true;
        }

  }

};
  static MesureService mesure;

class PongService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {

                pthread_mutex_lock(&mutex);
                isterm = true;
	 pthread_cond_signal(&cond);
	 pthread_mutex_unlock(&mutex);


  }
};

static PongService pong;

class PingService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {

     if (e == AC::ComFailure::OK){
          char  toto[10];
          strcpy(toto,"cou ping");
           try{


                ++count_ping[h->src-1];

                if (count_ping[h->src-1] == ITER_PING) {
                        char * argv;
                        //int sprint = sprintf(argv,"%i",count);

                        //strcat(toto,  argv);
                        AC::Network::OutChannel* channel = net->get_default_route(h->src);
                        AC::ActiveMessage<PongService> am (net, &pong, 0);
                        am->put(toto,9);
                        am(channel);
                        count_ping[h->src-1] =0;
                        count++;

                }

                if (count == net->node_count()-1)
                {
                        pthread_mutex_lock(&mutex);
                        isterm = true;
	          pthread_cond_signal(&cond);
	          pthread_mutex_unlock(&mutex);
                }

           }catch(...){
	     std::cout<<"node "<<net->rank()<<" : "<<"TEST : exception souleve lors de l'envoi du pong"<<std::endl;
          }
    }

  }
};

static PingService ping;

 int initFile (int i,int len)
{


                char  arg[3];
                char  arg_len[10];
                sprintf(arg,"%i",i);
                sprintf(arg_len,"%i",len);
                char file_name[50];
                char * var ;
                var ="RESULT_TEST";
                char *  path = getenv(var);
                if (path != NULL)
                        strcpy(file_name,  path);
                strcat (file_name,"/noden_1");
                strcat(file_name,  "_");
                strcat(file_name,  arg_len);
                fileStream.open(file_name,ofstream::app) ;
                if (fileStream.is_open()){
                        return 0;
	}
	return -1;
}
 void waitack()
{
	pthread_mutex_lock(&mutex);

	while(!isterm)
		pthread_cond_wait(&cond,&mutex);

	isterm=false;
	pthread_mutex_unlock(&mutex);
}

int doit (int len)
{
        size_t size;
        size = len;
        msg = malloc(size);
        if (rank!= 0)
        {

                                        /* Get a channel:                                                         */
               gettimeofday(&time1,NULL);
                t1= ((double)time1.tv_sec)*((double)SECPERUSEC) + (double)time1.tv_usec;
               for (int k=0; k < ITER_PING; ++k)
                      {
                                  AC::Network::OutChannel* channel = net->get_default_route(0);
                                AC::ActiveMessage<PingService> am (net, &ping, 0);
                                am->put(msg,size);
                                am(channel);
                      }


        }


        waitack();

        if (rank != 0)
        {
               gettimeofday(&time2,NULL);
                t2= ((double)time2.tv_sec)*((double)SECPERUSEC)+ (double)time2.tv_usec;
                tim = (t2-t1);
        }
// - wait calling of PING
        free(msg);
}

int main (int argc, char* argv[])
{

        Primaire = new Spread::Network();
        net = new TCP_NET_NAMESPACE::tcp_net();
        Primaire->initialize( &argc,&argv );
        net->initialize(0,&argv,Primaire);
        AC::Service::Manager.bind (15,15, &ping);
        AC::Service::Manager.bind (15,16, &pong);
        AC::Service::Manager.bind (15,17, &mesure);

        rank = net->rank();


         for (int i=0;i<net->node_count() - 1;i++)
                count_ping.push_back(0);
        int len = 0;
        double  * stock_time;
        double deb;
         len = atoi(argv[1]);
         ITER_PING = atoi(argv[2]);
         Primaire->commit();
        net->commit();

        try {


                if (rank ==0)
                {
                        int crea = initFile(rank,len);

                }

                        doit(len*1024);
                        count=0;

                        net->barrier();
                        std::cout<<"derrire la barrire "<<rank<<std::endl;
                        isterm=false;
                        tim =((double)time2.tv_sec)*((double)SECPERUSEC)+(double)time2.tv_usec
                                        - ((double)time1.tv_sec)*((double)SECPERUSEC)-(double)time1.tv_usec;
                        deb =len/((tim/ITER_PING)/ ((double)SECPERUSEC) );
                        if (rank !=0)
                         {
                                //rentrer les donnes mesures dans le tableau
                                stock_time=&deb;
                         }

                if (rank !=0)
                {

                         //envoyer le temps mis pour faire les itrations
                        AC::Network::OutChannel* channel = net->get_default_route(0);
                        AC::ActiveMessage<MesureService> am (net, &mesure, 0);
                        am->put(stock_time,sizeof(double));
                        am(channel);
                }
                if (rank == 0)
                {
                        //attendre les messages avec les donnes
                        while (!isterm){
                                usleep( 1000 );
                        }
                        std::cout<<"recu toutes les donnes"<<std::endl;
                        //traiter le fichier
                        fileStream.close();

                }
                std::cout << "Ready to Terminate" << std::endl;
                net->terminate( );
                Primaire->terminate();
        }
        catch (...) {
        std::cerr << "Unknown exception" << std::endl;
        }
        pthread_cond_destroy(&cond);
		pthread_mutex_destroy(&mutex);
}
