                                                                            //
// $Id: testamn_n_tcp_net.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to all node from all node
// arguments : longueur du message en Ko, nombre d'itrations
//
#include "acom"
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <iostream>
#include <sys/time.h>
#include <iomanip>
#include <spread_net.h>
#include <fstream.h>
#include <acom_tcp_net.h>
#include <vector>

using namespace std;
namespace AC = acom;

#define SECPERUSEC 1000000

static int rank = -1;
static volatile bool isterm = false;
static volatile int count_p = 0;
static volatile int count_time = 0;
static double ** matrice;
static double * tableau;
double deb;
Spread::Network *Primaire;
TCP_NET_NAMESPACE::tcp_net *net;
static std::vector<int> count_ping;
static int SIZE_MAX = 4096; // - in bytes
static volatile int ITER_PING= 1;
void * msg;

std::ofstream fileStream;

pthread_mutex_t mutex;
pthread_cond_t cond;




class MesureService: public AC::Service{
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
   //recoit un tableau d'un noeud et crit ce tableau dans un fichier

        count_time++;
        //on rcupre les donnes

        double* toto = ((double*) iov->data);
        for(int i=0;i<net->node_count();i++)
        {
                std::cout<<"src "<<h->src<<" time = "<<toto[i]<<std::endl;
        }

        // y mettre dans la matrice
//        matrice[h->src]=toto;
        for (int j=0; j< net->node_count();j++)
        {
                matrice[h->src][j]=toto[j];
        }
        if (count_time == net->node_count() -1 )
        {
                isterm = true;
        }

  }

};
static MesureService mesure;

class AckService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
	pthread_mutex_lock(&mutex);
    isterm = true;
	pthread_cond_signal(&cond);
	pthread_mutex_unlock(&mutex);
  }
};

static AckService pong;

class PingService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
     if (e == AC::ComFailure::OK){
        ++count_ping[h->src];
     }
    else
       std::cout << "Error" << std::endl;

    if (count_ping [h->src] == ITER_PING)
    {
        count_ping[h->src] =0;
        AC::Network::OutChannel* channel = net->get_default_route(h->src);
        AC::ActiveMessage<AckService> am (net, &pong, 0);
        am(channel);

    }


  }
};

static PingService ping;

int initFile (int i)
{


                char arg[3];
                sprintf(arg,"%i",i);
                char file_name[50];
                char * var ;
                var ="RESULT_TEST";
                char *  path = getenv(var);
                if (path != NULL)
                        strcpy(file_name,  path);
                strcat (file_name,"/noden_n");
                fileStream.open(file_name,ofstream::app) ;
                if (fileStream.is_open()){
                        return 0;
	}
	return -1;
}


void waitack()
{
	pthread_mutex_lock(&mutex);

	while(!isterm)
		pthread_cond_wait(&cond,&mutex);

	isterm=false;
	pthread_mutex_unlock(&mutex);
}

double debit(int node,int msgsz)
{
	size_t size=msgsz;
	char* msg = (char*)malloc(size*sizeof(char));
	struct timeval time1,time2;
	double debit=0.0;

	try{
		for (int k=0; k < ITER_PING; ++k)
        {
            gettimeofday(&time1,NULL);
        	AC::Network::OutChannel* channel = net->get_default_route(node);
            AC::ActiveMessage<PingService> am (net, &ping, 0);
            am->put(msg,size);
            am(channel);

        }
		waitack();
        gettimeofday(&time2,NULL);
		debit=((ITER_PING*msgsz)/((double)( time2.tv_sec - time1.tv_sec)+0.000001*(double)(time2.tv_usec - time1.tv_usec)))/1024; //Ko/sec
		return (debit);
	}
	catch(...){
		return 0.0;
	}
}

int doit (int len)
{
  size_t size;
  size = len;
  msg = malloc(size);

  std::cout << "C'est " << rank <<" qui s'y colle !"<< std::endl;
  //envoyer un ping a chaque noeud et mesurer le debit
  for (int n=0; n < net->node_count(); ++n)
  {
    /* Get a channel:
    */

      if (rank!= n)
      {
/*
                gettimeofday(&time1,NULL);
                t1= ((double)time1.tv_sec)*((double)SECPERUSEC)   + (double)time1.tv_usec;
                for (int k=0; k < ITER_PING; ++k)
                      {
                                AC::Network::OutChannel* channel = net->get_default_route(n);
                                AC::ActiveMessage<PingService> am (net, &ping, 0);
                                am->put(msg,size);
                                am(channel);
                      }
                while (!isterm) {
                        usleep( 1000 );
                }

                gettimeofday(&time2,NULL);
                isterm=false;
                t2= ((double)time2.tv_sec)*((double)SECPERUSEC)+ (double)time2.tv_usec;
                double time = (t2-t1);
                tim =((double)time2.tv_sec)*((double)SECPERUSEC)+(double)time2.tv_usec
                                        - ((double)time1.tv_sec)*((double)SECPERUSEC)+(double)time1.tv_usec;
                deb =len/((tim/ITER_PING)/ ((double)SECPERUSEC) );
                tim =  (tim/ITER_PING)/ ((double)SECPERUSEC);
*/
                tableau[n]=debit(n,len);
				std::cout<<"node "<<net->rank()<<" debit avec le noeud "<<n<<" = "<<tableau[n]<<std::endl;
      }
  }




}

int main (int argc, char* argv[])
{
		pthread_mutex_init(&mutex,NULL);
		pthread_cond_init(&cond,NULL);
        int len = 0;
        Primaire = new Spread::Network();
        net = new TCP_NET_NAMESPACE::tcp_net();
        Primaire->initialize( &argc,&argv );
        net->TCP_NET_NAMESPACE::tcp_net::initialize(0,&argv,Primaire);
        AC::Service::Manager.bind (15,15, &ping);
        AC::Service::Manager.bind (15,16, &pong);
        AC::Service::Manager.bind (15,17, &mesure);
        rank = net->rank();
		if(argc<3)
			std::cout<<"usage: "<<argv[0]<< "packet_size      nb_iteration   "<<std::endl;
        len = atoi(argv[1]);
        ITER_PING = atoi(argv[2]);
        tableau = (double *) calloc(net->node_count(),sizeof(double));

        for (int i=0;i<net->node_count();i++)
        {
                count_ping.push_back(0);
                tableau[i]=0;
        }

        matrice = (double ** ) calloc(net->node_count(),sizeof(double*));
        for (int j =0; j<net->node_count();j++)
        {
                matrice[j] = (double *) calloc(net->node_count(),sizeof(double));
        }
        Primaire->commit();
        net->commit();


        try {
                if (rank == 0)
               {
                        int crea = initFile(rank);
               }

               // pour chaque paire de noeuds evaluer le debit
                doit(len*1024);
                count_p=0;
                isterm = false;
                net->barrier();
                std::cout<<"derrire la barrire "<<rank<<std::endl;

                if (rank !=0)
                //envoyer nos debits au noeud 0
                {

                        AC::Network::OutChannel* channel = net->get_default_route(0);
                        AC::ActiveMessage<MesureService> am (net, &mesure, 0);
                        am->put(tableau,sizeof(double)*net->node_count());
                        am(channel);
                }

               if (rank == 0)
               {
                        //attendre les messages avec les donnes

                        while (!isterm){
                                usleep( 1000 );
                        }
                        // rajouter sontableau dans la matrice ...
                        std::cout<<"recu toutes les donnes"<<std::endl;
                        matrice[0]=tableau;
                        for(int i=0;i<net->node_count();i++)
                        {
                                 for (int j=0; j< net->node_count();j++)
                                {
                                        std::cout<<"tableau debit du noeud "<<i<<" avec le noeud "<<j<<" = "<<matrice[i][j]<<" Ko/sec"<<std::endl;
                                }
                        }
                        //traiter le fichier
                        for (int i=0;i<net->node_count();i++)
                        {
                                for (int j=0; j< net->node_count();j++)
                                {

                                               fileStream << (double)matrice[i][j]<<"   " ;
                                }

                                fileStream<<std::endl;
                        }
                        fileStream.close();
               }

                std::cout << "Ready to Terminate " << rank<<std::endl;
                net->terminate( );
                Primaire->terminate();

        free(tableau);
        free(matrice);
        }
        catch (...) {
        std::cerr << "Unknown exception" << std::endl;
        }
		pthread_cond_destroy(&cond);
		pthread_mutex_destroy(&mutex);
}
