//
// $Id: testamn_n_temps.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to all node from all node
// arguments : longueur du message en Ko, nombre d'itrations
//
#include "acom"
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <iostream>
#include <sys/time.h>
#include <iomanip>
#include <spread_net.h>
#include <fstream.h>
#include <vector>
#include <acom_tcp_net.h>

using namespace std;
namespace AC = acom;

#define SECPERUSEC 1000000

static int rank = -1;
static volatile bool isterm = false;
static volatile int count_p = 0;
static volatile int count_time = 0;
static double ** matrice;
static double * tableau;
double deb;
Spread::Network *Primaire;
TCP_NET_NAMESPACE::tcp_net *net;
static std::vector<int> count_ping;
static int SIZE_MAX = 4096; // - in bytes
static volatile int ITER_PING= 1;
void * msg;
struct timeval time1,time2;

std::ofstream fileStream;

pthread_mutex_t mutex;
pthread_cond_t cond;




class MesureService: public AC::Service{
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
   //recoit un tableau d'un noeud et crit ce tableau dans un fichier

        count_time++;


        if (count_time == net->node_count() -1 )
        {
                isterm = true;
        }

  }

};
static MesureService mesure;

class AckService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
	count_p++;
	if (count_p == net->node_count()-1 )
	{
		pthread_mutex_lock(&mutex);
    		isterm = true;
		pthread_cond_signal(&cond);
		pthread_mutex_unlock(&mutex);
	}
  }
};

static AckService pong;

class PingService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
     if (e == AC::ComFailure::OK){
        ++count_ping[h->src];
     }
    else
       std::cout << "Error" << std::endl;

    if (count_ping [h->src] == ITER_PING)
    {
        count_ping[h->src] =0;
        AC::Network::OutChannel* channel = net->get_default_route(h->src);
        AC::ActiveMessage<AckService> am (net, &pong, 0);
        am(channel);

    }


  }
};

static PingService ping;

int initFile (int i)
{


                char arg[3];
                sprintf(arg,"%i",i);
                char file_name[50];
                char * var ;
                var ="RESULT_TEST";
                char *  path = getenv(var);
                if (path != NULL)
                        strcpy(file_name,  path);
                strcat (file_name,"/noden_n");
                fileStream.open(file_name,ofstream::app) ;
                if (fileStream.is_open()){
                        return 0;
	}
	return -1;
}


void waitack()
{
	pthread_mutex_lock(&mutex);

	while(!isterm)
		pthread_cond_wait(&cond,&mutex);

	isterm=false;
	pthread_mutex_unlock(&mutex);
}

double debit(int node,int msgsz)
{
	size_t size=msgsz;
	char* msg = (char*)malloc(size*sizeof(char));
	double debit=0.0;

	try{
		for (int k=0; k < ITER_PING; ++k)
        {

        	AC::Network::OutChannel* channel = net->get_default_route(node);
            AC::ActiveMessage<PingService> am (net, &ping, 0);
            am->put(msg,size);
            am(channel);

        }
        	return 0.0;
	}
	catch(...){
		return 0.0;
	}
}

int doit (int len)
{
  size_t size;
  size = len;
  msg = malloc(size);

  std::cout << "C'est " << rank <<" qui s'y colle !"<< std::endl;
  //envoyer un ping a chaque noeud et mesurer le debit
  for (int n=0; n < net->node_count(); ++n)
  {
    /* Get a channel:
    */

      if (rank!= n)
      {

      	debit(n,len);
      }
  }
  waitack();


}

int main (int argc, char* argv[])
{
		pthread_mutex_init(&mutex,NULL);
		pthread_cond_init(&cond,NULL);
        int len = 0;
        Primaire = new Spread::Network();
        net = new TCP_NET_NAMESPACE::tcp_net();
        Primaire->initialize( &argc,&argv );
        net->TCP_NET_NAMESPACE::tcp_net::initialize(0,&argv,Primaire);
        AC::Service::Manager.bind (15,15, &ping);
        AC::Service::Manager.bind (15,16, &pong);
        //AC::Service::Manager.bind (15,17, &mesure);
        rank = net->rank();
		if(argc<3)
			std::cout<<"usage: "<<argv[0]<< "packet_size      nb_iteration   "<<std::endl;
        len = atoi(argv[1]);
        ITER_PING = atoi(argv[2]);

        for (int i=0;i<net->node_count();i++)
        {
                count_ping.push_back(0);
        }

        Primaire->commit();
        net->commit();


        try {
                if (rank == 0)
               {
                        int crea = initFile(rank);
			gettimeofday(&time1,NULL);
               }

               // pour chaque paire de noeuds evaluer le debit
                doit(len*1024);
		Primaire->barrier();
		if (rank ==0)
		{
			double debit=0.0;
			gettimeofday(&time2,NULL);
			double tim=((double)( time2.tv_sec - time1.tv_sec)+0.000001*(double)(time2.tv_usec - time1.tv_usec))/ITER_PING;
                	fileStream << len<<" "<< tim<<std::endl;
			fileStream.close();
		}
		count_p=0;
                isterm = false;



                std::cout << "Ready to Terminate " << rank<<std::endl;
                net->terminate( );
		Primaire->terminate();


        }
        catch (...) {
        std::cerr << "Unknown exception" << std::endl;
        }
		pthread_cond_destroy(&cond);
		pthread_mutex_destroy(&mutex);
}
