/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __CONNECTOR_H
#define __CONNECTOR_H

#include <vector>
#include <string>
#include <map>
#include <pth>
#include "topology.h"
//#include <pthread.h>

#define CHAR_CTRL ''
//bachward declaration
class scheduler;

class connector
{
  
 public:
	connector(){
		PTH::Pth::initialize();
		PTH::Pth::commit();
	}
	virtual ~connector(){
		//PTH::Pth::terminate();
	}
  /**
     virtual function to connect this node to other nodes
    
   */
  virtual void run()=0;


  int connect(std::vector<topology::host*>*reject_hosts, std::string l_user,PTH::CountDown* cd,scheduler* schd);
  //int connect(std::vector<topology::host*>*reject_hosts, std::string l_user);

  std::vector<topology::host*>remote_hosts;
  std::vector<topology::host*>* reject;
  std::string local_user;
	scheduler* _schd;
  void getalive();

  friend void runnable(connector* con); 
  PTH::Thread connect_thread;
  //pthread_t connect_thread;
  PTH::CountDown* _cd;

};



class connector_collector
{
 public:
  connector_collector();
  ~connector_collector();
  /**
     add a connector object in the connector_collector
     @param id: connector's name 
     @param con: reference to this connector 
   */
	template<class T>
  void add(const std::string& id)
	{
		collector[id]=new WrapperFactory<T>;
	}
  /**
     get a reference to the connector id
   */
  connector* get(const std::string& id)
	{
		if(collector.find(id)!=collector.end())
			return collector[id]->allocate();
		else
			return NULL;
	}

  struct ltstr
  {
    bool operator()(std::string s1, std::string s2) const
    {
      return s1 < s2;
    }
  };
 protected:
	class WrapperFactoryBase{
		public:
		virtual connector* allocate()=0;
	};
	template<class T>
	class WrapperFactory : public WrapperFactoryBase
	{
		public:
		connector* allocate()
		{
			return (connector*)new T;
		}
	};
  /**
     hash table containing all availlable connectors
   */
  std::map<std::string,WrapperFactoryBase*,ltstr> collector;
};


#endif //__CONNECTOR_H
