//TG not need on MacOSX#include <linux/fd.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <pwd.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>
#include <iostream>

#define SIZEBUF 4096
static int fd_pipe[2];

int sendall(int fd, void *buf, int size)
{
  void* buf_inter;
  int nbsent=0;
  int nbtosent=size;


  buf_inter=buf;
  while(nbtosent!=0)
    {
      (char*)buf_inter+=nbsent;
      nbsent=write(fd,buf_inter,nbtosent);
      //      ioctl(fd,FDFLUSH);
      nbtosent-=nbsent;
      if(nbsent<=0)
	break;
    }
  if(nbsent <= 0 && nbtosent != 0)
    {
      return -1;
    }
  else
    return size;
}

void repeat()
{
  char buf[SIZEBUF];

  fd_set read_set;
  int maxfd=0;
  int remote_open=1;
  int local_open=1;
  int nbread=0;

  while(true)
    {
      FD_ZERO(&read_set);
      if(local_open)
	FD_SET(fd_pipe[1],&read_set);
      if(remote_open)
	FD_SET(0,&read_set);
      maxfd=fd_pipe[1]+1;
      do
	{
	  errno = 0;
	  select(maxfd, &read_set, NULL, NULL, NULL);
	}while(errno == EINTR);
      if(FD_ISSET(fd_pipe[1],&read_set))
	{
	  nbread=read(fd_pipe[1],&buf,SIZEBUF);
	  if(nbread>0)
	  {
	    sendall(1,buf,nbread);
	  }
	  else
	    {
	      close(1);
	      close(0);
	      local_open = 0;
	      remote_open=0;
	    }
	}
      if(FD_ISSET(0,&read_set))
	{
	  nbread=read(0,&buf,SIZEBUF);
	  if(nbread>0)
	    sendall(fd_pipe[1],buf,nbread);
	  else
	    {
	      close(fd_pipe[1]);
	      local_open = 0;
	      remote_open=0;
	    }
	}
      if(remote_open+local_open==0)
	break;
    }
}


int main(int argc,char *argv[])
{

  
  int pid=0;
  if(socketpair(AF_LOCAL, SOCK_STREAM,0,fd_pipe)<0)
    {
      //perror("socket pair allocation:");
      exit(1);
    }

  if ((pid = fork()) == -1)
    {
      //perror("redir: fork error");
      exit(1);
    }
  
  if (pid != 0)
    {
      close(fd_pipe[0]);
      repeat();
    }
  else
    {
      //struct passwd* pwd;
      //redirect 0,1,2 on fd_pipe[0]
      if(dup2(fd_pipe[0],0)<0)
	perror("dup error: ");
      if(dup2(fd_pipe[0],1)<0)
	perror("dup error: ");
      if(dup2(fd_pipe[0],2)<0)
	perror("dup error: ");
      close(fd_pipe[1]);

      argv=&argv[1];
      execvp(argv[0],argv);
    }
}
