/*
 * The contents of this file are subject to the Dyade Public License,
 * as defined by the file DYADE_PUBLIC_LICENSE.TXT
 *
 * You may not use this file except in compliance with the License. You may
 * obtain a copy of the License on the Dyade web site (www.dyade.fr).
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 * 
 * 
 *
 * The Initial Developer of the Original Code is Dyade. The Original Code and
 * portions created by Dyade are Copyright Bull and Copyright INRIA.
 * All Rights Reserved.
 */
/* Copyright (c) 1997 by Groupe Bull. Read the COPYRIGHT file. */
/* $Id: */
/* Author: Cyrille.Martin@imag.fr */

/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#include <spawner.h>
#include <connector.h>
#include <topology.h>
#include <debuglog.h>
#include <pth>
#include <iostream>
#include <vector>
#include <fcntl.h>
#include <map>
#include <scheduler.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>

#include <fstream>
//getrusage include
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
//-----------------


#define MAXLOAD 8
//#define MAXLOAD 0.08


void spawner::checkload()
{

/* version 3
	struct timeval tps;
  double timecurr;
	double gap;
	double gapMoy;
	double gapmax;

//======get loadavg=======
	double load=0.0;
#ifndef PTH_USE_PTHREAD_IRIX
	getloadavg(&load,1);
#endif
//========================

//======get rusage========
	struct rusage usage;
	long nbctxtswitch=0;
	if(getrusage(RUSAGE_SELF, &usage)>=0)
	{
		nbctxtswitch=usage.ru_nvcsw+usage.ru_nivcsw;
	}

//========================
  
	gettimeofday(&tps,NULL);
  if(iter==0.0)
  {
    timeold=tps.tv_sec+0.000001*tps.tv_usec;
  }else
	{
		timecurr=tps.tv_sec+0.000001*tps.tv_usec;
		gap=(timecurr-timeold);
		if(iter==1.0)
			gapMoy=gap;
		else
			gapMoy=(gapsum/(iter-1.0));
		//dbg.log("tooloaded","timeold: %f timecurr: %f Gap: %f\n",timeold,timecurr,(timecurr-timeold));
		if(GapMax==0.0)
			gapmax=gapMoy*MAXLOAD;
		else
			gapmax=GapMax;
		dbg.log("tooloaded","Changement de contexte:%lu Loadavg:%f timeold: %f timecurr: %f Gap: %f GapMoy: %f GapMAX: %f\n",nbctxtswitch,load,timeold,timecurr,gap,gapMoy,gapmax);
		if (gap>gapmax)
		{
			loaded = true;
			GapMax=gapmax;
		}
		else
			loaded = false;
		timeold=timecurr;
		gapsum+=gap;
	}
	iter+=1.0;
	*/
}

bool spawner::tooloaded()
{
/*  version 1 */
	double load;

	load=0.0;
	if(getloadavg(&load,1)<0)
		return false;
	else
		return (load > 0.6);
/*		*/
/*  version 2
	std::ifstream proc;
	double real=0.0;
	double user=0.0;
	double truc=0.0;
	int Rqueue=0;
	bool loaded=false;

	proc.open("/proc/loadavg");

	if (!proc.fail())
	{
			if (!proc.eof())
			{
					proc >> real >> user >> truc >> Rqueue;
					//std::cout<<"Rqueue = "<<Rqueue<<std::endl;
					loaded=(Rqueue>=MAXLOAD);
			}

			proc.close();
	}
	return loaded;
	*/
/* version 3
	
	return loaded;
	*/
}

int spawner::connect(std::vector<topology::host*>& reject, std::string& local_user,bool dyn)
{
	std::map<std::string,connector*,ltstr> todomap;
  std::map<std::string,connector*,ltstr>::iterator cur;
  PTH::CountDown cd;
	cd.init(0);
	std::vector<topology::host*> tospawn;
	connector* con;
	int laststeal;
	if(dyn)
		laststeal=1;
	else
		laststeal=ToDoList.size();
  //complete the build of the remote command
  //for(int j=0;j<topo.arity;j++)
  //  topo.hostsmap[j]->cmd+= (" -- " + topo.arguments);

	startscheduler();

	while (get_job(tospawn,laststeal)>0)
	{
//			if(laststeal<8)
//				laststeal*=2;
			dbg.log("spawner","get a list of size %d to spawn\n",tospawn.size());
			/*for(int i=0;i<tospawn.size();i++)
			{
				dbg.log("spawner","host %d to spawn\n",i);
				dbg.log("spawner","host %d name %s\n",i,tospawn[i]->name.c_str());
				dbg.log("spawner","host %d connector %s\n",i,tospawn[i]->connector.c_str());
				dbg.log("spawner","host %d spreadargs %s\n",i,tospawn[i]->spreadargs.c_str());
				dbg.log("spawner","host %d userargs %s\n",i,tospawn[i]->userargs.c_str());
				dbg.log("spawner","host %d login %s\n",i,tospawn[i]->login.c_str());
				dbg.log("spawner","host %d passwd %s\n",i,tospawn[i]->passwd.c_str());
				dbg.log("spawner","host %d cmd %s\n",i,tospawn[i]->cmd.c_str());
				dbg.log("spawner","host %d fd %d\n",i,tospawn[i]->fd);
				dbg.log("spawner","host %d rank %d\n",i,tospawn[i]->rank);
				dbg.log("spawner","host %d size %d\n",i,tospawn[i]->size);
				dbg.log("spawner","host %d type %d\n",i,tospawn[i]->type);


			}
			*/
      //build the to do list for all connectors used
      for(int i=0;i<tospawn.size();i++)
			{
				
	  		if(todomap.find(tospawn[i]->connector)!=todomap.end())
	    		todomap[tospawn[i]->connector]->remote_hosts.push_back(tospawn[i]);
	  		else
	    	{
					if((con=connector_collector::get(tospawn[i]->connector))!=NULL)
					{
						con->remote_hosts.push_back(tospawn[i]);
						todomap[tospawn[i]->connector]=con;
					}
					else
					{
						//connector don't exist display an error message and 
						//set this node to the rejected list
						tospawn[i]->fd=-1;
						reject.push_back(tospawn[i]);
						std::cerr<<"Connector: "<<tospawn[i]->connector<<" unknow ABORT the node "
											<<tospawn[i]->name<<std::endl;
						dbg.log("WARNING","connector %s\
												unknow\n",tospawn[i]->connector.c_str());
						std::cerr<<"Available connectors are:"<<std::endl;
						for(std::map<std::string,WrapperFactoryBase*,ltstr>::iterator cur  = collector.begin();cur!=collector.end();cur++)
							std::cerr<<(*cur).first<<std::endl;
					}
	    	}
				// complete the command
				tospawn[i]->cmd+=(" --  "+ tospawn[i]->userargs);
			}      
      dbg.log("spawner","spawn begin\n");
      

      // call connector with his to do job
      for(cur  = todomap.begin();cur!=todomap.end();cur++)
			{
				if((*cur).second->remote_hosts.size()!=0)
	  		{
	    		dbg.log("spawner","use the connector [%s]\n",(*cur).first.c_str());
	    		++cd;
					//if error when launch thread decrement thread count
					checkload();
	    		if((*cur).second->connect(&(reject),local_user,&cd,this)<0)
					{
						dbg.log("WARNING","connect session failed maybe can't create thread\n");
						--cd;
					}
	  		}
      }
      //wait for all connectors job completed
//			if(scheduler::_maxthread!=250)
//			{
				if(cd.getValue()>=scheduler::_maxthread||(tooloaded() && dyn && scheduler::_maxthread==250) )
				//if(cd.getValue()>=scheduler::_maxthread )
				{
					dbg.log("tooloaded","join ...............\n");
					cd.wait();
					dbg.log("tooloaded","join ok\n");
				}
//			}
//			else
//			{
//				if(tooloaded())
//				{
//					PTH::Thread::yield();
//					dbg.log("spawner","join ...............\n");
//					cd.wait();
//					dbg.log("spawner","join ok\n");
//				}
//			}
			//control job correctly done & and supress rejected host
/*			for(std::vector<topology::host*>::iterator iter=tospawn.begin();iter!=tospawn.end();)
			{
				if((*iter)->fd==-1)
				{
					iter=tospawn.erase(iter);
				}
				else
					iter++;
			}
			add_childs(tospawn);
*/
			// free the tospawn list
			tospawn.clear();
			todomap.clear();
	}
	//all thread connect must terminated
	dbg.log("spawner","final join ...............wait for %d threads\n",cd.getValue());
	cd.wait();
	dbg.log("spawner","final join ok\n");
	//set off scheduler thread and refresch info structure
	//terminate();
  if (reject.size() > 0)
		return -1;
	else
	  return 0;
}


