//
// $Id: Ping.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <taktuknetwork.h>
#include <TCP_network.h>
#include <pth>

namespace AC = acom;

static int rank = -1;
static PTH::CountDown isterm;

class PingService: public AC::Service {
public:
  void call ( 
       AC::ComFailure::Code e,      // if any 
	   acom::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz,
       void* ctxt
  ) throw (AC::ComFailure)
  {
    //std::cout << ":: ACK: ";
		if (e == AC::ComFailure::OK) 
		{
       //std::cout << " No Error iov0 = "<<(char*)iov[0].data << std::endl;
			 //char toto[8];
       //std::cout << "Im data = "<<toto << std::endl;
			 
		}
    else 
       std::cout << "Ping Reception Error" << std::endl;
    --isterm;
  }
};

class PongService: public AC::Service {
public:
  void call ( 
       AC::ComFailure::Code e,      // if any 
	   acom::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz,
       void* ctxt
  ) throw (AC::ComFailure)
  {
    //std::cout << ":: ACK: ";
		if (e == AC::ComFailure::OK) 
		{
       //std::cout << " No Error iov0 = "<<(char*)iov[0].data << std::endl;
			 //char toto[8];
			 //receipt->unpack(toto,8);
       //std::cout << "Im data = "<<toto << std::endl;
			 
		}
    else 
       std::cout << "Pong Reception Error" << std::endl;
    --isterm;
  }
};
static PingService Ping;
static PongService Pong;

int doit (int argc, char* argv[])
{
	PTH::Pth::initialize();
  PTH::Pth::commit();
  AC::Service::Manager.bind (2, &Ping);
  AC::Service::Manager.bind (3, &Pong);
//  char* toto="coucou\n";

  Taktuk::Network* net = new Taktuk::Network();
  net->initialize(&argc,&argv);
  net->commit();




	char* msg;
	int msgsz=10;
	int nbPing=10;

	if(argc>=3)
	{
		msgsz=atoi(argv[1]);
		nbPing=atoi(argv[2]);
	}
	else
		std::cout<<"Usage Ping msgsize nbPing"<<std::endl;

	std::cout<<"Default options: \n message size: "<<msgsz<<" \n nb message "<<nbPing<<std::endl;



// if I'm the node 0 I wait for Pong of all other nodes
// else I wait Nb Ping until send a Pong to 0
	if(net->rank()==0)
	{
		msg=(char*)malloc(msgsz);
		isterm.init(net->node_count()-1);
	}
	else
		isterm.init(nbPing);
  net->barrier();
	std::cout<<"MAIN BEGIN node count = "<<net->node_count()<<std::endl; 
  
  rank = net->rank();

	if(rank==0)
	{
		std::cout<<"send a msg to all other node"<<std::endl;
		
		for(int i=0;i<nbPing;i++)
		{
			std::cout<<"Send Ping no "<<i<<std::endl;
			//std::cout << "Service as number=" << ack_service.get_id() << std::endl;
			for (int n=0; n < net->node_count(); ++n)
			{
				/* Get a channel:
				*/
				if(n!=rank) // not send it to me
				{
		//			std::cout << "Request for a channel to "<<n<<": rank is=" << rank << std::endl;
					AC::Network::OutChannel* channel = net->get_default_route(n);
		//			std::cout << "Got a channel to "<<n<<": rank is=" << rank <<" OK :-)"<< std::endl;
					AC::ActiveMessage<PingService> am (net, &Ping, 0);
					am->put(msg,msgsz);
					am(channel);
		//			std::cout << "SEND MESSAGE to "<<n<<": rank is=" << rank <<" OK :-)"<< std::endl;
				}
			}
		}
		std::cout << "Waiting for  Pong messages" << std::endl;
	}else
		std::cout << "Waiting for Ping messages" << std::endl;
  isterm.wait();
	
	if(rank !=0)
	{
		// send a Pong to 0
		std::cout << "Request for a channel to 0 : rank is=" << rank << std::endl;
		AC::Network::OutChannel* channel = net->get_default_route(0);
		std::cout << "Got a channel to 0 : rank is=" << rank <<" OK :-)"<< std::endl;
		AC::ActiveMessage<PongService> am (net, &Pong, 0);
		am(channel);
	}else
		free (msg);
  std::cout << "Ready to Terminate" << std::endl;

  net->terminate( );
	delete net;
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (...){
    std::cerr << "Unknown exception" << std::endl;
  }
}
