//
// $Id: mesure_debit.cpp,v 1.3 2003/07/15 17:47:38 thierry Exp $
//
// test active message: a call to all node from all node
// arguments : longueur du message en Ko, nombre d'itrations
// mesure la latence et le debit en tre 2 noeuds
//
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <iostream>
#include <sys/time.h>
#include <iomanip>
#include <taktuknetwork.h>
#include <acom>
#include <fstream>
#include <vector>




static int rank = -1;
static volatile bool isterm = false;
static volatile int count_p = 0;
static volatile int nb_send =0;
static volatile int count_time = 0;
static std::vector<int> count_ping;

static	acom::Network* net;
std::ofstream fileStream;

static pthread_mutex_t mutex;
static pthread_cond_t cond;
static char buf[1048576];

namespace AC=acom;



class AckService: public AC::ServiceAM {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz,
       void* ctx
  ) throw (AC::ComFailure)
  {
	pthread_mutex_lock(&mutex);
    isterm = true;
	pthread_cond_signal(&cond);
	pthread_mutex_unlock(&mutex);
  }
};

static AckService ack;

class PingService: public acom::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz,
       void * ctx
  ) throw (acom::ComFailure)
  {
     if (e == AC::ComFailure::OK){
     	count_p++;
     	if(nb_send == count_p)
	{
        	AC::Network::OutChannel* channel = net->get_default_route(h->src);
        	AC::ActiveMessage<AckService> am (net, &ack, 0);
        	am.post(channel);
			count_p=0;
	}
     }
    else
       std::cout << "Error" << std::endl;
  }
  void* get_iovect(
  	AC::Network::Receipt* receipt,
	AC::Network::Header* header,
	AC::IOVectEntry* vector, AC::IOVectSize count
	)
  {
	if(count==1)
		vector[0].data=buf;
  return NULL;
  }
};

static	PingService ping;




void waitack()
{
	pthread_mutex_lock(&mutex);

	while(!isterm)
		pthread_cond_wait(&cond,&mutex);

	isterm=false;
	pthread_mutex_unlock(&mutex);
}

double debit(int node,int packetsz,int nb_packets,acom::Network* net) //return the time to send
													//all this packets
{
	char* msg=NULL;
	double deb;
	struct timeval time1,time2;
	if (packetsz >0)
		msg = (char*)malloc(packetsz*sizeof(char));

	try{
        AC::Network::OutChannel* channel = net->get_default_route(node);
        gettimeofday(&time1,NULL);
		for (int k=0; k < nb_packets; ++k)
        {
            AC::ActiveMessage<PingService> am (net, &ping, 0);
            //AC::WriteAndSignal<PingService> am (net, &ping, 0);
        	//gettimeofday(&time1bis,NULL);
			//for (int k=0; k < nb_packets; ++k)
           	if (packetsz>0&&msg!=NULL)
    			am->put(msg,packetsz);
            am.post(channel);

        }
		waitack();
        gettimeofday(&time2,NULL);
		deb=((double)( time2.tv_sec - time1.tv_sec)+0.000001*(double)(time2.tv_usec - time1.tv_usec)); //sec
		return (deb);
	}
	catch(...){
		return 0.0;
	}
}


int main (int argc, char* argv[])
{
	Taktuk::Network *Primaire;
	double debit1=0.0;
	double debit2=0.0;
	double latence=0.0;

	int nb_iter=0;
	
	pthread_mutex_init(&mutex,NULL);
	pthread_cond_init(&cond,NULL);
    int len = 0;
    Primaire = new Taktuk::Network();
	net =(acom::Network*) Primaire;

    Primaire->initialize( &argc,&argv );
    AC::Service::Manager.bind (15,15, &ping);
    AC::Service::Manager.bind (15,16, &ack);
    

	rank = net->rank();
	if(argc<3)
		std::cout<<"usage: "<<argv[0]<< "packet_size      nb_iteration   "<<std::endl;
    len = atoi(argv[1]);
    nb_iter = atoi(argv[2]);
    nb_send = nb_iter;

    Primaire->commit();
	Primaire->barrier();


    if (rank == 0)
    {

        // pour chaque paire de noeuds evaluer le debit
	debit1 = debit(1,len,nb_iter,net);
//	debit2 = debit(1,nb_iter*1024,len,net);
	//latence = debit(1,0,1,net);
	std::cout<<"time :  "<< debit1 <<std::endl;
	std::cout<<"debit "<<(double)(len*nb_iter/debit1)/(1024*1024)<<" MBytes/sec"<<std::endl;
//	std::cout<<"time :  "<< debit2 <<std::endl;
//	std::cout<<"debit with "<<len<<" packets of "<<nb_iter<<" Ko :"<<(double)(len*nb_iter/debit2)<<" Ko/sec"<<std::endl;
//	std::cout<<"latence "<<latence <<std::endl;
    }
    //std::cout << "Ready to Terminate " << rank<<std::endl;
	Primaire->barrier();
	Primaire->terminate();


	pthread_cond_destroy(&cond);
	pthread_mutex_destroy(&mutex);
}
