//
// $Id: mesure_latence.cpp,v 1.3 2003/07/28 08:12:04 thierry Exp $
//
// test active message: a call to all node from all node
// arguments : longueur du message en Ko, nombre d'itrations
// mesure la latence et le debit en tre 2 noeuds
//
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <iostream>
#include <sys/time.h>
#include <iomanip>
#include <taktuknetwork.h>
#include <acom>
#include <fstream>
#include <vector>




static int rank = -1;
static volatile bool isterm = false;
static volatile int count_p = 0;
static volatile int nb_send =0;
static volatile int count_time = 0;

static	acom::Network* net;
std::ofstream fileStream;

static pthread_mutex_t mutex;
static pthread_cond_t cond;
static char buf[1048576];

namespace AC=acom;



class AckService: public AC::ServiceAM {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz,
       void * ctx
  ) throw (AC::ComFailure)
  {
	pthread_mutex_lock(&mutex);
    isterm = true;
	pthread_cond_signal(&cond);
	pthread_mutex_unlock(&mutex);
  }
};

static AckService ack;

class PingService: public acom::ServiceAM {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz,
       void * ctx
  ) throw (acom::ComFailure)
  {
     if (e == AC::ComFailure::OK){
       	AC::Network::OutChannel* channel = net->get_default_route(h->src);
       	AC::ActiveMessage<AckService> am (net, &ack, 0);
       	am.post(channel);
     }
    else
       std::cout << "Error" << std::endl;
  }
};

static	PingService ping;




void waitack()
{
	pthread_mutex_lock(&mutex);

	while(!isterm)
		pthread_cond_wait(&cond,&mutex);

	isterm=false;
	pthread_mutex_unlock(&mutex);
}

double latence(int node,acom::Network* net) //return the time to send
													//all this packets
{
	double deb;
	struct timeval time1,time2;
	try{
        AC::Network::OutChannel* channel = net->get_default_route(node);

		
        gettimeofday(&time1,NULL);
        AC::ActiveMessage<PingService> am (net, &ping, 0);
        am.post(channel);
		waitack();
        gettimeofday(&time2,NULL);
		deb=((double)( time2.tv_sec - time1.tv_sec)+0.000001*(double)(time2.tv_usec - time1.tv_usec)); //sec
		return (deb);
	}
	catch(...){
		return 0.0;
	}
}

double chauffe_marcel(int node,acom::Network* net) //return the time to send
													//all this packets
{
	double deb;
	struct timeval time1,time2;
	char msg[500000];
	try{
        AC::Network::OutChannel* channel = net->get_default_route(node);

		
        gettimeofday(&time1,NULL);
        AC::ActiveMessage<PingService> am (net, &ping, 0);
		am->put(msg,500000);
        am.post(channel);
		waitack();
        gettimeofday(&time2,NULL);
		deb=((double)( time2.tv_sec - time1.tv_sec)+0.000001*(double)(time2.tv_usec - time1.tv_usec)); //sec
		return (deb);
	}
	catch(...){
		return 0.0;
	}
}

int main (int argc, char* argv[])
{
	Taktuk::Network *Primaire;
	double lat=0.0;
	double latmoy=0.0;

	
	pthread_mutex_init(&mutex,NULL);
	pthread_cond_init(&cond,NULL);
	Primaire = new Taktuk::Network();
	net =(acom::Network*) Primaire;

	Primaire->initialize( &argc,&argv );
	AC::Service::Manager.bind (15,15, &ping);
	AC::Service::Manager.bind (15,16, &ack);
    

	rank = net->rank();
	nb_send = 1;

	Primaire->commit();


	Primaire->barrier();
  std::cout << "Node: " << rank << " ready " << std::endl;

	if (rank == 0)
	{
		for(int i=0;i<10;i++)
			chauffe_marcel(1,net);
		lat=0.0;
		sleep (5);
		for(int i=0;i<1000;i++)
		{
			lat= latence(1,net);
			latmoy+=lat;
			std::cout<<"latence "<<lat*1000000/2<<" usec"<<std::endl;
		}
		std::cout<<std::endl;
		std::cout<<"Latence moy: "<<latmoy*1000/2<<" usec"<<std::endl;
	}
	Primaire->barrier();
	Primaire->terminate();


	pthread_cond_destroy(&cond);
	pthread_mutex_destroy(&mutex);
}
