//
// $Id: testam.cpp,v 1.2 2003/07/09 13:41:11 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <taktuknetwork.h>
#include <pth>

namespace AC = acom;

static int rank = -1;
static PTH::CountDown isterm;

class AckService: public AC::ServiceAM {
public:
  void call ( 
       AC::ComFailure::Code e,      // if any 
	   acom::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz,
			 void* ctxt
  ) throw (AC::ComFailure)
  {
    std::cout << ":: ACK: ";
		if (e == AC::ComFailure::OK) 
		{
       std::cout << " No Error iov0 = "<<(char*)iov[0].data << std::endl;
			 char toto[8];
			 receipt->unpack(toto,8);
       std::cout << "Im data = "<<toto << std::endl;
			 
		}
    else 
       std::cout << "Error" << std::endl;
    --isterm;
  }
};

static AckService ack_service;

int doit (int argc, char* argv[])
{
	PTH::Pth::initialize();
  PTH::Pth::commit();

  char* toto="coucou\n";

  Taktuk::Network* net = new Taktuk::Network();
  net->initialize(&argc,&argv);
 	try
	{
  	AC::Service::Manager.bind (32,2, &ack_service);
	}catch(...)
	{
		std::cout<<"CAN'T BIND SERVICE ABORT"<<std::endl;
		exit(0);
	} 
	net->commit();

	isterm.init(net->node_count()-1);
  net->barrier();
	std::cout<<"MAIN BEGIN"<<std::endl; 
  
  rank = net->rank();

	std::cout<<"send a msg to all other node"<<std::endl;
	
	std::cout << "Service as number=" << ack_service.get_id() << std::endl;
	for (int n=0; n < net->node_count(); ++n)
	{
		/* Get a channel:
		*/
		if(n!=rank) // not send it to me
		{
			std::cout << "Got a channel to "<<n<<": rank is=" << rank << std::endl;
			AC::Network::OutChannel* channel = net->get_default_route(n);
			AC::ActiveMessage<AckService> am (net, &ack_service, 0);
			am->put(toto,8);
			am->pack(toto,8);
			am.post(channel);
		}
	}
  isterm.wait();
	// - wait calling of PING
  std::cout << "Ready to Terminate" << std::endl;
  net->terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (...){
    std::cerr << "Unknown exception" << std::endl;
  }
}
