//
// $Id: testaws.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <taktuknetwork.h>
#include <pth>

namespace AC = acom;

static int rank = -1;
static PTH::CountDown isterm;

class AckService: public AC::ServiceWS {
public:
  void call ( 
       AC::ComFailure::Code e,      // if any 
	   acom::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz,
			 void* ctxt
  ) throw (AC::ComFailure)
  {
    std::cout << ":: ACK: ";
		if (e == AC::ComFailure::OK) 
		{
       std::cout << " No Error iov0 = "<<(char*)iov[0].data << std::endl;
			 char toto[8];
			 receipt->unpack(toto,8);
       std::cout << "Im data = "<<toto << std::endl;
			 
		}
    else 
       std::cout << "Error" << std::endl;
    --isterm;
		AC::Network* _net=(AC::Network*)receipt->get_net();
		_net->deallocate_data(iov[0].data);
  }
};

static AckService ack_service;

int doit (int argc, char* argv[])
{
	PTH::Pth::initialize();
  PTH::Pth::commit();
  AC::Service::Manager.bind (10, 2, &ack_service);
  char* toto="coucou\n";

  Taktuk::Network* net = new Taktuk::Network();
  net->initialize(&argc,&argv);
  net->commit();

	isterm.init(net->node_count()-1);
  net->barrier();
	std::cout<<"MAIN BEGIN"<<std::endl; 
  
  rank = net->rank();

	std::cout<<"send a msg to all other node"<<std::endl;
	
	std::cout << "Service as number=" << ack_service.get_id() << std::endl;
	for (int n=0; n < net->node_count(); ++n)
	{
		/* Get a channel:
		*/
		if(n!=rank) // not send it to me
		{
			std::cout << "Got a channel to "<<n<<": rank is=" << rank << std::endl;
			AC::Network::OutChannel* channel = net->get_default_route(n);
			AC::AllocWriteAndSignal<AckService> aws (net, &ack_service, 0);
			aws->put(toto,8);
			aws->pack(toto,8);
			aws(channel);
		}
	}
  isterm.wait();
	// - wait calling of PING
  std::cout << "Ready to Terminate" << std::endl;
  net->terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (...){
    std::cerr << "Unknown exception" << std::endl;
  }
}
