// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/Tumit/doc/tr_doc.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: J. Briat 


// ==========================================================================
/*---------------------------------------------------------------------
------------------------ BEGIN   MANUAL -------------------------------
*----------------------------------------------------------------------
*
* There is a text part which introduce concepts anf how to use them.
*  Text refers to the code (class etc...) or modules. Modules contains only 
* object or methods defining the API for Inuktitut0  thread package
*
------------------------------------------------------------------------
-----------------------------------------------------------------------*/
/**
\htmlonly <IMG SRC="logo_a0.gif"  HEIGHT=200 WIDTH=600 ALIGN=CENTER>
\endhtmlonly 
\author J. Briat 
\date   March 2002, 19
\mainpage  Inuktitut0 tracing facility

This is a short introduction to Inuktitut0  tracing faclity  package. The following sections present the objective of this package and highlight key points and tricks in using  threads, synchronization etc.. 

The programmer may learn   the Inuktitut0 tracer package through  sections describing how to initiate  a tracer, to define trace event and to insert  recording of events in the code. In the documentation, we use the fully qualified names. When programming, you may use short names depending of C++ contextual rules (using directives, lexical scoping ..). The naming rule used use \c j as prefix for all classes which are closed to thread behaviour.


\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\section Saim Objectives
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
The aims of this package is to provide tools to help Inuktitut developpers and users to trace parallel programs or to building tracers. It is composed of two parts :
	- the first one is composed of a library of  classes. These classes are used to build basic tracing mechanisms such that buffer management (allocation , flushing on disk), data recording in or reading from buffer, etc..Instances of theses classes give the  tracer mechanisms.
	-  a stub compiler. From given event signatures, this compiler (written in m4) produces the event recording stubs or the event reading stubs. So the users are free of the burden of (un)marshalling data (from)to buffers etc...
	- a tracer named \b  InukTracer automatically installed in the Pthread package.


\htmlonly  <hr WIDTH="100%"> \endhtmlonly 
\section  STrace How to  trace a parallel program
\htmlonly  <hr WIDTH="100%"> \endhtmlonly 

All what is needed  to trace  must be put in a file with \b evt extension. First of of all, choose the name for the tracer to build. Then defines the events to be traced.   From this file,  the stub compiler produces the tracer stubs. Then, it is possible to insert trace points in the code to be traced and initialization of the tracer. Compile and link. 

The trace files may be read using event reader stubs.

\htmlonly <hr WIDTH="50%"> \endhtmlonly
\subsection SLevEv tracer,levels and event declarations
\htmlonly <hr WIDTH="50%">\endhtmlonly

To help in managing events, the events are classified. Each event belongs to a level. Defining a level is done by the association of a name (the level identifier) and a number (the level number) by the command LEVEL( level_id, level_no). The numbering of level must be done by user. ( Doing this numbering automatically needs to define a level data base). The level 0 is reserved for internal used and must not be used. After a level definition, all its events  must be declared. An event declaration is the association of an event name (the event identifier) and the signature of the event that is to say the types and names of the date to record in the traces. We may see this the same of the parameters declaration for a procedure.

All scalar types are allowed. For dynamic size types, only std::string is supported.

 For example :
\code
#include "jth_jthread.h"
#include "jth_jsema.h"
USE_TRACER(InukTracer)
using namespace JTH ;
LEVEL(JTHREAD_LEVEL_INTERFACE,3)
EVENT(JTH_START_0,  jThread * started_thread,ThId pthid)
EVENT(JTH_START_1,  jThread * started_thread, int start_error, ThId pthid, ThId pthid2)
EVENT(JTH_YIELD_0,ThId pthid)
EVENT(JTH_YIELD_1,ThId pthid)

LEVEL(SEMAPHORE_LEVEL,4)
EVENT(SEMA_CREATE,jSemaphore * sema)
EVENT(SEMA_P_0,jSemaphore * sema)
\endcode


Level names and event names must be globally unambiguous.
\warning The stub compiler is written in m4. To avoid problems, don't use accents in level or event names and eliminate leading or terminationg blanks in typing level and event declarations.

\htmlonly <hr WIDTH="50%"> \endhtmlonly
\subsection Sstub  Tracer stubs generation
\htmlonly <hr WIDTH="50%">\endhtmlonly
All the previous definition must be put in <tt>  my_def.evt </tt> file. From this file is generated the  recorder and reader stubs in 2 files :
	- <tt>  my_def_stub_reader.h  </tt> and <tt>  my_def_stub_reader.cpp  </tt>
	- <tt>  my_def_stub_tracer.h </tt> and <tt>  my_def_stub_tracer.cpp </tt> 


Theses recorder stubs  must compiled and link with :
	- the base recorder classes
	- the code to trace for the tracer stubs,
	- the instrumented code
Theses reader stubs  must compiled and link with :
	- the base recorder classes
	-  trace analyzer tools  which must be extended in the future
	 ( see section ??? for an exemple of a trace printing tool).


All tracer objects are generated in the tracer name space.Its identifier is the name given to the tracer. Events data and stubs are put in the tracer namespace . So you must include the .h files containing the reference of traced objects and insert in the .evt file the appropriate "using namespace" expression.


\htmlonly <hr WIDTH="50%"> \endhtmlonly
\subsection STrCtrl Trace control and trace points
\htmlonly <hr WIDTH="50%">\endhtmlonly

To record an event, calls to the recording facility must be inserted in the traced code. This is simply done by calling the event name with its arguments like calling a procedure.
\code
before_read_file( fd0, myBuffer, 1024) // trace point 
int ssz=::read( fd0, myBuffer, 1024);
after_read_file( fd0 , ssz, errno)// trace point 
\endcode

A tracer may be controlled at compile time or at  runtime. When decide at compile time,  the stub files contains only macros expending to nothing.  Enabling or discarding of trace points at compile time  may be done on a .evt file basis by instructing the compiler to generate full stubs or null stubs. 

At runtime, tracing of events may be temporarily and dynamically disable through control commands. It is not possible to discard trace points but it is possible to enable or disable the tracing mechanism using the tracer mask, level masks or event masks. 
Setting a mask to true, disable recording of the corresponding set of events or a single event.
\code
using namespace InukTracer;
InukTracer_msk=1; // disable the tracer
...
InukTracer_msk=0; ; // enable the tracer
...
IO_msk=1; // disable all events of the IO level
....
IO_msk=0; // enable all events of the IO level
write_msk=1;// disable write event of the IO level
......
\endcode
Setting a mask to false restart the recording of the corresponding events.
\note To avoid multiple definitions of  identifiers, all tracer global data are put in a namespace with the tracer name as its identifier. So  it may be possible to use more than one tracer in an application because it is possible to access distinct global space using C++ qualified name (for ex MyTracer::MyTracer_msk for the trace mask of tracer \b MyTracer or MyTracer::IO_msk for IO level). 

\htmlonly <hr WIDTH="50%"> \endhtmlonly
\subsection SInit Initiating & stopping traces
\htmlonly <hr WIDTH="50%">\endhtmlonly

Before beginning to trace, it is necessary to initialize the basic mechanisms called by the tracer stubs. 
We will see later how to define the set of basic mechnisms to used or how to build new mechanisms. Without information about them, the stub compiler used default mechanisms and generate the initialization stubs. 
\code
// initialize the tracer
MyTracer::initialize("trace file name");
// do some user work before tracing
MyTracer::commit();
// tracer is up
.............
.............
// terminate tracing
MyTracer::terminate();
\endcode
\warning In the InukTracer default tracer configuration, all these initialization/terminaison steps are done id the Pthread package. 

The default behaviour of the trace toolkit is to trace threads. All events produced by a thread are recorded in dedicated buffers in order to avoid contention on shared buffers. So the thread traces are interleaved in the trace file on a buffer basis ( not event basis). It is up to the analyzer tools to merge and  sort  theses traces on time or causal order properties. So it is needed allocate at least on trace buffer per thread. 
\code
// beginning of a thread
 MyTracer::openTrace() //mandatory
....
// trace all events related to the running thread
Some_event(......)
....
MyTracer::closeTrace(); //mandatory
// end of thread
\endcode

Allocating/deallocating a buffer to the current thread is done explicitly by MyTracer::openTrace() / MyTracer::closeTrace(). 

\warning This is transparently done in the Pthread package when using the \b InukTracer. 

 
\htmlonly  <hr WIDTH="50%"> \endhtmlonly 
\subsection  Sreader What is traced and how to get it
\htmlonly  <hr WIDTH="50%"> \endhtmlonly 
The data given at a trace point are registered with trace specific data :
	- level and event event code
	- a time stamp
	- aprocess id ( call node id) and a thread id 
 	- a time stamp
For each defined event in the configuration file, the stub compiler produce a class definition corresponding to the event and some information like the level and event code.
For example, the definition of :
\code
LEVEL(MyLevel, 12)
EVENT(MyEvent0, int Some_Value, char * Some_Adress)
\endcode
produce in the  namespace associated to the tracer.
\code
// numeric code of level
const tr_level_no MyLevel_no=0;
// the event number code
const tr_event_no MyEvent0_no= ...;   
class MyEvent0_rcd :public Record{
public :
// event specific fields
int Some_Value;
char * Some_Adress;
// to get events common data
PhysicalTime getDate();// time stamp 
int getNode(); // node id
int getTid();// Thread id
void getNo( tr_event_no*  ev;tr_level_no* lv) // level and event numbers
// print  the record
std::ostream& print(std::ostream& out );  
};
std::ostream& operator<<(std::ostream& out, MyEvent0_rcd& r);
\endcode

To help in reading a trace file, the stub compiler generates code to build a map from level & event codes to event record descriptors. This mao is conventionnally named \b recordMap ( in the namespace of the tracer)

To read a trace file, you need to open it by creating a trace reader. You need also to provide it with the event map corresponding to the trace file.  Then you can read it record by record. The reader stub reads the trace and build the corresponding event record. The stub compiler produce also a printer for each event. The following program print a trace file in a human readable form.

\code
MyTracer::Reader reader; // define a reader
reader.open(fn); // open the file
MyTracer::Record *rcd; // generic event record pointer
 try{while(1){
  rcd=reader.readEvent(); // read next event and buid the corresponding record
   rcd->print(cout))<<"\n" ; // print it 
   MyTracer::Record::Date d= rcd->getDate(); // read the date
   cout << d  <<"\n" ; // print the date
  }
 }
 catch( EndOfTrace &e){ cout << " END OF TRACE FILE\n";}  
 reader.close();
\endcode

\htmlonly  <hr WIDTH="50%"> \endhtmlonly 
\subsection  Sflush Tracing the tracer
\htmlonly  <hr WIDTH="50%"> \endhtmlonly 
 There is only one event traced in the tracer. It is when a buffer flush occurs. An  event is recorded when the buffer is flushed. This event contains the date of the beginning of the flush. This event is produce to be able to adjust time scale of threads. the \b flushBuffer event is numbered by  TR::flushBuffer_no . It belongs to  the reserved level TR::tracer_level_no (0). When read from a trace file by a reader, a record class is produced and may be print as any event records: 
\code
class flushBuffer_rcd :public Record{
public :
 Record::Date  flushBeginDate ; //  date for request to flush
// print  the record
std::ostream& print(std::ostream& out ); 
};
std::ostream& operator<<(std::ostream& out, flushBuffer_rcd& r);
\endcode

\htmlonly  <hr WIDTH="100%"> \endhtmlonly 
\section  SBuild How to  build  a tracer
\htmlonly  <hr WIDTH="100%"> \endhtmlonly 

The stub compiler generates an instance of a tracer when compiling the \b TRACER directive in an .evt file. For a tracer, there must be only one .evt file with TRACER. All other files must begin with the USE_TRACER directive.  

\warning The InukTracer is generated in the Pthread package.


\htmlonly  <hr WIDTH="50%"> \endhtmlonly 
\subsection  SBlock Building blocks
\htmlonly  <hr WIDTH="50%"> \endhtmlonly 


The building blocks used to day are  :
	-  the PTH::Binder is  used to link a thread to its trace buffer
	- The buffer manager  PTH::SimpleBufferManageris very simple. On demand, it flushes event buffers in a trace in a blocking manner. After that, it returns the flushed buffer as a fresh one. When a new trace is opened, it allocates a buffer from the standard free memory and frees the buffer when the trace is closed. 
	- one buffer class PTH::SimpleBuffer which is used to record events.
	- one generic recorder PTH::SimpleRecorder which glues together all the previous things.
	- a physical clock PTH::PhysicalClock providing time on a second/microsecond basis TR::PhysicalTime ( Unix gettimeofday output).
\htmlonly  <hr WIDTH="50%"> \endhtmlonly 




\htmlonly  <hr WIDTH="100%"> \endhtmlonly 
\section  SInuk Tracing Inuktitut : InukTracer
\htmlonly  <hr WIDTH="100%"> \endhtmlonly 


InukTracer provides an embedded trace facility in Inuktitut . The basic idea is to:
	-  put in the Pthread module the definition of the Inuktitut tracer in an tr.evt file (beginning  withTRACER(InukTracer)) from which are built thr recorder and reader stubs. This file contains also the event definitions used to trace the Pthread module
	- put in the Pthread module all the initialization / termination of trace, allocation / deallocation of trace buffers to threads.
	-  put in each modules to trace ( Jthread, etc ..) an .evt file begining only with USE_TRACER(InukTracer)) followed by level+event declarations. Stubs are generated from theses files with only external reference to basic type ans values ( defined in the Tracer stubs).

Depending on the Inuktitut configuration, the stub compiler  outputs effective stubs or no-op stubs. All the readers stubs must be linked with  trace analysis tools. All this stuff is placed in Tracer sundirectory of the Inuktitut install directory. User may put here its own tools. 


*/ // DON'T REMOVE 
/*----------------------------- END OF MANUAL ----------------------------
------------------------------------------------------------------------
------------------------------------------------------------------------*/

