%{
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <map>

#include "stub_regles.h"

  extern "C"
  {
    int yyparse(void);
    int yywrap()
    {
      return 1;
    }
  }

  
  /***************************************/
  extern int yylval;
  extern int lineno;
  extern char *yycopy;
  extern int yylex(void);
  
  extern std::ofstream* ph ;
  extern std::ofstream* pcpp ;

  extern std::string name;
  
  int Lno=0;
  int Eno=0;
  char* Lvid;
  char* Evid;
  int tmp;
  int nb_param=0;  // Nombre de parametres de l'evenement courant...
  static const int nbMaxParam=20;

  struct parametre
  {
    std::string type;
    std::string id;
  };

  struct parametre tab_param[nbMaxParam];

  void init_tab_param()
    {
      for (int i=0; i < nbMaxParam ; i++)
	{
	  (tab_param[i]).type = "";
	  (tab_param[i]).id = "";
	}
    }

  void yyerror(char* s)
    {
      std::cout << s << " line " << lineno << std::endl;
    }
%}

%token NOMBRE NOM
%token EVT LV  TRACER USETRACER UNS DIESEINCLUDE
%token PARG PARD GUILM PVIRG VIRG STAR

%%
fichier:
desc     { std::cout << "\n------fichier " << name << ".evt ok-------\n"  ;};

desc:
  inc tracer usi dec_niv
{
  *ph   << " }       //end namespace    \n"
        << "#endif                    \n\n"; 
  *pcpp <<  " }      //end namespace  \n\n";
} ;

inc:
  inclusions
  |;         

inclusions:
  di
  | inclusions di;

di:
  DIESEINCLUDE GUILM NOM GUILM 
{ 
  *ph   << "#include \"" << (char*)$3 << "\"\n" ;
  *pcpp << "#include \"" << (char*)$3 << "\"\n" ;
};

tracer:
  USETRACER PARG NOM PARD  
{
  *ph   << "namespace "<< (char*)$3 << "\n{\n" ;
  *pcpp << "namespace "<< (char*)$3 << "\n{\n" ;
  
  *ph << "using namespace TR;\n\n";
  
  // USE_TRACER alors pas de demarage du traceur...
  *ph << "// y a PAS de TRACER\n";
  *ph << "extern RecordDescMap recordMap;\n\n";
}
| TRACER PARG NOM PARD  
{
  *ph   << "namespace "<< (char*)$3 << "\n{\n" ;
  *pcpp << "namespace "<< (char*)$3 << "\n{\n" ;

  *ph << "using namespace TR;\n\n";

  // TRACER alors demarage du traceur...
  
  *ph << "\n// y a du TRACER\n";
  
  *ph << "  typedef PTH::PhysicalClock ClockType;\n";
  *ph << "  extern RecordDescMap recordMap;\n\n";
  *ph << "class Reader : public TR::FileReader\n"
      << "   {\n"
      << "   public:\n"
      << "     Reader() :TR::FileReader(&recordMap){};\n"
      << "     ~Reader(){};\n"
      << "   };\n";
  *ph << "extern flushBuffer_desc flushBuffer_register;\n\n";
  // *ph << "using namespace PTH;\n";
  
  *pcpp << "RecordDescMap recordMap;\n\n";
  *pcpp << "flushBuffer_desc flushBuffer_register( flushBuffer_no , tracer_level_no, &recordMap);\n\n";
};


usi:
  using
  |;


using:
  UNS NOM PVIRG  
{ 
  // *ph   << "  using namespace TR;\n";
  *ph 	<< "  using namespace "<< (char*)$3 << ";\n\n" ;
  //?????? << "  #include \"ns_stub_regles.h\" \n\n" ;
  *pcpp << "  using namespace TR;\n" 
	<< "  using namespace "<< (char*)$3 << ";\n\n";
        //<< "  #include \"ns_stub_regles.cpp\" \n" ;
}
| using UNS NOM PVIRG 
{
  *ph   << "     using namespace "<< (char*)$4 << ";\n\n" ;
  *pcpp << "     using namespace "<< (char*)$4 << ";\n\n" ;
};

dec_niv:
  lev_evts
  | dec_niv lev_evts;

lev_evts:
  level evts ;
    

level:
LV PARG NOM VIRG NOMBRE PARD 
{
  Lno=$5; Eno=0; Lvid=strdup((char*)$3);  

  *ph << "// numeric code of level  \n"
      << "const tr_level_no " << Lvid << "_no = " << Lno << ";\n";
};

evts:
  evt
  | evts evt;

evt:
  EVT PARG nom_event listeParam PARD 
{ 
  Evid = strdup ((char*)$3); 

  // ///////////////////////////////////////////////////
  // //// point H //////////////////////////////////////


  // ///// event number code
  *ph << "// compute the event number code \n"
      << "const TR::tr_event_no "
      << Evid <<"_no = " << Eno << ";\n\n";


  // ///// class EVENT_rcd    /////   pb si 2 event de meme nom...??
  *ph << "\n  // the record for event " << Evid << std::endl
      << "  class "<< Evid << "_rcd:public Record \n"
      << "    {\n    public:\n";
  *ph << "\n      // constructor \n"
      << "      " << Evid << "_rcd ():Record ("
      << Evid << "_no, "<< Lvid << "_no)\n"
      << "        {};\n"
      << "      // destructor \n"
      << "      ~" << Evid << "_rcd ()\n"
      << "        {};\n";
  *ph     << "      // decl. of variables for event reading\n";
  for  (int i=5; i < nb_param; i++) 
    { 
      *ph << "      " << (tab_param[i]).type << " " << (tab_param[i]).id << "; \n";
    } 
  
  *ph << "      // read parameters of event from buffer\n"
      << "      TR::TraceFile& read (TR::TraceFile& in);\n\n"
      << "      // decl. of write function\n"
      << "      TR::TraceFile& write (TR::TraceFile& out);\n\n"
      << "      // print parameters of event\n"
      << "      std::ostream & print (std::ostream & out);\n\n"
      << "    };\n\n";


  // ////// class EVENT_desc
  *ph << " //  class desc \n"
      << "class " << Evid << "_desc:public RecordDesc \n"
      << "{ \n  public: \n   "
      << Evid << "_desc (TR::tr_event_no ev, TR::tr_level_no lv, \n"
      << "        RecordDescMap * rdm):RecordDesc (ev, lv, rdm) \n" 
      << "  {}; \n"
      << "~" << Evid <<  "_desc () \n"
      << "  {};  \n \n   "
      << Evid << "_rcd *build (TR::TraceFile& in);\n"
      << "std::ostream & print(std::ostream & out);  //pour dump \n"
      << "}; \n\n";


  *ph << "extern std::ostream & operator << (std::ostream & out, " 
      << Evid << "_rcd & r);\n";

  *ph << "extern " << Evid << "_desc " << Evid << "_register; "
      << "\n\n\n";




  // ///////////////////////////////////////////////////////////////
  // //// point CPP ////////////////////////////////////////////////
 
  //  *pcpp << "using namespace TR;\n\n";
  *pcpp << "//   trace flag\n\n";



  // ///// rcd read
  *pcpp << "//  rcd read \n"
	<< "TR::TraceFile& " << Evid << "_rcd::read (TR::TraceFile& in)\n"
	<< "{\n   return  Record::read(in)" ;
  for (int i=5; i < nb_param; i++) 
    {
      *pcpp << ">> &" << (tab_param[i]).id ;
    }
  *pcpp << " ;\n"
	<< "};     //end of read function \n\n";  
    

  //  ///// rcd write 
  *pcpp << "TR::TraceFile& " << Evid << "_rcd::write (TR::TraceFile& out)\n"
	<< "{\n   return  Record::write(out)" ;
  for (int i=5; i < nb_param; i++) 
    {
      *pcpp << "<< " << (tab_param[i]).id ;
    }
  *pcpp << " ;\n";
  *pcpp << "};        //end of write function \n\n";      


  
  //  ///// rcd print 
  *pcpp << "// code of print function \n"
	<< "std::ostream & " << Evid << "_rcd::print (std::ostream & out)\n { \n";
  TRegle::iterator rit;
  TSR::iterator tsrit;
  TSR::iterator paramit;
  // parcours de la structure Regle 
  // pour afficher toutes les parties droites
  for ( rit  = convMap[clef(Lno,Eno)]->begin() ; 
        rit != convMap[clef(Lno,Eno)]->end() ; 
        rit++ )
    {
      tsrit = (*rit)->begin() ;
      paramit = (*rit)->begin() ; paramit++;
      // .
      if (tsrit != (*rit)->end() )    // not empty event
	{
	  *pcpp << "  std::cout <<";

	  // on parcours tte la 1ere string 
	  int taille=(*tsrit).size();
	  
	  *pcpp << "\"";
	  
	  for (int i=0 ; i < taille; i++)
	    {
	      // si on rencontre un @ alors on substitue
	      if (((*tsrit)[i])=='@')
		{		  
		  *pcpp << "\" <<";

		  if (*paramit=="_d")
		    {
		      // faut fixer l'affichage des usec a 6 caracters (0 par def)
		      *pcpp << "_d.get_sec() << \".\" << setfill('0') << setw(6) << _d.get_usec()";
		    }
		  else
		    {
		      *pcpp << (*paramit) ;
		    }

		  *pcpp << " << \"";
		  paramit++;
		}
	      else
		{
		  *pcpp << ((*tsrit)[i]);
		} 
	    }
	      
	  *pcpp << "\"";

	  *pcpp << "  << std::endl;\n";
	}
      else  // empty event
	{
	  *pcpp << "  std::cout << \"\"; ";
	}
    }

  *pcpp << "\n }     // end of print func  //////"
	<< "\n\n";  


  // //// desc build 
  *pcpp << "// code of desc build function \n"
	<< Evid << "_rcd * " << Evid << "_desc::build(TR::TraceFile& in)\n"
	<< "{\n  " << Evid << "_rcd * rcd = new " << Evid << "_rcd();\n"
	<< "    rcd->read(in);\n"
	<< "    return rcd;\n"
	<< "};    // end of desc build func  ///// \n\n";


  // //// desc print 
  *pcpp << "// code of desc print function \n"
	<< "std::ostream & " << Evid 
	<< "_desc::print (std::ostream & out)\n { \n"
	<< "  out << \"" << Lvid << "_" << Evid << "\";\n" 
	<< "  return out;\n"
	<< "};     // end of desc print func  //////"
	<< "\n\n";  


  // ///// desc register
  *pcpp << "// EV desc register \n"
	<< Evid << "_desc " << Evid << "_register ( " 
	<< Evid << "_no, " << Lvid << "_no, &recordMap);\n\n";


  // //// operator  << 
  *pcpp << "// stream operator << (stream, rcd)\n" 
	<< "std::ostream& operator<<(std::ostream& out, " << Evid << "_rcd& r)\n"
	<< " {\n   return r.print(out);\n };\n\n";

      
  Eno++; 
  nb_param=0;
  init_tab_param();
};


nom_event:
  NOM
{
  $$ = $1;

  (tab_param[nb_param]).type += "ind";          (tab_param[nb_param]).id += "_node";   nb_param++;
  (tab_param[nb_param]).type += "void *";       (tab_param[nb_param]).id += "(int)_tid";    nb_param++;
  (tab_param[nb_param]).type += "tr_level_no";  (tab_param[nb_param]).id += "_lv";     nb_param++;
  (tab_param[nb_param]).type += "tr_event_no";  (tab_param[nb_param]).id += "_ev";     nb_param++;
  (tab_param[nb_param]).type += "DATE";         (tab_param[nb_param]).id += "_d._tv.tv_sec << \".\" <<  setfill('0') <<  setw(6) <<_d._tv.tv_usec"; nb_param++;
};



listeParam:
  VIRG desparam
  |;
  
desparam:
  param
  | desparam VIRG param;
  
param:
  NOM NOM       
{
  (tab_param[nb_param]).type += ((char*)$1); 
  (tab_param[nb_param]).id += ((char*)$2);  
  nb_param++;
}

| NOM STAR NOM 

{ (tab_param[nb_param]).type += ((char*)$1); 
 (tab_param[nb_param]).type += " *";
 (tab_param[nb_param]).id += ((char*)$3);  
 nb_param++;
};


%%




