#include <stdio.h>      //FILE
#include <iostream>
#include <iomanip>
#include "tab_rec_ana_yacc.h"
#include <fstream>
#include <string>

std::ofstream* ph;
std::ofstream* pcpp;
std::ofstream* etpdph;
std::ofstream* etpdpcpp;

std::string namepr;
std::string name;

extern FILE* yyin;

extern "C"
{
 int yyparse(void);
  char *yycopy;
}


int main(int argc, char** argv)
{
  if (argc > 1)
    {
      FILE* fin;
      name += argv[1];
      namepr = name;
      namepr += ".regles";
      fin = fopen(namepr.c_str(), "rt");
      if (!fin) 
	{
	  std::cout << "unable to open file : " << namepr
		    << "   (-> line " << __LINE__ 
		    << " of file " <<  __FILE__ << ") \n"
		    << "...aborting\n";
	  exit(1);
	}
      yyin = fin;
    }

  else
    {
      std::cout << "\nNo prefix spcified \naborting...\n";
      exit(1);
    }
  

  // names of outputs files
  std::string ph_name=name;
  std::string pcpp_name=name;
  std::string etpdph_name=name;
  std::string etpdpcpp_name=name;

  ph_name       += "_stub_regles.h";
  pcpp_name     += "_stub_regles.cpp";
  etpdph_name   += "_stub_etpdp.h";
  etpdpcpp_name += "_stub_etpdp.cpp";

  // openning of files
  ph =       new std::ofstream (ph_name.c_str(),        std::ios::out|std::ios::binary);
  pcpp =     new std::ofstream (pcpp_name.c_str(),      std::ios::out|std::ios::binary);
  etpdph =   new std::ofstream (etpdph_name.c_str(),   std::ios::out|std::ios::binary);
  etpdpcpp = new std::ofstream (etpdpcpp_name.c_str(), std::ios::out|std::ios::binary);


  *ph << "\n"
      << "/** file ns_stub_regles.h generated by "   ////////// <----
      << argv[0] 
      << " from file " << argv[1] << ".regles  ***/\n\n\n";
  *ph << "#ifndef _" << name << "_stub_regles_h_\n"
      << "#define _" << name << "_stub_regles_h_\n\n";
  *ph << "\n\n\n/////// begining of parsing of .regles file    \n\n";



  *pcpp << "/** file ns_stub_regles.cpp generated by " 
	<< argv[0] << " from file " << argv[1] << ".regles ***/\n\n\n";
  *pcpp << "#include \"" << name << "_stub_regles.h\"\n\n";
  *pcpp << "\n\n/////// begining of parsing of .regles file     \n\n";

///////////////////////////////////////////////////////////////////
yyparse();
//////////////////////////////////////////////////////////////////

  *ph << "\n////// end of parsing of .regles file      \n\n\n";
  *ph << "#endif       // end of #ifndef _" << name << "_stub_conv_h_ \n\n";


  *pcpp << "\n////// end of parsing of .regles file      \n\n\n";



  // closing output files
  ph->close();
  pcpp->close();
  etpdph->close();
  etpdpcpp->close();

  return 0;
}

