%{
#include <iostream>
#include <fstream>
#include <string>

extern "C"
{
  int yyparse(void);
  int yywrap()
  {
    return 1;
  }
}

 extern std::ofstream* ph;
 extern std::ofstream* pcpp;
 extern std::ofstream* etpdph;   
 extern std::ofstream* etpdpcpp;

 extern int lineno;

 extern std::string name;
 extern int yylval;
 extern char *yycopy;
 int Lno;
 int Eno;

 extern int yylex(void);


void yyerror(char* message )
{
 std::cerr << message << " " << "ligne " << lineno << std::endl;
 exit(-1);
}

%}

%token LENTETE LPDP COMM
%token FLECHE AT VIRG PARG PARD ESPACE GUILLEMET
%token NOMBRE NOM STRING SSCH

%%
fichier:
desc    
{ std::cout <<  "\n------ fin analyse rgles rcriture fichier "<< name <<".regles -------\n" ;};

desc:
entete regles pdp;

entete:
 lignes_entete
| ;

lignes_entete:
  ligne_entete
| ligne_entete lignes_entete ;

ligne_entete:
LENTETE
{
  *etpdpcpp << "std::string str_" << lineno << ";\n"
	    << "str_" << lineno << " += \"" << (char*)$1 << "\";\n"
	    << "str_" << lineno << ".erase(0,1);\n"
	    << "ENTETE.push_back(str_" << lineno << ");\n\n\n";
};

pdp:
  lignes_pdp
|;

lignes_pdp:
  ligne_pdp
| ligne_pdp lignes_pdp;

ligne_pdp:
LPDP
{
  *etpdpcpp << "std::string str_" << lineno << ";\n"
	    << "str_" << lineno << " += \"" << (char*)$1 << "\";\n"
	    << "str_" << lineno << ".erase(0,1);\n"
	    << "PDP.push_back(str_" << lineno << ");\n\n\n";
};

// il y a au moins une regle !
// changer pour permetre pas de regle ?
regles:
  regle
| regle regles;

regle:
// regle |= doublet parties_droite
// (4,3)   -> 12 @3 @4 @6
//         -> 15 @2 @1 @4
  doublet   parties_droite
{
  // end of rewriting rule, ...  is push into the map
  *ph << "\n    (*cm)[clef(" << Lno << "," << Eno << ")]=regle;\n" 
     << "  };\n";

  // decl of destructor   // need to free some bytes ??
  *ph    << " ~CONV_" << Lno << "_" << Eno << "()\n  {}; \n"
	<< "}; \n\n\n" ;
};


doublet:
// ( XX     ,    XX     )          pas d'espaces
  PARG NOMBRE VIRG NOMBRE PARD
{
  Lno = $2;
  Eno = $4;
 
  *ph << "class CONV_" << Lno << "_" << Eno 
      << "\n{\n"
      << "public:\n  CONV_" << Lno << "_" << Eno << "(Tmap* cm)\n"
      << "{\n"
    //<< " std::cout << \"--constructeur--" << Lno << "_" << Eno   << "\" << endl;\n"
      << "    TRegle* regle = new TRegle; \n"
      << "    TSR* structReec = new TSR; \n";

  
  *pcpp << "CONV_" << Lno << "_" << Eno << " CONV_" 
       << Lno << "_" << Eno  << "_register(&convMap );\n\n";

};

// il y a au moins une partie_droite.
parties_droite:
  partie_droite
| partie_droite parties_droite;

partie_droite:
//   ->     12  @5 COM  @1  CPU@4   Val@6@7
  fleche 
| fleche expar;

fleche:
  FLECHE
{
  *ph << "    structReec = new TSR; \n";
};

expar:
chaine liste_param 
{
  *ph << "    regle->push_back(structReec);\n";
};

chaine:
STRING
{
  //  std::cout << "une chaine:" << (char*)$1 << std::endl;;
  *ph << "    structReec->push_back(" <<  (char*)$1 << ");\n";
};


// pas de liste de param vide ?
liste_param:
 params
| ;

params:
  param
| param params;

param:
VIRG NOM
{
  //  std::cout << "un param:" << (char*)$1 << std::endl;
*ph << "    structReec->push_back(\"" << (char*)$2 << "\");\n";
};


%%

