#include "tr_reader.h"

namespace TR 
{
  // open a trace reader for a file and a node
  void  FileReader::open( char *fn )throw (FailOnOpen)
  {
    int err;
    _trin.open(fn,ios::binary|ios::in );
    if(!_trin.is_open()) throw FailOnOpen();
  };

  //  read and build an event from a file
  Record* FileReader::readEvent() throw (EndOfTrace, BadEvent, UnknownEvent, UnknownEvent2) 
  {
    tr_event_no  ev; 
    tr_level_no  lv; 
    Record* r;
    RecordDesc*  desc;

    if(_trin.eof()) throw EndOfTrace();
    _trin>>&lv;
    if(_trin.eof()) throw EndOfTrace();
    if(_trin.fail()) throw BadEvent();
    _trin>>&ev;
    if(_trin.eof()) throw EndOfTrace();
    if(_trin.fail()) throw BadEvent();
    //std::cout<<"READ level="<<lv<<"event="<<ev<<"\n";
    desc = _rdm->get(ev,lv);
    if (desc==0) throw UnknownEvent2(ev,lv);
    r = desc->build(_trin);
    if(_trin.fail())throw BadEvent();
    return r;
  };

  //  build an event record from a file 
  flushBuffer_rcd * flushBuffer_desc::build(TraceFile & in)
  {
    flushBuffer_rcd * rcd= new flushBuffer_rcd(); 
    rcd->read(in); 
    return rcd;
  };
  
  std::ostream& operator<<(std::ostream& out, flushBuffer_rcd& r)
  {  
    return  r.print(out) ;
  };
  
  void RecordDescMap::dump(std::ostream& out)
  {
    int i;
    out << "DUMP MAP" << (void * ) &_map << "=========================================== \n";
    for( i=0; i!=_keyMax;i++)
      {
	if(_map[i]!=0)
	  //out << "( " << i << ":::"<< (void*)_map[i] <<")\n";
	  if(_map[i])
	    { 
	      (_map[i]->print(out))<<"\n";
	    }
	  else 
	    {
	      out << "( map entry (" << i << "):::undefined\n";
	    }
      }
    out <<"==================================================== \n";
  }  
}


