/* ============================
 * Common defines
 * ============================
 */

/* Define if you have the <sys/time.h> header file.  */
#undef HAVE_SYS_TIME_H

/* Define if you have the <unistd.h> header file.  */
#undef HAVE_UNISTD_H

/* Define if you have the sleep function.  */
#undef HAVE_SLEEP

/* Define if you have the usleep function.  */
#undef HAVE_USLEEP

/* Define if you have the nanosleep function.  */
#undef HAVE_NANOSLEEP


/* ============================
 * Inuktitut defines
 * ============================
 */

/* Define to use InukTracer  */
#undef INUK_USE_TRACER
/* Define to use tracer */
#undef PTH_USE_TRACER

/* Define to use Linux  */
#undef INUKTITUT_USE_LINUX
/* Define to use Sun OS  */
#undef INUKTITUT_USE_SUNOS
/* Define to use Darwin  */
#undef INUKTITUT_USE_DARWIN
/* Define to use Irix  */
#undef INUKTITUT_USE_IRIX

/* ============================
 * Pthread defines
 * ============================
 */

/* Define to use X86 arch  */
#undef PTH_USE_ARCH_X86

/* Define to use Sun arch  */
#undef PTH_USE_ARCH_SUN

/* Define to be architecture independant for unknown processor  */
#undef PTH_USE_ARCH_GENERIC

/* Define to use SMP arch  */
#undef PTH_USE_ARCH_SMP

/* Define to use MONO arch  */
#undef PTH_USE_ARCH_MONO

/* Define if you have the pthread library (-lpthread).  */
#undef HAVE_LIBPTHREAD

/* Define to use LINUX implementation of Pthread */
#undef PTH_USE_PTHREAD_LINUX

/* Define to use SUNOS implementation of Pthread */
#undef PTH_USE_PTHREAD_SUNOS

/* Define to use DARWIN implementation of Pthread */
#undef PTH_USE_PTHREAD_DARWIN

/* Define to use DARWIN implementation of Pthread */
#undef PTH_USE_PTHREAD_IRIX

/* Define to use the scope for the PTHREAD_SCOPE_PROCESS */
#undef PTH_CANUSE_PTHREAD_SCOPE_PROCESS

/* Define to use the scheduling policy for the daemon */
#undef PTH_DAEMON_SCHED

/* Define to use the pthread_attr_setstacksize */
#undef PTH_USE_SET_STACKSIZE

/* Define to use the pthread_attr_getstacksize */
#undef PTH_USE_GET_STACKSIZE

/* Define to use the pthread_attr_setstackaddr */
#undef PTH_USE_SET_STACKADDR

/* Define to use the pthread_attr_getstackaddr */
#undef PTH_USE_GET_STACKADDR

/* Define to use the pthread_mutexattr_settype */
#undef PTH_USE_SET_MUTEXATTR_SETTYPE

/* Define to use the pthread_mutexattr_setkind_np */
#undef PTH_USE_SET_MUTEXATTR_SETKIND_NP


/* Define to use LINUX implementation of Pthread */
#undef SOCK_USE_LINUX

/* Define to use SUNOS implementation of Pthread */
#undef SOCK_USE_SUNOS

/* Define to use DARWIN implementation of Pthread */
#undef SOCK_USE_DARWIN

/* Define to use DARWIN implementation of Pthread */
#undef SOCK_USE_IRIX


/* Define to use taktuk network */
#undef ACOM_USE_TAKTUK

/* Define to use tcp_net network */
#undef ACOM_USE_TCPNET

/* Define to use cor_net network */
#undef ACOM_USE_CORNET

/* Define to use sock_net network */
#undef ACOM_USE_SOCKNET

/* Define to use X86 arch  */
#undef CORNET_USE_ARCH_X86

/* Define to use Sun arch  */
#undef CORNET_USE_ARCH_SUN

/* Define to be architecture independant for unknown processor  */
#undef CORNET_USE_ARCH_GENERIC

/* Define to use SMP arch  */
#undef CORNET_USE_ARCH_SMP

/* Define to use MONO arch  */
#undef CORNET_USE_ARCH_MONO

/* Define to use LINUX implementation of Pthread */
#undef CORNET_USE_PTHREAD_LINUX

/* Define to use SUNOS implementation of Pthread */
#undef CORNET_USE_PTHREAD_SUNOS

/* Define to use DARWIN implementation of Pthread */
#undef CORNET_USE_PTHREAD_DARWIN

/* Define to use DARWIN implementation of Pthread */
#undef CORNET_USE_PTHREAD_IRIX

/* Define to use CORNET debug*/
#undef CORNET_DEBUG

/* Define to use the scheduling policy for the daemon */
#undef CORNET_DAEMON_SCHED


/* @BOTTOM@ */

#ifdef HAVE_NANOSLEEP
#  define PTH_HAVE_NANOSLEEP
#  define SOCK_HAVE_NANOSLEEP
#endif

#ifdef HAVE_USLEEP
#  define PTH_HAVE_MICROSLEEP
#  define SOCK_HAVE_MICROSLEEP
#endif

#ifdef HAVE_SLEEP
#  define PTH_HAVE_SLEEP
#  define SOCK_HAVE_SLEEP
#endif

#ifndef HAVE_ROUND
#  define round(x) ((long) (x))
#endif


/* Macro to reset getopt internal variables */
#ifdef INUKTITUT_USE_IRIX
#define GETOPTRESET() getoptreset()
#elif defined(INUKTITUT_USE_DARWIN)
#define GETOPTRESET() \
do {                  \ 
  optind = 1;         \
  optreset = 1;       \
} while (0)
#elif defined(INUKTITUT_USE_LINUX)
#define GETOPTRESET() \
do {                  \ 
  optind = 0;         \
} while (0)
#endif
