dnl aclocal.m4t generated automatically by aclocal 1.4-p4

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.


dnl ================================================================
dnl PROG_M4
dnl ================================================================
AC_DEFUN([PROG_M4], [
    AC_CACHE_CHECK(for "gnu m4",
    M4, [
    which_m4=`whereis m4 | cut -d" " -f2- `
    for m4 in $which_m4; do
        m4version=`echo no version | ${m4} --version`
        tmp=`echo ${m4version} | grep GNU`
        if test -n "$tmp"; then
            M4=${m4}
            AC_SUBST(M4)
            break
        fi
    done
])
])

dnl ================================================================
dnl PROG_DOT
dnl ================================================================
AC_DEFUN([PROG_DOT], [
    AC_CACHE_CHECK(for dot,
    dot, [
    dot=`which dot 2> /dev/null`
    have_dot=yes
    test x$dot == x && dot=none && have_dot=no
    ])
])


dnl ================================================================
dnl CHECK_ROUND
dnl ================================================================

AC_DEFUN([FUNC_ROUND], [
	AC_CACHE_CHECK(for round,
	have_round,
	AC_TRY_RUN([
#include <math.h>
int main()
{
  int i = round(10.7);
  if (i != 11) return 1;
  return 0;
}],
	AC_DEFINE(HAVE_ROUND, 1, Define if round is available)
    have_round=yes,
    AC_TRY_RUN([
#include <tgmath.h>
int main()
{
  int i = round(10.7);
  if (i != 11) return 1;
  return 0;
}],
	AC_DEFINE(HAVE_ROUND, 1, Define if round is defined)
    have_round=yes,
    have_round=no
	)))
])

dnl ================================================================
dnl CHECK_PTHREAD_SCOPE_PROCESS
dnl ================================================================

AC_DEFUN([CHECK_PTHREAD_SCOPE_PROCESS], [
	AC_CACHE_CHECK(for pthread_scope_process,
	pth_pthread_scope_process,
	AC_TRY_RUN([
#include <pthread.h>
#include <errno.h>
int main()
{
  int err;
  pthread_attr_t attr;
  pthread_attr_setscope( &attr, PTHREAD_SCOPE_PROCESS);
  if (err != 0) { return 1; } else return 0;
}],
	pth_pthread_scope_process=yes
	AC_DEFINE(PTH_CANUSE_PTHREAD_SCOPE_PROCESS),
	pth_pthread_scope_process=no
	))
])

dnl ================================================================
dnl CHECK_PTHREAD_ATTR_SETSTACKADDR
dnl ================================================================

AC_DEFUN([CHECK_PTHREAD_ATTR_SETSTACKADDR], [
	AC_CACHE_CHECK(for pthread_attr_setstackaddr,
	pthread_attr_setstackaddr,
	AC_TRY_RUN([
#include <pthread.h>
#include <errno.h>
int main()
{
  int err;
  pthread_attr_t attr;
  void* addr;
  pthread_attr_setstackaddr( &attr, &addr);
  if (err != 0) { return 1; } else return 0;
}],
	pthread_attr_setstackaddr=yes
  	AC_DEFINE(PTH_USE_SET_STACKADDR),
	pthread_attr_setstackaddr=no
	))
])


dnl ================================================================
dnl CHECK_PTHREAD_ATTR_GETSTACKADDR
dnl ================================================================

AC_DEFUN([CHECK_PTHREAD_ATTR_GETSTACKADDR], [
	AC_CACHE_CHECK(for pthread_attr_getstackaddr,
	pthread_attr_getstackaddr,
	AC_TRY_RUN([
#include <pthread.h>
#include <errno.h>
int main()
{
  int err;
  pthread_attr_t attr;
  void* addr;
  pthread_attr_getstackaddr( &attr, &addr);
  if (err != 0) { return 1; } else return 0;
}],
	pthread_attr_getstackaddr=yes
	AC_DEFINE(PTH_USE_GET_STACKADDR),
  	pthread_attr_getstackaddr=no
	))
])

dnl ================================================================
dnl CHECK_PTHREAD_ATTR_SETSTACKSIZE
dnl ================================================================
AC_DEFUN([CHECK_PTHREAD_ATTR_SETSTACKSIZE], [
	AC_CACHE_CHECK(for pthread_attr_setstacksize,
	pthread_attr_setstacksize,
	AC_TRY_RUN([
#include <pthread.h>
#include <errno.h>
int main()
{
  int err;
  pthread_attr_t attr;
  pthread_attr_setstacksize( &attr, 1024);
  if (err != 0) { return 1; } else return 0;
}],
	pthread_attr_setstacksize=yes
  	AC_DEFINE(PTH_USE_SET_STACKSIZE),
	pthread_attr_setstacksize=no
	))
])



dnl ================================================================
dnl CHECK_PTHREAD_ATTR_GETSTACKSIZE
dnl ================================================================
AC_DEFUN([CHECK_PTHREAD_ATTR_GETSTACKSIZE], [
	AC_CACHE_CHECK(for pthread_attr_getstacksize,
	pthread_attr_getstacksize,
	AC_TRY_RUN([
#include <pthread.h>
#include <errno.h>
int main()
{
  int err;
  pthread_attr_t attr;
  size_t size;
  pthread_attr_getstacksize( &attr, &size);
  if (err != 0) { return 1; } else return 0;
}],
	pthread_attr_getstacksize=yes
  	AC_DEFINE(PTH_USE_GET_STACKSIZE),
  	pthread_attr_getstacksize=no
	))
])


dnl ================================================================
dnl CHECK_CORBA
dnl ================================================================


AC_DEFUN([CHECK_CORBA],
	[
	AC_ARG_WITH(corbadir,
  	[   --with-corbadir=<corba_directory>. Recognized CORBA implantations are: omniORB3, omniORB4],
  	[ if test -d "$withval"; 
    then 
		corbadir="$withval"
    else 
      	AC_MSG_ERROR([--with-corbadir=DIR, invalid directory]) 
    fi
  	])

#	AC_SUBST(CORBA_IDLCC)
	AC_SUBST(CORBA_IDLCCFLAGS)

	AC_CHECKING(for a corba implementation)

	if test x$corbadir == x 
	then
		corbadir="/usr"
	fi

	CORBA_ORBNAME=unknown 


	if test x$CORBA_ORBNAME == xunknown 
	then
		CORBA_CHECK_OBE
	fi

	if test x$CORBA_ORBNAME == xunknown 
	then
		CORBA_CHECK_OB
	fi

	if test x$CORBA_ORBNAME == xunknown 
	then
		CORBA_CHECK_OMNIORB3
	fi

	if test x$CORBA_ORBNAME == xunknown 
	then
		CORBA_CHECK_OMNIORB4
	fi

	
	AC_MSG_RESULT(found corba implementation: $CORBA_ORBNAME)
	])


AC_DEFUN([CORBA_CHECK_OBE], [

	###################################
	# OBE
	###################################
	if test -d "$corbadir/include/OBE"
	then
#		CORBA_ORBNAME="OBE"
		AC_MSG_WARN([recognised ORbacus/OBE, but no configuration for it]);
#	    AC_DEFINE(CORBA_USE_OBE, 1, Defined if ORBACUS/OBE is used)
	fi 
])

AC_DEFUN([CORBA_CHECK_OB], [


	###################################
	# OB
	###################################
	if test -d "$corbadir/include/OB"
	then
#		CORBA_ORBNAME="OB"
		AC_MSG_WARN([recognised ORbacus/OB, but no configuration for it]);
#	    AC_DEFINE(CORBA_USE_OB, 1, Defined if ORBACUS/OB is used)
	fi 
])

AC_DEFUN([CORBA_CHECK_OMNIORB3], [

	###################################
	# OMNIORB3
	###################################

	if test -d "$corbadir/include/omniORB3"
  	then
#		AC_MSG_RESULT(found omniORB3)
		CORBA_ORBNAME="omniorb3"
		if test $corbadir != "/usr"
		then
			compile_COR_net_CPPFLAGS="-I$corbadir/include"
		fi
		CORBA_CPPFLAGS="-I$corbadir/include/omniORB3"
		if test -d "$corbadir/lib/i586_linux_2.0_glibc2.1"
		then
			CORBA_LIBS="-L$corbadir/lib/i586_linux_2.0_glibc2.1 $CORBA_LIBS"
		  	AC_PATH_PROG(CORBA_IDLCC, omniidl,, $corbadir/bin/i586_linux_2.0_glibc2.1)
		fi
		if test -d "$corbadir/lib/powerpc_darwin_6.5"
		then
		  	AC_CHECK_PROG(CORBA_IDLCC, omniidl,, $corbadir/bin/powerpc_darwin_6.5/)
		  	CORBA_LIBS="-L$corbadir/lib/powerpc_darwin_6.5 $CORBA_LIBS"
		fi

		AC_PATH_PROG(CORBA_IDLCC, omniidl, , $corbadir/bin) 
		if test x"$CORBA_IDLCC" == x
		then 
			 AC_MSG_ERROR(Cannot find omniidl in $corbadir/bin)
		fi

		CORBA_LIBS="$CORBA_LIBS -lomniDynamic3 -lomniORB3 -ltcpwrapGK -lomnithread"
		CORBA_IDLCCFLAGS="-bcxx -Wba -Wbh=.h -Wbd=_dyn.cpp -Wbs=.cpp"
		AC_DEFINE(CORBA_USE_OMNIORB, 1, Defined if omniorb is used)
		AC_DEFINE(CORBA_USE_OMNIORB3, 1, Defined if omniorb3 is used)
	fi 
])

AC_DEFUN([CORBA_CHECK_OMNIORB4], [


	###################################
	# OMNIORB4
	###################################

	if test -d "$corbadir/include/omniORB4"
	then
		CORBA_ORBNAME="OMNIORB4"
		if test $corbadir != "/usr"
		then
			CORBA_CPPFLAGS="-I$corbadir/include"
		fi
		CORBA_CPPFLAGS="$CORBA_CPPFLAGS -I$corbadir/include/omniORB4"
		AC_PATH_PROG(CORBA_IDLCC, omniidl, , $corbadir/bin) 
		if test x$CORBA_IDLCC == x
		then
			 AC_MSG_ERROR(Cannot find omniidl in $corbadir/bin)
		fi

		CORBA_LIBS="$CORBA_LIBS -L$corbadir/lib -lomniDynamic4 -lomniORB4 -lomnithread"
		CORBA_IDLCCFLAGS="-bcxx -Wba -Wbh=.h -Wbd=_dyn.cpp -Wbs=.cpp"
		AC_DEFINE(CORBA_USE_OMNIORB, 1, Defined if omniorb is used)
		AC_DEFINE(CORBA_USE_OMNIORB4, 1, Defined if omniorb4 is used)
	fi 

])



# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 1

dnl Usage:
dnl AM_INIT_AUTOMAKE(package,version, [no-define])

AC_DEFUN(AM_INIT_AUTOMAKE,
[AC_REQUIRE([AC_PROG_INSTALL])
PACKAGE=[$1]
AC_SUBST(PACKAGE)
VERSION=[$2]
AC_SUBST(VERSION)
dnl test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" && test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi
ifelse([$3],,
AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package]))
AC_REQUIRE([AM_SANITY_CHECK])
AC_REQUIRE([AC_ARG_PROGRAM])
dnl FIXME This is truly gross.
missing_dir=`cd $ac_aux_dir && pwd`
AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
AM_MISSING_PROG(AUTOMAKE, automake, $missing_dir)
AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
AM_MISSING_PROG(MAKEINFO, makeinfo, $missing_dir)
AC_REQUIRE([AC_PROG_MAKE_SET])])

#
# Check to make sure that the build environment is sane.
#

AC_DEFUN(AM_SANITY_CHECK,
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftestfile
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
   if test "[$]*" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftestfile`
   fi
   if test "[$]*" != "X $srcdir/configure conftestfile" \
      && test "[$]*" != "X conftestfile $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "[$]2" = conftestfile
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
rm -f conftest*
AC_MSG_RESULT(yes)])

dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
dnl The program must properly implement --version.
AC_DEFUN(AM_MISSING_PROG,
[AC_MSG_CHECKING(for working $2)
# Run test in a subshell; some versions of sh will print an error if
# an executable is not found, even if stderr is redirected.
# Redirect stdin to placate older versions of autoconf.  Sigh.
if ($2 --version) < /dev/null > /dev/null 2>&1; then
   $1=$2
   AC_MSG_RESULT(found)
else
   $1="$3/missing $2"
   AC_MSG_RESULT(missing)
fi
AC_SUBST($1)])

# Like AC_CONFIG_HEADER, but automatically create stamp file.

AC_DEFUN(AM_CONFIG_HEADER,
[AC_PREREQ([2.12])
AC_CONFIG_HEADER([$1])
dnl When config.status generates a header, we must update the stamp-h file.
dnl This file resides in the same directory as the config header
dnl that is generated.  We must strip everything past the first ":",
dnl and everything past the last "/".
AC_OUTPUT_COMMANDS(changequote(<<,>>)dnl
ifelse(patsubst(<<$1>>, <<[^ ]>>, <<>>), <<>>,
<<test -z "<<$>>CONFIG_HEADERS" || echo timestamp > patsubst(<<$1>>, <<^\([^:]*/\)?.*>>, <<\1>>)stamp-h<<>>dnl>>,
<<am_indx=1
for am_file in <<$1>>; do
  case " <<$>>CONFIG_HEADERS " in
  *" <<$>>am_file "*<<)>>
    echo timestamp > `echo <<$>>am_file | sed -e 's%:.*%%' -e 's%[^/]*$%%'`stamp-h$am_indx
    ;;
  esac
  am_indx=`expr "<<$>>am_indx" + 1`
done<<>>dnl>>)
changequote([,]))])

# Define a conditional.

AC_DEFUN(AM_CONDITIONAL,
[AC_SUBST($1_TRUE)
AC_SUBST($1_FALSE)
if $2; then
  $1_TRUE=
  $1_FALSE='#'
else
  $1_TRUE='#'
  $1_FALSE=
fi])


dnl AM_PROG_LEX
dnl Look for flex, lex or missing, then run AC_PROG_LEX and AC_DECL_YYTEXT
AC_DEFUN(AM_PROG_LEX,
[missing_dir=ifelse([$1],,`cd $ac_aux_dir && pwd`,$1)
AC_CHECK_PROGS(LEX, flex lex, "$missing_dir/missing flex")
AC_PROG_LEX
AC_DECL_YYTEXT])

