
.PHONY: export_include export_libs export_objs clean_exported_objs clean_exported_inc

install all: export_include export_stub_include export_objs
clean : clean_exported_inc clean_exported_objs


# export objects to lib/objs (actually make symbolic links)

export_objs:
	@test -d $(top_builddir)/lib/objs || mkdir $(top_builddir)/lib/objs
	@-list='$(OBJECTS) $(ADDOBJS)'; for f in $$list ; \
	do \
	  test -f $${f} && { \
           test ! -L $(top_builddir)/lib/objs/$(MODNAME)_$${f} && \
	     ln -s `pwd`/$${f} $(top_builddir)/lib/objs/$(MODNAME)_$${f}; \
           test $${f} -nt $(top_builddir)/lib/makeobjs && \
		touch $(top_builddir)/lib/makeobjs; \
         }; \
	done || :
	@echo

clean_exported_objs:
	rm $(top_builddir)/lib/objs/$(MODNAME)_* 2> /dev/null || :


# export includes with conserved dates
export_include :
	@-list='$(include_HEADERS)';  \
		for f in $$list; \
		do \
			cp -p $(srcdir)/$${f} $(top_builddir)/include; \
		done 

export_stub_include :
	@-list='$(TRACE_STUBS_H)'; \
		for f in $$list; \
		do \
			cp -p ./$${f} $(top_builddir)/include; \
		done


clean_exported_inc:
	@-list='$(include_HEADERS)'; for f in $$list; \
	do \
		rm -f  $(top_builddir)/include/$${f}; \
	done

